import { Boton } from 'boton';
declare type NotificaCampo = 'con-pulsacion' | 'con-pulsacion-retrasada' | 'al-validar';
declare type ManejadorCambioCampo = (p_valor: string | number) => void;
declare type ManejadorValidaCampo = (p_validacion: {
    nuevoValor: string | number;
    valorAnterior: string | number;
    valorHaCambiado: boolean;
}) => void;
declare type ManejadorLovCampo = () => Promise<boolean>;
export declare class DefinicionCampo {
    private _elemento;
    private _valores;
    constructor(_elemento: HTMLElement, _valores: {
        cambio?: ManejadorCambioCampo;
        valida?: ManejadorValidaCampo;
        notifica?: NotificaCampo;
        lov?: ManejadorLovCampo;
    });
    cambio(p_funcion: ManejadorCambioCampo): DefinicionCampo;
    cambio(): ManejadorCambioCampo;
    valida(p_funcion: ManejadorValidaCampo): DefinicionCampo;
    valida(): ManejadorValidaCampo;
    notifica(p_notifica: NotificaCampo): DefinicionCampo;
    notifica(): NotificaCampo;
    lov(p_funcion: ManejadorLovCampo): DefinicionCampo;
    lov(): ManejadorLovCampo;
    crea(): Campo;
    creaAsincrono(): Promise<Campo>;
}
export declare class Campo {
    private _elemento;
    private _valores;
    private _botonLov?;
    private _valorAnterior;
    constructor(_elemento: HTMLInputElement, _valores: {
        cambio?: ManejadorCambioCampo;
        valida?: ManejadorValidaCampo;
        notifica?: NotificaCampo;
        lov?: () => Promise<boolean>;
    }, _botonLov?: Boton);
    valor(p_valor?: string | number): string | number;
    foco(): this;
    deshabilita(): this;
    habilita(): this;
    habilitado(p_valor: boolean): boolean;
    visible(p_valor: boolean): boolean;
}
export declare function campo(p_elemento: HTMLElement | string): DefinicionCampo;
export {};
