﻿define('api',
    [
        'mensaje'
    ],
    function (
        mensaje
    ) {

        function api(p_url) {
            function Api(p_url, p_metodo, p_parametros, p_ok, p_error) {
                var v_url = p_url;
                var v_metodo = p_metodo;
                var v_parametros = p_parametros;
                var v_ok = p_ok;
                var v_error = p_error;

                this.url = function (p_url) {
                    if (arguments.length === 1) {
                        if (typeof p_metodo !== 'string')
                            throw new Error('No es un método no válido');
                        return new Api(p_url, p_metodo, v_parametros, v_ok, v_error);
                    }
                    else
                        return v_url;
                }

                this.metodo = function (p_metodo) {
                    if (arguments.length === 1) {
                        if (typeof p_metodo !== 'string')
                            throw new Error('No es un método no válido');
                        return new Api(v_url, p_metodo, v_parametros, v_ok, v_error);
                    }
                    else
                        return v_metodo;
                };

                this.parametros = function (p_parametros) {
                    if (arguments.length === 1) {
                        if (typeof p_parametros !== 'object')
                            throw new Error('No son parámetros no validos');
                        return new Api(v_url, v_metodo, p_parametros, v_ok, v_error);
                    }
                    else
                        return v_parametros;
                };

                this.ok = function (p_funcion) {
                    if (typeof p_funcion !== 'function') 
                        throw new Error('No es una función');
                    return new Api(v_url, v_metodo, v_parametros, p_funcion, v_error);
                };

                this.error = function (p_funcion) {
                    if (typeof p_funcion !== 'function') 
                        throw new Error('No es una función');
                    return new Api(v_url, v_metodo, v_parametros, v_ok, p_funcion);
                };

                this.invoca = function () {
                    var v_promesa = new Promise(function (p_resuelve, p_rechaza) {
                        apiGeneral(v_url, v_metodo.toUpperCase(), v_parametros, function (p_respuesta) {
                            if (p_respuesta.Ok)
                                p_resuelve([p_respuesta.Objeto, p_respuesta.Mensaje]);
                            else
                                p_rechaza([p_respuesta.Mensaje, p_respuesta.Objeto]);
                        });
                    });
                    if (typeof v_ok === 'function' && typeof v_error === 'function') {
                        v_promesa = v_promesa
                            .then(function ([p_resultado, p_mensaje]) { v_ok(p_resultado, p_mensaje); })
                            .catch(function ([p_mensaje, p_resultado]) { v_error(p_mensaje, p_resultado); });
                    }
                    else
                        return v_promesa;
                };
            }

            var v_errorPredeterminado = async function (p_mensaje, p_resultado) {
                await mensaje().error().muestra(p_mensaje);
            };
            return new Api(p_url, 'GET', {}, void 0, v_errorPredeterminado);
        }

        return api;
    });