﻿// lodash
define('boton',
    [
        'manejador-teclado'
    ],
    function (
        manejadorTeclado
    ) {
        function boton(p_elemento, p_valores) {
            function DefinicionBoton(p_elemento, p_valores) {
                this.clic = function (p_funcion) {
                    return new DefinicionBoton(p_elemento, Object.assign(p_valores, { clic: p_funcion }));
                };

                this.tecla = function (p_tecla) {
                    return new DefinicionBoton(p_elemento, Object.assign(p_valores, { tecla: p_tecla }));
                }

                this.crea = function () {
                    return new Boton(p_elemento, p_valores);
                };
            }

            function Boton(p_elemento, p_valores) {
                this.etiqueta = function (p_valor) {
                    p_elemento.innerText = p_valor;
                    return this;
                }

                this.deshabilita = function () {
                    p_elemento.setAttribute("disabled", "true");
                    return this;
                };

                this.habilita = function () {
                    p_elemento.removeAttribute("disabled");
                    return this;
                };

                this.habilitado = function (p_valor) {
                    if (arguments.length === 0) {
                        return !p_elemento.hasAttribute('disabled');
                    } else {
                        if (p_valor) {
                            this.habilita();
                        }
                        else {
                            this.deshabilita();
                        }
                    }
                };

                this.visible = function (p_valor) {
                    if (arguments.length === 0)
                        return !p_elemento.classList.contains('oculto');
                    else if (p_valor)
                        p_elemento.classList.remove('oculto');
                    else
                        p_elemento.classList.add('oculto');
                };

                var v_clic = p_valores.clic;
                let v_this = this;
                p_elemento.addEventListener('click', function (p_evento) {
                    if (v_this.habilitado()) {
                        v_clic(v_this, p_evento);
                    }
                });

                if (typeof p_valores.tecla === 'string' /*&& typeof p_valores.contenedor !== 'undefined'*/) {
                    manejadorTeclado.captura(p_valores.tecla, p_elemento, function (p_evento) {
                        if (v_this.habilitado() && v_this.visible())
                            v_clic(v_this, p_evento);
                    });
                }
            }

            var v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
            return new DefinicionBoton(v_elemento, Object.assign({}, p_valores, { clic: void 0 }));
        }

        return boton;
    });