﻿// lodash
define('campo',
    [
        'foco',
        'boton',
        'utilidades'
    ],
    function (
        foco,
        boton,
        utilidades
    ) {
        let interpola = utilidades.interpola;

        function campo(p_elemento) {
            function DefinicionCampo(p_elemento, p_valores) {
                this.cambio = function (p_funcion) {
                    if (arguments.length === 1)
                        return new DefinicionCampo(p_elemento, Object.assign(p_valores, { cambio: p_funcion }));
                    else
                        return p_valores.cambio;
                };

                this.valida = function (p_funcion) {
                    if (arguments.length === 1)
                        return new DefinicionCampo(p_elemento, Object.assign(p_valores, { valida: p_funcion }));
                    else
                        return p_valores.cambio;
                }

                this.notifica = function (p_notifica) {
                    if (arguments.length === 1)
                        return new DefinicionCampo(p_elemento, Object.assign(p_valores, { notifica: p_notifica }));
                    else
                        return p_valores.notifica;
                }

                this.lov = function (p_funcion) {
                    if (arguments.length === 1)
                        return new DefinicionCampo(p_elemento, Object.assign(p_valores, { lov: p_funcion }));
                    else
                        return p_valores.lov;
                };

                this.crea = function () {
                    if (p_elemento.tagName !== 'INPUT') {
                        let v_promesa = new Promise(function (p_resuelve, p_rechaza) {
                            if (typeof p_valores.lov === 'function') {
                                require(['text!inputLov.pp.html'], function (plantillaInputLov) {
                                    p_elemento.innerHTML = interpola(plantillaInputLov, p_elemento.id);

                                    let v_elementoCampo = document.getElementById('campo-' + p_elemento.id);

                                    let v_lov = p_valores.lov;
                                    let v_boton = boton('boton-lov-' + p_elemento.id)
                                        .clic(async function () {
                                            let v_aceptado = await v_lov();
                                            if (v_aceptado) {
                                                foco.enSiguienteA(v_elementoCampo);
                                            } else {
                                                foco.en(v_elementoCampo);
                                            }
                                        })
                                        .crea();

                                    p_resuelve(new Campo(v_elementoCampo, p_valores, v_boton));
                                });
                            }
                            else {
                                p_rechaza('no se que hacer');
                            }
                        });
                        return v_promesa;
                    } else {
                        return new Campo(p_elemento, p_valores);
                    }
                };
            }

            function Campo(p_elemento, p_valores, p_botonLov) {
                this.valor = function (p_valor) {
                    if (arguments.length === 1)
                        switch (p_elemento.type) {
                            //case 'checkbox': p_elemento.checked = p_valor; break;
                            default: {
                                v_valorAnterior = p_elemento.value = p_valor;
                                break;
                            }
                        }
                    else switch (p_elemento.type) {
                        case 'number': {
                            if (p_elemento.value.length === 0)
                                return null;
                            return Number(p_elemento.value);
                        } 
                        //case 'checkbox': return p_elemento.checked;
                        default: return p_elemento.value;
                    }
                };

                let v_valorAnterior = this.valor();

                this.foco = function () {
                    foco.en(p_elemento);
                    return this;
                };

                this.deshabilita = function () {
                    p_elemento.setAttribute("disabled", "true");
                    if (typeof p_botonLov !== 'undefined')
                        p_botonLov.deshabilita();
                    return this;
                };

                this.habilita = function () {
                    p_elemento.removeAttribute("disabled");
                    if (typeof p_botonLov !== 'undefined')
                        p_botonLov.habilita();
                    return this;
                };

                this.habilitado = function (p_valor) {
                    if (arguments.length === 0)
                        return !p_elemento.hasAttribute('disabled');
                    else
                        if (p_valor)
                            this.habilita();
                        else
                            this.deshabilita();
                };

                this.visible = function (p_valor) {
                    if (arguments.length === 0)
                        return !p_elemento.classList.contains('oculto');
                    else {
                        let v_elementos = [p_elemento].concat(Array.from(p_elemento.labels));
                        if (p_valor)
                            v_elementos.forEach(p => p.classList.remove('oculto'));
                        else
                            v_elementos.forEach(p => p.classList.add('oculto'));
                    }
                };

                p_elemento.setAttribute('autocomplete', 'off');

                let v_forzarEventoCambio = false;

                if (typeof p_valores.cambio === 'function') {
                    switch (p_valores.notifica) {
                        case 'con-pulsacion':
                            p_elemento.addEventListener('keyup', function (p_evento) {
                                if (p_evento.key !== 'F9') {
                                    v_forzarEventoCambio = false;
                                    p_elemento.blur();
                                    if (typeof p_valores.cambio === 'function')
                                        p_valores.cambio(this.valor());
                                }
                            }.bind(this));
                            break;
                        case 'con-pulsacion-retrasada': {
                            let v_temporizador = null;
                            p_elemento.addEventListener('keyup', function (p_evento) {
                                if (p_evento.key !== 'F9') {
                                    if (v_temporizador !== null) {
                                        clearTimeout(v_temporizador);
                                        v_temporizador = null;
                                    }
                                    v_temporizador = setTimeout(() => {
                                        v_forzarEventoCambio = false;
                                        p_elemento.blur();
                                        if (typeof p_valores.cambio === 'function')
                                            p_valores.cambio(this.valor());
                                    }, 400);
                                }
                            }.bind(this));
                            break;
                        }
                        case 'al-validar':
                        default:
                            p_elemento.addEventListener('change', () => {
                                v_forzarEventoCambio = false;
                                p_elemento.blur();
                                if (typeof p_valores.cambio === 'function')
                                    p_valores.cambio(this.valor());
                            });
                            break;
                    }

                    p_elemento.addEventListener('blur', () => {
                        if (v_forzarEventoCambio) {
                            v_forzarEventoCambio = false;
                            if (typeof p_valores.cambio === 'function')
                                p_valores.cambio(this.valor());
                        }
                    });
                }

                let v_lov = p_valores.lov;
                p_elemento.addEventListener('keydown', async (p_evento) => {
                    //v_forzarEventoCambio = typeof p_valores.cambio === 'function' && p_evento.key === 'Enter';
                    if (p_evento.key === 'Enter') {
                        if (typeof p_valores.valida === 'function') {
                            let v_valor = this.valor();
                            p_valores.valida({
                                nuevoValor: v_valor,
                                valorAnterior: v_valorAnterior,
                                valorHaCambiado: v_valor !== v_valorAnterior
                            });
                            v_valorAnterior = v_valor;
                        }
                    }
                    else if (p_evento.key === 'F9') {
                        p_evento.preventDefault();
                        let v_aceptado = await v_lov();
                        if (v_aceptado)
                            foco.enSiguienteA(p_elemento);
                        else
                            foco.en(p_elemento);
                    }
                });

                p_elemento.addEventListener('focus', () => p_elemento.select());
            }

            let v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);

            return new DefinicionCampo(v_elemento, {
                cambio: void 0,
                lov: void 0
            });
        }

        return campo;
    });