﻿define('casilla-verificacion',
    [
        'foco'
    ],
    function (
        foco
    ) {

        function casillaVerificacion(p_elemento) {

            function DefinicionCasillaVerificacion(p_elemento, p_valores) {
                this.valida = function (p_funcion) {
                    return new DefinicionCasillaVerificacion(p_elemento, Object.assign(p_valores, { valida: p_funcion }));
                };

                this.cambio = function (p_funcion) {
                    return new DefinicionCasillaVerificacion(p_elemento, Object.assign(p_valores, { cambio: p_funcion }));
                };

                this.crea = function () {
                    return new CasillaVerificacion(p_elemento, p_valores);
                };
            }

            function CasillaVerificacion(p_elemento, p_valores) {
                this.valor = function (p_valor) {
                    if (arguments.length === 1)
                        p_elemento.checked = p_valor;
                    else
                        return p_elemento.checked;
                };

                this.foco = function () {
                    foco.en(p_elemento);
                    return this;
                };

                this.deshabilita = function () {
                    p_elemento.setAttribute("disabled", "true");
                    return this;
                };

                this.habilita = function () {
                    p_elemento.removeAttribute("disabled");
                    return this;
                };

                this.habilitado = function (p_valor) {
                    if (arguments.length === 0)
                        return !p_elemento.hasAttribute('disabled');
                    else if (p_valor)
                        this.habilita();
                    else
                        this.deshabilita();
                };

                this.visible = function (p_valor) {
                    if (arguments.length === 0)
                        return !p_elemento.classList.contains('oculto');
                    else {
                        let v_elementos = [p_elemento].concat(Array.from(p_elemento.labels));
                        if (p_valor)
                            v_elementos.forEach(p => p.classList.remove('oculto'));
                        else
                            v_elementos.forEach(p => p.classList.add('oculto'));
                    }
                };

                p_elemento.addEventListener('change', p_valores.cambio);

                p_elemento.addEventListener('focus', function () {
                    this.select();
                });
            }

            var v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);

            return new DefinicionCasillaVerificacion(v_elemento, {
                cambio: void 0
            });
        }

        return casillaVerificacion;
    });