﻿define('componente',
    [
        'label',
        'boton',
        'tabla',
        'campo',
        'casilla-verificacion',
        'desplegable',
        'bloque'
    ],
    function (
        label,
        boton,
        tabla,
        campo,
        casillaVerificacion,
        desplegable,
        bloque
    ) {
        function componente(p_elemento) {
            const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);

            function input(p_elemento) {
                const v_type = p_elemento.type;
                return v_inputs[v_type](p_elemento);
            }

            const v_componentes = {
                LABEL: label,
                INPUT: input,
                BUTTON: boton,
                TABLE: tabla,
                DIV: bloque,
                SELECT: desplegable,
            };

            const v_inputs = {
                text: campo,
                number: campo,
                button: boton,
                checkbox: casillaVerificacion
            };

            const v_componente = v_componentes[v_elemento.tagName];
            if (typeof v_componente === 'function') {
                return v_componente(v_elemento);
            } else {
                throw new Error('No es un elemento/componente conocido: "' + p_elemento.tagName + '"');
            }
        }

        return componente;
    });