﻿define('cortina',
    [
        'boton'
    ],
    function (
        boton
    ) {
        function cortina() {

            var v_siguienteIdOpcion = 0;

            function DefinicionOpcion(p_valores) {
                this.titulo = function (p_titulo) {
                    return new DefinicionOpcion(Object.assign(p_valores, { titulo: p_titulo }));
                };

                this.icono = function (p_icono) {
                    return new DefinicionOpcion(Object.assign(p_valores, { icono: p_icono }));
                };

                this.valor = function (p_valor) {
                    return new DefinicionOpcion(Object.assign(p_valores, { valor: p_valor }));
                };

                this.iconoValor = function (p_iconoValor) {
                    return new DefinicionOpcion(Object.assign(p_valores, { iconoValor: p_iconoValor }));
                };

                this.clic = function (p_funcion) {
                    return new DefinicionOpcion(Object.assign(p_valores, { clic: p_funcion }));
                };

                this.crea = function () {
                    var v_id = 'cortina-opcion-' + v_siguienteIdOpcion++;
                    menuElement(p_valores.titulo, p_valores.icono, '#', p_valores.valor, p_valores.iconoValor, v_id);
                    return new Opcion(v_id, p_valores);
                };
            }

            function DefinicionOpcionFecha(p_valores) {
                this.titulo = function (p_titulo) {
                    return new DefinicionOpcionFecha(Object.assign(p_valores, { titulo: p_titulo }));
                };

                this.icono = function (p_icono) {
                    return new DefinicionOpcionFecha(Object.assign(p_valores, { icono: p_icono }));
                };

                this.valor = function (p_valor) {
                    return new DefinicionOpcionFecha(Object.assign(p_valores, { valor: p_valor }));
                };

                this.cambio = function (p_funcion) {
                    return new DefinicionOpcionFecha(Object.assign(p_valores, { cambio: p_funcion }));
                }

                this.crea = function () {
                    var v_id = 'cortina-opcion-' + v_siguienteIdOpcion++;
                    menuElement(p_valores.titulo, p_valores.icono, '#', p_valores.valor, 'buscador', v_id);
                    menuDatePicker(v_id, p_valores.cambio);
                    return new OpcionFecha(v_id, p_valores);
                };
            }

            //cortina()
            //    .opcion(function (x) { return x.titulo('hola').icono('fecha').valor('un valor'); })
            //    .opcion(function (x) { return x.titulo('adios').icono('almacen').valor('otro valor'); });

            function DefinicionCortina(p_valores) {
                this.opcion = function () {
                    var v_nombre, v_funcion;
                    switch (arguments.length) {
                        case 1:
                            [v_funcion] = arguments;
                            break;
                        case 2:
                            [v_nombre, v_funcion] = arguments;
                            break;
                    }

                    var v_opcion = v_funcion(new DefinicionOpcion({ nombre: v_nombre }));
                    return new DefinicionCortina(Object.assign(p_valores, { opciones: p_valores.opciones.concat(v_opcion) }));
                };

                this.opcionFecha = function () {
                    var v_nombre, v_funcion;
                    switch (arguments.length) {
                        case 1:
                            [v_funcion] = arguments;
                            break;
                        case 2:
                            [v_nombre, v_funcion] = arguments;
                            break;
                    }

                    var v_opcion = v_funcion(new DefinicionOpcionFecha({ nombre: v_nombre }));
                    return new DefinicionCortina(Object.assign(p_valores, { opciones: p_valores.opciones.concat(v_opcion) }));
                }

                this.crea = this.activa = function () {
                    $('#nav-user').find('li:not(:last)').remove();
                    var v_opciones = p_valores.opciones
                        .map(function (p_opcion) { return p_opcion.crea(); })
                        .reduce(function (p_opciones, p_opcion) {
                            var v_nombre = p_opcion.nombre();
                            if (typeof v_nombre === 'string') {
                                p_opciones[v_nombre] = p_opcion;
                            }
                            return p_opciones;
                        }, {})
                        ;
                    return new Cortina(p_valores, v_opciones);
                };
            }

            function Opcion(p_id, p_valores) {
                this.nombre = function () { return p_valores.nombre; };
                this.titulo = function () { return p_valores.titulo; };
                this.icono = function () { return p_valores.icono; };
                this.valor = function (p_valor) {
                    if (arguments.length === 0) {
                        return p_valores.valor;
                    } else {
                        p_valores.valor = p_valor;
                        $('#' + p_id + ' div input').val(p_valor);
                    }
                };
                this.iconoValor = function () { return p_valores.iconoValor; };

                var v_elemento = document.getElementById(p_id);

                var v_boton = boton(v_elemento)
                    .clic(function (p_evento) { p_valores.clic(this, p_evento); })
                    .crea();

                v_boton.habilitado(typeof p_valores.clic === 'function');

                this.habilita = function () {
                    return v_boton.habilita();
                };

                this.deshabilita = function () {
                    return v_boton.deshabilita();
                };

                this.habilitado = function (p_valor) {
                    if (arguments.length === 0) {
                        return v_boton.habilitado();
                    } else {
                        v_boton.habilitado(p_valor);
                    }
                };
            }

            function OpcionFecha(p_id, p_valores) {
                this.nombre = function () { return p_valores.nombre; };
                this.titulo = function () { return p_valores.titulo; };
                this.icono = function () { return p_valores.icono; };
                this.valor = function (p_valor) {
                    if (arguments.length === 0) {
                        return p_valores.valor;
                    } else {
                        p_valores.valor = p_valor;
                        const v_fecha = moment(p_valor, 'DD/MM/YYYY').toDate();
                        updateDatePicker(v_fecha, p_id);
                    }
                };
            }


            function Cortina(p_valores, v_opciones) {
                this.opciones = v_opciones;

                this.abre = function () {
                    openMenu();
                };

                this.cierra = function () {
                    closeMenu();
                };
            }

            return new DefinicionCortina({
                opciones: []
            });
        }

        return cortina;
    });