﻿define('dialogo',
    [
        '--plantilla',
        'modal',
        'utilidades'
    ],
    function (
        __plantilla,
        modal,
        utilidades
    ) {

        let interpola = utilidades.interpola;
        let generaSecuencia = utilidades.generaSecuencia;

        function dialogo() {

            class Envoltura {
                constructor(p_elemento) {
                    this._elemento = p_elemento;
                }

                elemento() {
                    return this._elemento;
                }

                suprime() {
                    this._elemento.remove();
                }
            }

            function DefinicionDialogo(p_valores) {
                this.titulo = function (p_titulo) {
                    return new DefinicionDialogo(Object.assign(p_valores, { titulo: p_titulo }));
                }

                this.cancelable = function (p_cancelable) {
                    return new DefinicionDialogo(Object.assign(p_valores, { cancelable: p_cancelable }));
                }

                //this.plantilla = function (p_plantilla) {
                //    // si no tiene extensión, supongo que es extensión .html
                //    if (p_plantilla.indexOf('.') === -1)
                //        p_plantilla = p_plantilla + '.html';

                //    return new DefinicionDialogo(Object.assign(p_valores, { plantilla: p_plantilla }));
                //}

                this.plantilla = function (p_plantilla) {
                    let v_plantilla;
                    if (typeof p_plantilla === 'string')
                        v_plantilla = { nombre: p_plantilla, secciones: {} };
                    else
                        v_plantilla = p_plantilla;

                    return new DefinicionDialogo(Object.assign(p_valores, { plantilla: p_plantilla }));
                }

                this.elemento = function (p_elemento) {
                    return new DefinicionDialogo(Object.assign(p_valores, { elemento: p_elemento }));
                }

                this.construye = function (p_construye) {
                    return new DefinicionDialogo(Object.assign(p_valores, { construye: p_construye }));
                }

                this.estilos = function (p_estilos) {
                    return new DefinicionDialogo(Object.assign(p_valores, { estilos: p_estilos }));
                }

                this.abre = async function () {
                    let v_insertado;
                    if (typeof p_valores.elemento !== 'undefined') {
                        v_insertado = new Envoltura(p_valores.elemento);
                    }
                    else {
                        //let v_plantillaDialogo = await __plantilla(p_valores.plantilla).carga();

                        //let v_id = 'modal-' + generaSecuencia();
                        //let v_textoPlantillaModal = v_plantillaDialogo.texto();
                        //let v_plantillaModal = __plantilla().crea(v_textoPlantillaModal);
                        //v_insertado = v_plantillaModal.inserta({ prefijoId: v_id });

                        let v_plantillaDialogo = await __plantilla(p_valores.plantilla).carga();
                        //let v_id = 'modal-' + generaSecuencia();
                        //v_insertado = v_plantillaDialogo.inserta({ prefijoId: v_id });
                        v_insertado = v_plantillaDialogo.inserta();
                    }
                    let v_elemento = v_insertado.elemento();
                    let v_resultado;
                    try {
                        v_resultado = await modal(v_elemento)
                            .titulo(p_valores.titulo)
                            .cancelable(p_valores.cancelable)
                            .construye(p_valores.construye)
                            .estilos(p_valores.estilos)
                            .abre();
                    }
                    finally {
                        v_insertado.suprime();
                    }

                    return v_resultado;
                };
            }

            return new DefinicionDialogo({
                titulo: void 0,
                cancelable: true,
                plantilla: void 0,
                construye: p_modal => { }
            });
        }

        return dialogo;
    });