﻿define('foco',
    [
        'utilidades'
    ],
    function (utilidades) {
        let traza = utilidades.traza;

        function foco() {
            let v_timer = null;

            function determinaFocusables(p_contenedor) {
                return p_contenedor.querySelectorAll('*:not([disabled]).focusable');
            }

            return {
                en: function (p_elemento) {
                    if (arguments.length === 0) {
                        return document.activeElement;
                    }
                    else {
                        if (v_timer !== null) {
                            clearTimeout(v_timer);
                        }
                        if (typeof p_elemento === 'undefined')
                            return;

                        v_timer = setTimeout(function () {
                            if (p_elemento.id) {
                                traza(`Foco en #${p_elemento.id}: ${p_elemento.tagName}`);
                            } else {
                                traza(`Foco en ${p_elemento.tagName}`);
                            }
                            if (typeof p_elemento.select === 'function')
                                p_elemento.select();
                            p_elemento.focus();
                        }, 10); 
                    }
                },
                enPrimero: function (p_contenedor) {
                    let v_focoInicial = p_contenedor.querySelectorAll('*:not([disabled]).focusable.foco-inicial')[0];
                    if (typeof v_focoInicial !== 'undefined') {
                        this.en(v_focoInicial);
                        return v_focoInicial;
                    }

                    let v_focusables = determinaFocusables(p_contenedor)
                    let v_primero = v_focusables[0];
                    this.en(v_primero);
                    return v_primero;
                },
                enSiguienteA: function (p_elemento, p_luego) {
                    if (typeof p_elemento === 'undefined') {
                        return this.enPrimero();
                    }

                    let v_elemento = p_elemento instanceof HTMLElement ? p_elemento : p_elemento.get(0);
                    let v_contenedor = v_elemento.closest('.formulario,.modal');

                    if (v_contenedor === null)
                        v_contenedor = document;

                    let v_focusables = determinaFocusables(v_contenedor);
                    if (typeof v_focusables === 'undefined')
                        return;

                    let v_focusable = Array.prototype.filter.call(v_focusables,
                        function (p) {
                            return p.offsetWidth > 0 || p.offsetHeight > 0 || p === v_elemento;
                        });
                    let v_indice = v_focusable.indexOf(v_elemento);
                    if (v_indice > -1) {
                        var v_siguiente = v_focusable[v_indice + 1] || v_focusable[0];
                        this.en(v_siguiente);
                        return v_siguiente;
                    }
                    else {
                        return this.enPrimero(v_contenedor);
                    }
                }
            };
        }

        return foco();
    });