﻿define('lov',
    [
        '--plantilla',
        'tabla',
        'boton',
        'campo',
        'dialogo', 
        'utilidades'
    ],
    function (
        __plantilla,
        tabla,
        boton,
        campo,
        dialogo,
        utilidades
    ) {
        let interpola = utilidades.interpola;
        let generaSecuencia = utilidades.generaSecuencia;

        function lov() {
            function Lov(p_titulo, p_columnas, p_cancelable) {
                var v_titulo = p_titulo;
                var v_columnas = p_columnas;
                var v_cancelable = p_cancelable;

                this.titulo = function (p_titulo) {
                    if (typeof p_titulo !== 'string') {
                        throw new Error('No es un título válido');
                    }
                    return new Lov(p_titulo, v_columnas, v_cancelable);
                };

                this.columnas = function (p_columnas) {
                    if (!Array.isArray(p_columnas)) {
                        throw new Error('No son columnas válidas');
                    }
                    return new Lov(v_titulo, p_columnas, v_cancelable);
                };

                this.cancelable = function (p_valor) {
                    if (arguments.length === 0) {
                        p_valor = true;
                    }
                    if (typeof p_valor !== 'boolean') {
                        throw new Error('No es una opción válida');
                    }
                    return new Lov(v_titulo, v_columnas, p_valor);
                };

                this.elige = async function (p_datos) {
                    let v_resultado = await dialogo()
                        .titulo(v_titulo)
                        .plantilla('lov.pp.html')
                        .construye(function (p_modal) {
                            let v_tabla, v_campoBusqueda, v_botonAceptar;

                            function selecciona(p_fila) {
                                v_botonAceptar.habilitado(p_fila);
                            }

                            v_tabla = p_modal.tabla('tabla')
                                .columnas(v_columnas)
                                .datos(p_datos)
                                .seleccionado(selecciona)
                                .crea();

                            v_campoBusqueda = p_modal.campo('busqueda')
                                .cambio(function () { v_tabla.filtro(v_campoBusqueda.valor()); })
                                .notifica('con-pulsacion-retrasada')
                                .crea();

                            v_botonAceptar = p_modal.boton('aceptar')
                                .clic(function () {
                                    let v_objeto = v_tabla.seleccionado();
                                    p_modal.cierra(v_objeto);
                                })
                                .tecla('Enter')
                                .crea();
                        })
                        .abre();

                    return v_resultado;
                }
            }

            return new Lov('Seleccione', [], true);
        }

        lov.siguienteId = 0;

        return lov;
    });