﻿define('manejador-teclado',
    [],
    function () {

        let v_contextos = [];

        let v_manejador = {
            handleEvent: function (p_evento) {
                // p_evento.type === 'keydown'

                let v_contexto = v_contextos[v_contextos.length - 1];

                let v_opcionesTecla = v_contexto[p_evento.key];
                if (typeof v_opcionesTecla === 'undefined')
                    return;

                if (p_evento.key === 'Enter' && (document.activeElement instanceof HTMLInputElement || document.activeElement instanceof HTMLSelectElement))
                    return;

                v_opcionesTecla.accion();
                p_evento.preventDefault();
            }
        };

        function captura(p_tecla, p_elemento, p_accion) {
            if (v_contextos.length === 0)
                iniciaContexto();

            let v_contenedor = document.createElement('div');
            v_contenedor = p_elemento.parentNode.insertBefore(v_contenedor, p_elemento);
            v_contenedor.appendChild(p_elemento);


            let v_contexto = v_contextos[v_contextos.length - 1];
            v_contexto[p_tecla] = { elemento: v_contenedor, accion: p_accion };

            v_contenedor.classList.add('con-tecla');
            let v_tecla = p_tecla.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase();
            v_contenedor.classList.add(`tecla-${v_tecla}`);
            p_elemento.classList.add('focusable');
        }

        function iniciaContexto() {
            if (v_contextos.length === 0)
                document.addEventListener('keydown', v_manejador);
            v_contextos.push({});
        }

        function finalizaContexto() {
            v_contextos.pop();
            if (v_contextos.length === 0)
                document.removeEventListener('keydown', v_manejador);
        }

        return {
            captura: captura,
            iniciaContexto: iniciaContexto,
            finalizaContexto: finalizaContexto
        }
    });