﻿// @ts-nocheck
define('modal',
    [
        '--plantilla',
        'componente',
        'bloque',
        'label',
        'boton',
        'campo',
        'casilla-verificacion',
        'tabla',
        'foco',
        'manejador-teclado',
        'utilidades'
    ],
    function (
        __plantilla,
        componente,
        bloque,
        label,
        boton,
        campo,
        casillaVerificacion,
        tabla,
        foco,
        manejadorTeclado,
        utilidades
    ) {

        let interpola = utilidades.interpola;
        let generaSecuencia = utilidades.generaSecuencia;

        function modal(p_elemento) {

            function DefinicionModal(p_elemento, p_valores) {

                this.titulo = function (p_titulo) {
                    return new DefinicionModal(p_elemento, Object.assign(p_valores, { titulo: p_titulo }));
                };

                this.estilos = function (p_estilos) {
                    return new DefinicionModal(p_elemento, Object.assign(p_valores, { estilos: p_estilos }));
                }

                this.cancelable = function (p_cancelable) {
                    return new DefinicionModal(p_elemento, Object.assign(p_valores, { cancelable: p_cancelable }));
                };

                this.construye = function (p_construye) {
                    return new DefinicionModal(p_elemento, Object.assign(p_valores, { construye: p_construye }));
                };

                this.abre = async function () {
                    let v_elementoEnFoco = foco.en();

                    document.activeElement.blur();

                    let v_estilos = Object.assign({ titulo: 'info' }, p_valores.estilos);

                    let v_plantillaModal = await __plantilla().nombre('modal.pp.html').carga({ estiloTitulo: v_estilos.titulo });

                    var v_renderizado = v_plantillaModal.renderiza();
                    let v_contenido = v_renderizado.documento().getElementById('cuerpo');
                    v_contenido.appendChild(p_elemento);
                    let v_id = 'modal-' + generaSecuencia();
                    let v_insertado = v_renderizado.inserta({ prefijoId: v_id });
                    let v_promesa = new Promise(function (p_resuelve, p_rechaza) {
                        function combina(a, b) {
                            return function (p_resultado) {
                                a(p_resultado);
                                b(p_resultado);
                            };
                        }

                        let v_resuelve = p_resuelve;
                        if (!v_insertado.elemento().classList.contains('fade')) {
                            v_insertado.elemento().classList.add('fade');
                            v_resuelve = combina(function () { v_insertado.elemento().classList.remove('fade'); }, v_resuelve);
                        }

                        showDialog('#' + v_insertado.elemento().id);

                        $('#' + v_insertado.elemento().id).on('shown.bs.modal', function () {
                            foco.enPrimero(v_elemento);
                        });

                        let v_modal = new Modal(v_insertado, v_resuelve, p_valores.titulo, "", v_elementoEnFoco, p_valores.cancelable);

                        let v_controlador = p_valores.construye(v_modal);
                        if (typeof v_controlador !== 'undefined' && typeof v_controlador.actualizaVista === 'function')
                            v_controlador.actualizaVista();
                    });
                    return v_promesa;
                };
            }

            function Modal(p_insertado, p_resuelve, p_titulo, p_contenido, p_elementoEnFoco, p_cancelable) {
                let v_insertado = p_insertado;
                //let p_elemento = v_insertado.elemento();
                let v_elemento = v_insertado.elemento();
                let v_resuelve = p_resuelve;
                let v_elementoEnFoco = p_elementoEnFoco;
                let v_cancelable = p_cancelable;

                //let v_manejadorEventos;
                manejadorTeclado.iniciaContexto();



                // Componentes
                this.componente = p_elemento => componente(`${v_elemento.id}.${p_elemento}`);
                this.bloque = p_elemento => bloque(`${v_elemento.id}.${p_elemento}`);
                this.etiqueta = this.label = p_elemento => label(`${v_elemento.id}.${p_elemento}`);
                this.boton = p_elemento => boton(`${v_elemento.id}.${p_elemento}`, { contenedor: this });
                this.campo = this.input = p_elemento => campo(`${v_elemento.id}.${p_elemento}`);
                this.casillaVerificacion = this.check = p_elemento => casillaVerificacion(`${v_elemento.id}.${p_elemento}`);
                this.tabla = p_elemento => tabla(`${v_elemento.id}.${p_elemento}`);
                 
                let v_titulo = this.etiqueta('titulo')
                    .texto(v_elemento.dataset.titulo)
                    .crea();

                let v_botonCerrar = this.boton('cerrar')
                    .clic(function () { this.cierra(void 0); }.bind(this))
                    .tecla('Escape')
                    .crea();

                this.cierra = function (p_resultado) {
                    $('#' + v_elemento.id)
                        .on('hidden.bs.modal', function () {
                            v_resuelve(p_resultado);
                            v_insertado.suprime();
                            //v_elemento.innerHTML = p_contenido;
                            foco.enSiguienteA(v_elementoEnFoco);
                            //this.data('bs.modal', null);
                            //if (typeof v_manejadorEventos !== 'undefined') 
                            //    document.removeEventListener('keydown', v_manejadorEventos);
                            manejadorTeclado.finalizaContexto();
                        })
                        .modal('hide');
                };

                this.titulo = function (p_titulo) {
                    v_titulo.texto(p_titulo);
                };

                this.cancelable = function (p_cancelable) {
                    if (arguments.length === 0)
                        return v_botonCerrar.visible();
                    else
                        return v_botonCerrar.visible(p_cancelable);
                };


                this.capturaTecla = function (p_tecla, p_elemento, p_manejador) {
                    manejadorTeclado.captura(p_tecla, p_elemento, p_manejador);

                    //v_manejadorEventos = {
                    //    handleEvent: function (p_evento) {
                    //        // p_evento.type === 'keydown'
                    //        if (p_evento.key === p_tecla) {
                    //            p_manejador();
                    //            p_evento.preventDefault();
                    //        }
                    //    }
                    //};
                    //document.addEventListener('keydown', v_manejadorEventos);

                    //v_elemento.addEventListener('keydown', function (p_evento) {
                    //    console.log(JSON.stringify(p_evento));
                    //    if (p_evento.key === p_tecla)
                    //        p_manejador();
                    //});
                }

                this.id = function () {
                    return v_elemento.id;
                }

                this.titulo(p_titulo);
                this.cancelable(p_cancelable);
            }

            let v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);

            if (v_elemento === null)
                throw new Error('No es un elemento válido');

            return new DefinicionModal(v_elemento, {
                titulo: void 0,
                cancelable: true,
                construye: function (p_modal) { },
                estilos: {}
            });
        }

        return modal;
    });