﻿define('notificacion',
    [
        'modal',
        'label',
        'boton',
        'utilidades'
    ],
    function (
        modal,
        label,
        boton,
        utilidades
    ) {

        let interpola = utilidades.interpola;
        let generaSecuencia = utilidades.generaSecuencia;

        function notificacion(p_texto) {
            if (arguments.length === 0) {
                p_texto = '';
            }

            function Notificacion(p_texto, p_error) {
                let v_texto = p_texto;
                let v_error = p_error;

                this.texto = function (p_texto) {
                    if (typeof p_texto !== 'string') {
                        throw new Error('No es un texto válido');
                    }
                    return new Notificacion(p_texto, v_error);
                };

                this.error = function () {
                    return new Notificacion(v_texto, true);
                };

                this.muestra = function (p_texto) {
                    if (typeof p_texto === 'string') {
                        v_texto = p_texto;
                    }

                    function muestraNotificacion() {
                        let v_promesa = new Promise(function (p_resuelve, p_rechaza) {
                            let v_id = 'notificacion-' + generaSecuencia();

                            require(['text!notificacion.pp.html'], function (plantilla) {
                                //successMessage(p_texto);
                                let v_htmlNotificacion = interpola(plantilla, { id: v_id, mensaje: v_texto, estilo: v_error ? "error" : "info" });
                                //debugger;

                                let v_parser = new DOMParser();
                                let v_documento = v_parser.parseFromString(v_htmlNotificacion, 'text/html');

                                let v_elementoNotificacion = v_documento.getElementById(v_id);
                                p_resuelve(v_elementoNotificacion);
                            });
                        });

                        v_promesa
                            .then(v_elementoNotificacion => {
                                // antes de insertarlo en el DOM me aseguro de que esté oculto
                                v_elementoNotificacion.classList.add('notificacion-oculta');

                                // lo inserto en el DOM
                                document.body.appendChild(v_elementoNotificacion);

                                // retraso esto unos milisegundos ya que de otro modo la transición de entrada no funciona
                                setTimeout(() => {
                                    // lo hago visible
                                    v_elementoNotificacion.classList.remove('notificacion-oculta');
                                    // luego, un tiempo después lo oculto
                                    setTimeout(() => {
                                        v_elementoNotificacion.classList.add('notificacion-oculta');
                                        v_elementoNotificacion.addEventListener('transitionend', () => document.body.removeChild(v_elementoNotificacion), { once: true });
                                    }, Math.max(3000, 40 * v_texto.length));
                                }, 100);
                            });


                        return v_promesa;
                    }
                    return muestraNotificacion.apply(this);
                };
            }

            return new Notificacion(p_texto, false);
        }

        return notificacion;
    });