﻿define('dialogo-consulta-bultos',
    [
        'componentes',
        'dialogo-detalle-bulto'
    ],
    function (
        componentes,
        DialogoDetalleBulto
    ) {

        let
            boton = componentes.boton,
            tabla = componentes.tabla,
            dialogo = componentes.dialogo;

        class DialogoConsultaBultos {
            constructor(p_modal, p_bultos) {
                this.modal = p_modal;

                this.bultos = p_bultos.map(p_bulto => ({
                    N_BULTO: p_bulto.N_BULTO,
                    GVPALLETIP_COD: p_bulto.GVPALLETIP.COD,
                    GVPALLETIP_DESCRIP: p_bulto.GVPALLETIP.DESCRIP,
                    CANTIDAD: p_bulto.articulos.map(p_articulo => p_articulo.CANTIDAD).reduce((p_total, p_cantidad) => p_total + p_cantidad, 0),
                    articulos: p_bulto.articulos
                }));

                this._tabla = p_modal.tabla('bultos')
                    .seleccionado(this.seleccionaBulto.bind(this))
                    .columnas([
                        { propiedad: 'N_BULTO', titulo: 'Nº', ancho: '2em', numerico: true },
                        { propiedad: 'GVPALLETIP_COD', titulo: 'Bulto', ancho: '3em' },
                        { propiedad: 'GVPALLETIP_DESCRIP', titulo: 'Descripcion', ancho: 'auto' },
                        { propiedad: 'CANTIDAD', titulo: 'Cantidad', ancho: '6em', numerico: true, },
                    ])
                    .crea();

                this._botonDetalles = p_modal.boton('detalles')
                    .clic(this.detalles.bind(this))
                    .tecla('Enter')
                    .crea();
            }

            seleccionaBulto(p_bulto) {
                this.seleccionado = p_bulto;
                this.actualizaVista();
            }

            actualizaVista() {
                this._tabla.datos(this.bultos);
                this._botonDetalles.habilitado(typeof this.seleccionado !== 'undefined');
            }

            async detalles() {
                let v_seleccionado = this.seleccionado;

                await dialogo()
                    .titulo('Detalle de bulto')
                    .plantilla('dialogo-detalle-bulto')
                    .construye(p_modal => new DialogoDetalleBulto(p_modal, v_seleccionado))
                    .abre();
            }
        }

        return DialogoConsultaBultos;
    });