﻿// @ts-nocheck
define('dialogo-seleccion-tipo-bulto',
    [
    ],
    function (
    ) {
        class DialogoSeleccionTipoBulto {
            constructor(p_modal, p_tiposBulto, p_cantidad) {
                this.modal = p_modal;

                this.numeroBultos = 1;
                this.cantidadPorBulto = this.cantidad = p_cantidad;

                this.campoNumeroBultos = p_modal.campo('numero-bultos')
                    .cambio(p_valor => {
                        this.actualizaModelo();
                        this.numeroBultos = p_valor;
                        this.cantidadPorBulto = null;
                        this.actualizaVista();
                    })
                    .crea();

                this.campoCantidadPorBulto = p_modal.campo('cantidad-por-bulto')
                    .cambio(p_valor => {
                        this.actualizaModelo();
                        this.cantidadPorBulto = p_valor;
                        this.actualizaVista();
                    })
                    .crea();

                this.campoBusqueda = p_modal.campo('busqueda')
                    .cambio(() => { this.tabla.filtro(this.campoBusqueda.valor()); })
                    //.notifica('con-pulsacion-retrasada')
                    .crea();

                this.tabla = p_modal.tabla('tabla')
                    .columnas([
                        { propiedad: 'COD', titulo: 'Código', ancho: '6em' },
                        { propiedad: 'DESCRIP', titulo: 'Nombre' }
                    ])
                    .datos(p_tiposBulto)
                    .seleccionado(() => this.actualizaVista())
                    .crea();

                this.botonAceptar = p_modal.boton('aceptar')
                    .clic(this.acepta.bind(this))
                    .tecla('Enter')
                    .crea();
            }

            acepta() {
                this.actualizaModelo();
                const v_tipoBulto = this.tabla.seleccionado();
                this.modal.cierra({ numeroBultos: this.numeroBultos, cantidadPorBulto: this.cantidadPorBulto, GVPALLETIP: v_tipoBulto }); 
            }

            actualizaVista() {
                this.campoNumeroBultos.valor(this.numeroBultos);
                this.campoCantidadPorBulto.valor(this.cantidadPorBulto);

                this.botonAceptar.habilitado(this.tabla.seleccionado() && this.numeroBultos && this.cantidadPorBulto &&
                    this.numeroBultos * this.cantidadPorBulto === this.cantidad);
            }

            actualizaModelo() {
                this.numeroBultos = this.campoNumeroBultos.valor();
                this.cantidadPorBulto = this.campoCantidadPorBulto.valor();
            }
        }

        return DialogoSeleccionTipoBulto;
    });