define(["require", "exports", "foco"], function (require, exports, foco_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.desplegable = exports.Desplegable = void 0;
    class DefinicionDesplegable {
        constructor(_elemento, _valores) {
            this._elemento = _elemento;
            this._valores = _valores;
        }
        valores(p_valoresDesplegable) {
            return new DefinicionDesplegable(this._elemento, Object.assign(Object.assign({}, this._valores), { valores: p_valoresDesplegable }));
        }
        cambio(p_funcion) {
            return new DefinicionDesplegable(this._elemento, Object.assign(Object.assign({}, this._valores), { cambio: p_funcion }));
        }
        crea() {
            return new Desplegable(this._elemento, this._valores);
        }
    }
    class Desplegable {
        constructor(_elemento, _valores, _botonLov) {
            this._elemento = _elemento;
            this._valores = _valores;
            this._botonLov = _botonLov;
            this._valoresDesplegable = _valores.valores;
            _elemento.setAttribute('autocomplete', 'off');
            if (typeof _valores.cambio === 'function')
                _elemento.addEventListener('input', () => _valores.cambio(this.valor()));
            if (Array.isArray(this._valoresDesplegable))
                this.actualiza();
        }
        valores(p_valoresDesplegable) {
            this._valoresDesplegable = Array.isArray(p_valoresDesplegable) ? p_valoresDesplegable : [];
            this.actualiza();
        }
        valor(p_valor) {
            if (arguments.length === 1)
                this._elemento.value = p_valor;
            else
                return this._elemento.value;
        }
        ;
        foco() {
            foco_1.foco.en(this._elemento);
            return this;
        }
        ;
        deshabilita() {
            this._elemento.setAttribute("disabled", "true");
            return this;
        }
        ;
        habilita() {
            this._elemento.removeAttribute("disabled");
            return this;
        }
        ;
        habilitado(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.hasAttribute('disabled');
            else if (p_valor)
                this.habilita();
            else
                this.deshabilita();
        }
        ;
        visible(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.classList.contains('oculto');
            else {
                const v_elementos = [this._elemento].concat(Array.from(this._elemento.labels));
                if (p_valor)
                    v_elementos.forEach(p => p.classList.remove('oculto'));
                else
                    v_elementos.forEach(p => p.classList.add('oculto'));
            }
        }
        ;
        actualiza() {
            while (this._elemento.firstChild)
                this._elemento.removeChild(this._elemento.firstChild);
            for (let v_indice = 0; v_indice < this._valoresDesplegable.length; v_indice++) {
                const v_opcion = document.createElement('option');
                v_opcion.text = this._valoresDesplegable[v_indice];
                this._elemento.appendChild(v_opcion);
            }
        }
    }
    exports.Desplegable = Desplegable;
    function desplegable(p_elemento) {
        const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
        return new DefinicionDesplegable(v_elemento, {
            cambio: void 0
        });
    }
    exports.desplegable = desplegable;
});
