define('dialogo-prueba-tablas',
    [
        'componentes'
    ],
    function (
        componentes
    ) {

        let
            tabla = componentes.tabla,
            boton = componentes.boton;

        class DialogoPruebaTablas {
            constructor(p_modal, p_bultos) {
                this.modal = p_modal;

                this.datos = Array.apply(null, { length: 100 }).map(Number.call, Number).map(p_indice =>
                    ({ CAMPO1: `valor${p_indice}`, CAMPO2: p_indice, CAMPO3: p_indice % 2 ? 'S' : 'N' }),
                );

                this.editable = true;

                this._tabla = p_modal.tabla('tabla')
                    .columnas([
                        { propiedad: 'CAMPO1', titulo: 'Campo 1', ancho: 'auto', editable: true, cambio: p_valor => console.log(p_valor) },
                        { propiedad: 'CAMPO2', titulo: 'Campo 2', ancho: 'auto', numerico: true, editable: true },
                        { propiedad: 'CAMPO3', titulo: 'Campo 3', ancho: 'auto' },
                    ])
                    .seleccionado(p_registro => console.log(JSON.stringify(p_registro)))
                    .crea();
                this._botonEditable = p_modal.boton('editable')
                    .clic(this.invierteEditable.bind(this))
                    .crea();
                this._botonAlerta = p_modal.boton('alerta')
                    .clic(() => alert('heeeeey!!'))
                    .tecla('Enter')
                    .crea();
            }

            invierteEditable() {
                this.editable = !this.editable;
                this.actualizaVista();
            }

            actualizaVista() {
                this._tabla.datos(this.datos);
                this._tabla.editable(this.editable);
                this._tabla.refresca();
            }
        }

        return DialogoPruebaTablas;
    });