var _scannerIsRunning = false;
var _scannerFromInput;
var hold = false;
function setHold() {
    hold = !hold;
    if (hold) {
        startScanner();
        hold = false;
    }
}
function cameraFunction() {
    var v_cameraInputs = "input:enabled";
    var timeoutId = 0;

    $("html").on("touchstart mousedown", v_cameraInputs, function (e) {
        timeoutId = setTimeout(setHold, 1500);
        _scannerFromInput = $(this);
    }).on("touchend mouseup", v_cameraInputs, function () {
        clearTimeout(timeoutId);
    });

    $('#cameraDialog .close, #cameraClose').on('click', function (e) {
        Quagga.stop();
        closeModal($('#cameraDialog'));
        e.preventDefault();
    });
}

function startScanner() {
    showDialog('#cameraDialog');
    var v_width = $('#cameraDialog .modal-body').width() - 20;
    closeModal($('#cameraDialog'));
    Quagga.init({
        inputStream: {
            name: "Live",
            type: "LiveStream",
            target: document.querySelector('#cameraContainer'),
            constraints: {
                audio: false,
                width: v_width,
                height: $('#cameraDialog .modal-body').innerHeight() - 70
            }
        },
        decoder: {
            readers: [
                "code_128_reader",
                "ean_reader",
                "ean_8_reader",
                "code_39_reader",
                "code_39_vin_reader",
                "codabar_reader",
                "upc_reader",
                "upc_e_reader",
                "i2of5_reader"
            ],
            debug: {
                showCanvas: true,
                showPatches: true,
                showFoundPatches: true,
                showSkeleton: true,
                showLabels: true,
                showPatchLabels: true,
                showRemainingPatchLabels: true,
                boxFromPatches: {
                    showTransformed: true,
                    showTransformedBox: true,
                    showBB: true
                }
            }
        }

    }, function (err) {
        if (err) {
            return
        }
        Quagga.start();
        showDialog('#cameraDialog');
        // Set flag to is running
        _scannerIsRunning = true;
    });
    Quagga.onProcessed(function (result) {
        var drawingCtx = Quagga.canvas.ctx.overlay,
            drawingCanvas = Quagga.canvas.dom.overlay;

        if (result) {
            if (result.boxes) {
                drawingCtx.clearRect(0, 0, parseInt(drawingCanvas.getAttribute("width")), parseInt(drawingCanvas.getAttribute("height")));
                result.boxes.filter(function (box) {
                    return box !== result.box;
                }).forEach(function (box) {
                    Quagga.ImageDebug.drawPath(box, { x: 0, y: 1 }, drawingCtx, { color: "green", lineWidth: 2 });
                });
            }

            if (result.box) {
                Quagga.ImageDebug.drawPath(result.box, { x: 0, y: 1 }, drawingCtx, { color: "#00F", lineWidth: 2 });
            }

            if (result.codeResult && result.codeResult.code) {
                Quagga.ImageDebug.drawPath(result.line, { x: 'x', y: 'y' }, drawingCtx, { color: 'red', lineWidth: 3 });
            }
        }
    });


    Quagga.onDetected(function (result) {
        _scannerFromInput.val(result.codeResult.code);
        var e = jQuery.Event("keypress");
        e.which = 13;
        _scannerFromInput.trigger(e);
        Quagga.stop();
        closeModal($('#cameraDialog'));
    });
}
!function (t, e) { "object" == typeof exports && "object" == typeof module ? module.exports = e(e.toString()).default : "object" == typeof exports ? exports.Quagga = e(e.toString()).default : t.Quagga = e(e.toString()).default }(this, function (t) { return function (t) { function e(r) { if (n[r]) return n[r].exports; var o = n[r] = { i: r, l: !1, exports: {} }; return t[r].call(o.exports, o, o.exports, e), o.l = !0, o.exports } var n = {}; return e.m = t, e.c = n, e.i = function (t) { return t }, e.d = function (t, n, r) { e.o(t, n) || Object.defineProperty(t, n, { configurable: !1, enumerable: !0, get: r }) }, e.n = function (t) { var n = t && t.__esModule ? function () { return t.default } : function () { return t }; return e.d(n, "a", n), n }, e.o = function (t, e) { return Object.prototype.hasOwnProperty.call(t, e) }, e.p = "/", e(e.s = 165) }([function (t, e) { function n(t) { var e = typeof t; return null != t && ("object" == e || "function" == e) } t.exports = n }, function (t, e) { var n = Array.isArray; t.exports = n }, function (t, e, n) { "use strict"; function r(t, e) { return this._row = [], this.config = t || {}, this.supplements = e, this } r.prototype._nextUnset = function (t, e) { var n; for (void 0 === e && (e = 0), n = e; n < t.length; n++)if (!t[n]) return n; return t.length }, r.prototype._matchPattern = function (t, e, n) { var r, o, i, a, u = 0, c = 0, s = 0, f = 0; for (n = n || this.SINGLE_CODE_ERROR || 1, r = 0; r < t.length; r++)s += t[r], f += e[r]; if (s < f) return Number.MAX_VALUE; for (o = s / f, n *= o, r = 0; r < t.length; r++) { if (i = t[r], a = e[r] * o, (c = Math.abs(i - a) / a) > n) return Number.MAX_VALUE; u += c } return u / f }, r.prototype._nextSet = function (t, e) { var n; for (e = e || 0, n = e; n < t.length; n++)if (t[n]) return n; return t.length }, r.prototype._correctBars = function (t, e, n) { for (var r = n.length, o = 0; r--;)(o = t[n[r]] * (1 - (1 - e) / 2)) > 1 && (t[n[r]] = o) }, r.prototype._matchTrace = function (t, e) { var n, r, o = [], i = this, a = i._nextSet(i._row), u = !i._row[a], c = 0, s = { error: Number.MAX_VALUE, code: -1, start: 0 }; if (t) { for (n = 0; n < t.length; n++)o.push(0); for (n = a; n < i._row.length; n++)if (i._row[n] ^ u) o[c]++; else { if (c === o.length - 1) return r = i._matchPattern(o, t), r < e ? (s.start = n - a, s.end = n, s.counter = o, s) : null; c++, o[c] = 1, u = !u } } else for (o.push(0), n = a; n < i._row.length; n++)i._row[n] ^ u ? o[c]++ : (c++, o.push(0), o[c] = 1, u = !u); return s.start = a, s.end = i._row.length - 1, s.counter = o, s }, r.prototype.decodePattern = function (t) { var e, n = this; return n._row = t, e = n._decode(), null === e ? (n._row.reverse(), (e = n._decode()) && (e.direction = r.DIRECTION.REVERSE, e.start = n._row.length - e.start, e.end = n._row.length - e.end)) : e.direction = r.DIRECTION.FORWARD, e && (e.format = n.FORMAT), e }, r.prototype._matchRange = function (t, e, n) { var r; for (t = t < 0 ? 0 : t, r = t; r < e; r++)if (this._row[r] !== n) return !1; return !0 }, r.prototype._fillCounters = function (t, e, n) { var r, o = this, i = 0, a = []; for (n = void 0 === n || n, t = void 0 !== t ? t : o._nextUnset(o._row), e = e || o._row.length, a[i] = 0, r = t; r < e; r++)o._row[r] ^ n ? a[i]++ : (i++, a[i] = 1, n = !n); return a }, Object.defineProperty(r.prototype, "FORMAT", { value: "unknown", writeable: !1 }), r.DIRECTION = { FORWARD: 1, REVERSE: -1 }, r.Exception = { StartNotFoundException: "Start-Info was not found!", CodeNotFoundException: "Code could not be found!", PatternNotFoundException: "Pattern could not be found!" }, r.CONFIG_KEYS = {}, e.a = r }, function (t, e, n) { "use strict"; function r(t, e) { t = a()(o(), t), u.a.call(this, t, e) } function o() { var t = {}; return Object.keys(r.CONFIG_KEYS).forEach(function (e) { t[e] = r.CONFIG_KEYS[e].default }), t } var i = n(28), a = n.n(i), u = n(2), c = Object.assign || function (t) { for (var e = 1; e < arguments.length; e++) { var n = arguments[e]; for (var r in n) Object.prototype.hasOwnProperty.call(n, r) && (t[r] = n[r]) } return t }, s = { CODE_L_START: { value: 0 }, CODE_G_START: { value: 10 }, START_PATTERN: { value: [1, 1, 1] }, STOP_PATTERN: { value: [1, 1, 1] }, MIDDLE_PATTERN: { value: [1, 1, 1, 1, 1] }, EXTENSION_START_PATTERN: { value: [1, 1, 2] }, CODE_PATTERN: { value: [[3, 2, 1, 1], [2, 2, 2, 1], [2, 1, 2, 2], [1, 4, 1, 1], [1, 1, 3, 2], [1, 2, 3, 1], [1, 1, 1, 4], [1, 3, 1, 2], [1, 2, 1, 3], [3, 1, 1, 2], [1, 1, 2, 3], [1, 2, 2, 2], [2, 2, 1, 2], [1, 1, 4, 1], [2, 3, 1, 1], [1, 3, 2, 1], [4, 1, 1, 1], [2, 1, 3, 1], [3, 1, 2, 1], [2, 1, 1, 3]] }, CODE_FREQUENCY: { value: [0, 11, 13, 14, 19, 25, 28, 21, 22, 26] }, SINGLE_CODE_ERROR: { value: .7 }, AVG_CODE_ERROR: { value: .48 }, FORMAT: { value: "ean_13", writeable: !1 } }; r.prototype = Object.create(u.a.prototype, s), r.prototype.constructor = r, r.prototype._decodeCode = function (t, e) { var n, r, o, i = [0, 0, 0, 0], a = this, u = t, c = !a._row[u], s = 0, f = { error: Number.MAX_VALUE, code: -1, start: t, end: t }; for (e || (e = a.CODE_PATTERN.length), n = u; n < a._row.length; n++)if (a._row[n] ^ c) i[s]++; else { if (s === i.length - 1) { for (r = 0; r < e; r++)(o = a._matchPattern(i, a.CODE_PATTERN[r])) < f.error && (f.code = r, f.error = o); return f.end = n, f.error > a.AVG_CODE_ERROR ? null : f } s++, i[s] = 1, c = !c } return null }, r.prototype._findPattern = function (t, e, n, r, o) { var i, a, u, c, s = [], f = this, l = 0, d = { error: Number.MAX_VALUE, code: -1, start: 0, end: 0 }; for (e || (e = f._nextSet(f._row)), void 0 === n && (n = !1), void 0 === r && (r = !0), void 0 === o && (o = f.AVG_CODE_ERROR), i = 0; i < t.length; i++)s[i] = 0; for (i = e; i < f._row.length; i++)if (f._row[i] ^ n) s[l]++; else { if (l === s.length - 1) { for (c = 0, u = 0; u < s.length; u++)c += s[u]; if ((a = f._matchPattern(s, t)) < o) return d.error = a, d.start = i - c, d.end = i, d; if (!r) return null; for (u = 0; u < s.length - 2; u++)s[u] = s[u + 2]; s[s.length - 2] = 0, s[s.length - 1] = 0, l-- } else l++; s[l] = 1, n = !n } return null }, r.prototype._findStart = function () { for (var t, e, n = this, r = n._nextSet(n._row); !e;) { if (!(e = n._findPattern(n.START_PATTERN, r))) return null; if ((t = e.start - (e.end - e.start)) >= 0 && n._matchRange(t, e.start, 0)) return e; r = e.end, e = null } }, r.prototype._verifyTrailingWhitespace = function (t) { var e, n = this; return e = t.end + (t.end - t.start), e < n._row.length && n._matchRange(t.end, e, 0) ? t : null }, r.prototype._findEnd = function (t, e) { var n = this, r = n._findPattern(n.STOP_PATTERN, t, e, !1); return null !== r ? n._verifyTrailingWhitespace(r) : null }, r.prototype._calculateFirstDigit = function (t) { var e, n = this; for (e = 0; e < n.CODE_FREQUENCY.length; e++)if (t === n.CODE_FREQUENCY[e]) return e; return null }, r.prototype._decodePayload = function (t, e, n) { var r, o, i = this, a = 0; for (r = 0; r < 6; r++) { if (!(t = i._decodeCode(t.end))) return null; t.code >= i.CODE_G_START ? (t.code = t.code - i.CODE_G_START, a |= 1 << 5 - r) : a |= 0 << 5 - r, e.push(t.code), n.push(t) } if (null === (o = i._calculateFirstDigit(a))) return null; if (e.unshift(o), null === (t = i._findPattern(i.MIDDLE_PATTERN, t.end, !0, !1))) return null; for (n.push(t), r = 0; r < 6; r++) { if (!(t = i._decodeCode(t.end, i.CODE_G_START))) return null; n.push(t), e.push(t.code) } return t }, r.prototype._decode = function () { var t, e, n = this, r = [], o = [], i = {}; if (!(t = n._findStart())) return null; if (e = { code: t.code, start: t.start, end: t.end }, o.push(e), !(e = n._decodePayload(e, r, o))) return null; if (!(e = n._findEnd(e.end, !1))) return null; if (o.push(e), !n._checksum(r)) return null; if (this.supplements.length > 0) { var a = this._decodeExtensions(e.end); if (!a) return null; var u = a.decodedCodes[a.decodedCodes.length - 1], s = { start: u.start + ((u.end - u.start) / 2 | 0), end: u.end }; if (!n._verifyTrailingWhitespace(s)) return null; i = { supplement: a, code: r.join("") + a.code } } return c({ code: r.join(""), start: t.start, end: e.end, codeset: "", startInfo: t, decodedCodes: o }, i) }, r.prototype._decodeExtensions = function (t) { var e, n, r = this._nextSet(this._row, t), o = this._findPattern(this.EXTENSION_START_PATTERN, r, !1, !1); if (null === o) return null; for (e = 0; e < this.supplements.length; e++)if (null !== (n = this.supplements[e].decode(this._row, o.end))) return { code: n.code, start: r, startInfo: o, end: n.end, codeset: "", decodedCodes: n.decodedCodes }; return null }, r.prototype._checksum = function (t) { var e, n = 0; for (e = t.length - 2; e >= 0; e -= 2)n += t[e]; for (n *= 3, e = t.length - 1; e >= 0; e -= 2)n += t[e]; return n % 10 == 0 }, r.CONFIG_KEYS = { supplements: { type: "arrayOf(string)", default: [], description: "Allowed extensions to be decoded (2 and/or 5)" } }, e.a = r }, function (t, e, n) { var r = n(38), o = "object" == typeof self && self && self.Object === Object && self, i = r || o || Function("return this")(); t.exports = i }, function (t, e) { function n(t) { return null != t && "object" == typeof t } t.exports = n }, function (t, e) { function n(t) { var e = new Float32Array(2); return e[0] = t[0], e[1] = t[1], e } t.exports = n }, function (t, e, n) { function r(t) { return null == t ? void 0 === t ? c : u : s && s in Object(t) ? i(t) : a(t) } var o = n(11), i = n(118), a = n(145), u = "[object Null]", c = "[object Undefined]", s = o ? o.toStringTag : void 0; t.exports = r }, function (t, e, n) { "use strict"; e.a = { init: function (t, e) { for (var n = t.length; n--;)t[n] = e }, shuffle: function (t) { var e, n, r = t.length - 1; for (r; r >= 0; r--)e = Math.floor(Math.random() * r), n = t[r], t[r] = t[e], t[e] = n; return t }, toPointList: function (t) { var e, n, r = [], o = []; for (e = 0; e < t.length; e++) { for (r = [], n = 0; n < t[e].length; n++)r[n] = t[e][n]; o[e] = "[" + r.join(",") + "]" } return "[" + o.join(",\r\n") + "]" }, threshold: function (t, e, n) { var r, o = []; for (r = 0; r < t.length; r++)n.apply(t, [t[r]]) >= e && o.push(t[r]); return o }, maxIndex: function (t) { var e, n = 0; for (e = 0; e < t.length; e++)t[e] > t[n] && (n = e); return n }, max: function t(e) { var n, t = 0; for (n = 0; n < e.length; n++)e[n] > t && (t = e[n]); return t }, sum: function t(e) { for (var n = e.length, t = 0; n--;)t += e[n]; return t } } }, function (t, e, n) { "use strict"; e.a = { drawRect: function (t, e, n, r) { n.strokeStyle = r.color, n.fillStyle = r.color, n.lineWidth = 1, n.beginPath(), n.strokeRect(t.x, t.y, e.x, e.y) }, drawPath: function (t, e, n, r) { n.strokeStyle = r.color, n.fillStyle = r.color, n.lineWidth = r.lineWidth, n.beginPath(), n.moveTo(t[0][e.x], t[0][e.y]); for (var o = 1; o < t.length; o++)n.lineTo(t[o][e.x], t[o][e.y]); n.closePath(), n.stroke() }, drawImage: function (t, e, n) { var r, o = n.getImageData(0, 0, e.x, e.y), i = o.data, a = t.length, u = i.length; if (u / a != 4) return !1; for (; a--;)r = t[a], i[--u] = 255, i[--u] = r, i[--u] = r, i[--u] = r; return n.putImageData(o, 0, 0), !0 } } }, function (t, e, n) { function r(t) { var e = -1, n = null == t ? 0 : t.length; for (this.clear(); ++e < n;) { var r = t[e]; this.set(r[0], r[1]) } } var o = n(132), i = n(133), a = n(134), u = n(135), c = n(136); r.prototype.clear = o, r.prototype.delete = i, r.prototype.get = a, r.prototype.has = u, r.prototype.set = c, t.exports = r }, function (t, e, n) { var r = n(4), o = r.Symbol; t.exports = o }, function (t, e, n) { function r(t, e) { for (var n = t.length; n--;)if (o(t[n][0], e)) return n; return -1 } var o = n(17); t.exports = r }, function (t, e, n) { function r(t, e) { return o(t) ? t : i(t, e) ? [t] : a(u(t)) } var o = n(1), i = n(129), a = n(153), u = n(164); t.exports = r }, function (t, e, n) { function r(t, e) { var n = t.__data__; return o(e) ? n["string" == typeof e ? "string" : "hash"] : n.map } var o = n(130); t.exports = r }, function (t, e) { function n(t, e) { return !!(e = null == e ? r : e) && ("number" == typeof t || o.test(t)) && t > -1 && t % 1 == 0 && t < e } var r = 9007199254740991, o = /^(?:0|[1-9]\d*)$/; t.exports = n }, function (t, e, n) { var r = n(22), o = r(Object, "create"); t.exports = o }, function (t, e) { function n(t, e) { return t === e || t !== t && e !== e } t.exports = n }, function (t, e, n) { var r = n(95), o = n(5), i = Object.prototype, a = i.hasOwnProperty, u = i.propertyIsEnumerable, c = r(function () { return arguments }()) ? r : function (t) { return o(t) && a.call(t, "callee") && !u.call(t, "callee") }; t.exports = c }, function (t, e, n) { "use strict"; function r(t, e) { return { x: t, y: e, toVec2: function () { return b.clone([this.x, this.y]) }, toVec3: function () { return E.clone([this.x, this.y, 1]) }, round: function () { return this.x = this.x > 0 ? Math.floor(this.x + .5) : Math.floor(this.x - .5), this.y = this.y > 0 ? Math.floor(this.y + .5) : Math.floor(this.y - .5), this } } } function o(t, e, n) { n || (n = t); for (var r = t.data, o = r.length, i = n.data; o--;)i[o] = r[o] < e ? 1 : 0 } function i(t, e) { e || (e = 8); for (var n = t.data, r = n.length, o = 8 - e, i = 1 << e, a = new Int32Array(i); r--;)a[n[r] >> o]++; return a } function a(t, e) { function n(t, e) { var n, r = 0; for (n = t; n <= e; n++)r += a[n]; return r } function r(t, e) { var n, r = 0; for (n = t; n <= e; n++)r += n * a[n]; return r } function o() { var o, u, c, s, f, l, d, h = [0], p = (1 << e) - 1; for (a = i(t, e), s = 1; s < p; s++)o = n(0, s), u = n(s + 1, p), c = o * u, 0 === c && (c = 1), f = r(0, s) * u, l = r(s + 1, p) * o, d = f - l, h[s] = d * d / c; return x.a.maxIndex(h) } e || (e = 8); var a, u = 8 - e; return o() << u } function u(t, e) { var n = a(t); return o(t, n, e), n } function c(t, e, n) { function r(t) { var e = !1; for (i = 0; i < c.length; i++)a = c[i], a.fits(t) && (a.add(t), e = !0); return e } var o, i, a, u, c = []; for (n || (n = "rad"), o = 0; o < t.length; o++)u = m.a.createPoint(t[o], o, n), r(u) || c.push(m.a.create(u, e)); return c } function s(t, e, n) { var r, o, i, a, u = 0, c = 0, s = []; for (r = 0; r < e; r++)s[r] = { score: 0, item: null }; for (r = 0; r < t.length; r++)if ((o = n.apply(this, [t[r]])) > c) for (i = s[u], i.score = o, i.item = t[r], c = Number.MAX_VALUE, a = 0; a < e; a++)s[a].score < c && (c = s[a].score, u = a); return s } function f(t, e, n) { for (var r, o = 0, i = e.x, a = Math.floor(t.length / 4), u = e.x / 2, c = 0, s = e.x; i < a;) { for (r = 0; r < u; r++)n[c] = (.299 * t[4 * o + 0] + .587 * t[4 * o + 1] + .114 * t[4 * o + 2] + (.299 * t[4 * (o + 1) + 0] + .587 * t[4 * (o + 1) + 1] + .114 * t[4 * (o + 1) + 2]) + (.299 * t[4 * i + 0] + .587 * t[4 * i + 1] + .114 * t[4 * i + 2]) + (.299 * t[4 * (i + 1) + 0] + .587 * t[4 * (i + 1) + 1] + .114 * t[4 * (i + 1) + 2])) / 4, c++, o += 2, i += 2; o += s, i += s } } function l(t, e, n) { var r, o = t.length / 4 | 0; if (n && n.singleChannel === !0) for (r = 0; r < o; r++)e[r] = t[4 * r + 0]; else for (r = 0; r < o; r++)e[r] = .299 * t[4 * r + 0] + .587 * t[4 * r + 1] + .114 * t[4 * r + 2] } function d(t, e) { for (var n = t.data, r = t.size.x, o = e.data, i = 0, a = r, u = n.length, c = r / 2, s = 0; a < u;) { for (var f = 0; f < c; f++)o[s] = Math.floor((n[i] + n[i + 1] + n[a] + n[a + 1]) / 4), s++, i += 2, a += 2; i += r, a += r } } function h(t, e) { var n = t[0], r = t[1], o = t[2], i = o * r, a = i * (1 - Math.abs(n / 60 % 2 - 1)), u = o - i, c = 0, s = 0, f = 0; return e = e || [0, 0, 0], n < 60 ? (c = i, s = a) : n < 120 ? (c = a, s = i) : n < 180 ? (s = i, f = a) : n < 240 ? (s = a, f = i) : n < 300 ? (c = a, f = i) : n < 360 && (c = i, f = a), e[0] = 255 * (c + u) | 0, e[1] = 255 * (s + u) | 0, e[2] = 255 * (f + u) | 0, e } function p(t) { var e, n = [], r = []; for (e = 1; e < Math.sqrt(t) + 1; e++)t % e == 0 && (r.push(e), e !== t / e && n.unshift(Math.floor(t / e))); return r.concat(n) } function v(t, e) { for (var n = 0, r = 0, o = []; n < t.length && r < e.length;)t[n] === e[r] ? (o.push(t[n]), n++, r++) : t[n] > e[r] ? r++ : n++; return o } function g(t, e) { function n(t) { for (var e = 0, n = t[Math.floor(t.length / 2)]; e < t.length - 1 && t[e] < d;)e++; return e > 0 && (n = Math.abs(t[e] - d) > Math.abs(t[e - 1] - d) ? t[e - 1] : t[e]), d / n < c[f + 1] / c[f] && d / n > c[f - 1] / c[f] ? { x: n, y: n } : null } var r, o = p(e.x), i = p(e.y), a = Math.max(e.x, e.y), u = v(o, i), c = [8, 10, 15, 20, 32, 60, 80], s = { "x-small": 5, small: 4, medium: 3, large: 2, "x-large": 1 }, f = s[t] || s.medium, l = c[f], d = Math.floor(a / l); return r = n(u), r || (r = n(p(a))) || (r = n(p(d * l))), r } function _(t) { return { value: parseFloat(t), unit: (t.indexOf("%"), t.length, "%") } } function y(t, e, n) { var r = { width: t, height: e }, o = Object.keys(n).reduce(function (t, e) { var o = n[e], i = _(o), a = C[e](i, r); return t[e] = a, t }, {}); return { sx: o.left, sy: o.top, sw: o.right - o.left, sh: o.bottom - o.top } } var m = n(50), x = n(8); e.b = r, e.f = u, e.g = c, e.h = s, e.c = f, e.d = l, e.i = d, e.a = h, e.e = g, e.j = y; var b = { clone: n(6) }, E = { clone: n(82) }, C = { top: function (t, e) { if ("%" === t.unit) return Math.floor(e.height * (t.value / 100)) }, right: function (t, e) { if ("%" === t.unit) return Math.floor(e.width - e.width * (t.value / 100)) }, bottom: function (t, e) { if ("%" === t.unit) return Math.floor(e.height - e.height * (t.value / 100)) }, left: function (t, e) { if ("%" === t.unit) return Math.floor(e.width * (t.value / 100)) } } }, function (t, e, n) { "use strict"; function r(t, e, n, r) { e ? this.data = e : n ? (this.data = new n(t.x * t.y), n === Array && r && a.a.init(this.data, 0)) : (this.data = new Uint8Array(t.x * t.y), Uint8Array === Array && r && a.a.init(this.data, 0)), this.size = t } var o = n(53), i = n(19), a = n(8), u = { clone: n(6) }; r.prototype.inImageWithBorder = function (t, e) { return t.x >= e && t.y >= e && t.x < this.size.x - e && t.y < this.size.y - e }, r.sample = function (t, e, n) { var r = Math.floor(e), o = Math.floor(n), i = t.size.x, a = o * t.size.x + r, u = t.data[a + 0], c = t.data[a + 1], s = t.data[a + i], f = t.data[a + i + 1], l = u - c; return e -= r, n -= o, Math.floor(e * (n * (l - s + f) - l) + n * (s - u) + u) }, r.clearArray = function (t) { for (var e = t.length; e--;)t[e] = 0 }, r.prototype.subImage = function (t, e) { return new o.a(t, e, this) }, r.prototype.subImageAsCopy = function (t, e) { var n, r, o = t.size.y, i = t.size.x; for (n = 0; n < i; n++)for (r = 0; r < o; r++)t.data[r * i + n] = this.data[(e.y + r) * this.size.x + e.x + n] }, r.prototype.copyTo = function (t) { for (var e = this.data.length, n = this.data, r = t.data; e--;)r[e] = n[e] }, r.prototype.get = function (t, e) { return this.data[e * this.size.x + t] }, r.prototype.getSafe = function (t, e) { var n; if (!this.indexMapping) { for (this.indexMapping = { x: [], y: [] }, n = 0; n < this.size.x; n++)this.indexMapping.x[n] = n, this.indexMapping.x[n + this.size.x] = n; for (n = 0; n < this.size.y; n++)this.indexMapping.y[n] = n, this.indexMapping.y[n + this.size.y] = n } return this.data[this.indexMapping.y[e + this.size.y] * this.size.x + this.indexMapping.x[t + this.size.x]] }, r.prototype.set = function (t, e, n) { return this.data[e * this.size.x + t] = n, this }, r.prototype.zeroBorder = function () { var t, e = this.size.x, n = this.size.y, r = this.data; for (t = 0; t < e; t++)r[t] = r[(n - 1) * e + t] = 0; for (t = 1; t < n - 1; t++)r[t * e] = r[t * e + (e - 1)] = 0 }, r.prototype.invert = function () { for (var t = this.data, e = t.length; e--;)t[e] = t[e] ? 0 : 1 }, r.prototype.convolve = function (t) { var e, n, r, o, i = t.length / 2 | 0, a = 0; for (n = 0; n < this.size.y; n++)for (e = 0; e < this.size.x; e++) { for (a = 0, o = -i; o <= i; o++)for (r = -i; r <= i; r++)a += t[o + i][r + i] * this.getSafe(e + r, n + o); this.data[n * this.size.x + e] = a } }, r.prototype.moments = function (t) { var e, n, r, o, i, a, c, s, f, l, d, h, p = this.data, v = this.size.y, g = this.size.x, _ = [], y = [], m = Math.PI, x = m / 4; if (t <= 0) return y; for (i = 0; i < t; i++)_[i] = { m00: 0, m01: 0, m10: 0, m11: 0, m02: 0, m20: 0, theta: 0, rad: 0 }; for (n = 0; n < v; n++)for (o = n * n, e = 0; e < g; e++)(r = p[n * g + e]) > 0 && (a = _[r - 1], a.m00 += 1, a.m01 += n, a.m10 += e, a.m11 += e * n, a.m02 += o, a.m20 += e * e); for (i = 0; i < t; i++)a = _[i], isNaN(a.m00) || 0 === a.m00 || (l = a.m10 / a.m00, d = a.m01 / a.m00, c = a.m11 / a.m00 - l * d, s = a.m02 / a.m00 - d * d, f = a.m20 / a.m00 - l * l, h = (s - f) / (2 * c), h = .5 * Math.atan(h) + (c >= 0 ? x : -x) + m, a.theta = (180 * h / m + 90) % 180 - 90, a.theta < 0 && (a.theta += 180), a.rad = h > m ? h - m : h, a.vec = u.clone([Math.cos(h), Math.sin(h)]), y.push(a)); return y }, r.prototype.show = function (t, e) { var n, r, o, i, a, u, c; for (e || (e = 1), n = t.getContext("2d"), t.width = this.size.x, t.height = this.size.y, r = n.getImageData(0, 0, t.width, t.height), o = r.data, i = 0, c = 0; c < this.size.y; c++)for (u = 0; u < this.size.x; u++)a = c * this.size.x + u, i = this.get(u, c) * e, o[4 * a + 0] = i, o[4 * a + 1] = i, o[4 * a + 2] = i, o[4 * a + 3] = 255; n.putImageData(r, 0, 0) }, r.prototype.overlay = function (t, e, r) { (!e || e < 0 || e > 360) && (e = 360); for (var o = [0, 1, 1], a = [0, 0, 0], u = [255, 255, 255], c = [0, 0, 0], s = [], f = t.getContext("2d"), l = f.getImageData(r.x, r.y, this.size.x, this.size.y), d = l.data, h = this.data.length; h--;)o[0] = this.data[h] * e, s = o[0] <= 0 ? u : o[0] >= 360 ? c : n.i(i.a)(o, a), d[4 * h + 0] = s[0], d[4 * h + 1] = s[1], d[4 * h + 2] = s[2], d[4 * h + 3] = 255; f.putImageData(l, r.x, r.y) }, e.a = r }, function (t, e, n) { function r(t, e, n) { "__proto__" == e && o ? o(t, e, { configurable: !0, enumerable: !0, value: n, writable: !0 }) : t[e] = n } var o = n(37); t.exports = r }, function (t, e, n) { function r(t, e) { var n = i(t, e); return o(n) ? n : void 0 } var o = n(96), i = n(119); t.exports = r }, function (t, e, n) { function r(t) { if ("string" == typeof t || o(t)) return t; var e = t + ""; return "0" == e && 1 / t == -i ? "-0" : e } var o = n(27), i = 1 / 0; t.exports = r }, function (t, e, n) { function r(t) { return null != t && i(t.length) && !o(t) } var o = n(25), i = n(26); t.exports = r }, function (t, e, n) { function r(t) { if (!i(t)) return !1; var e = o(t); return e == u || e == c || e == a || e == s } var o = n(7), i = n(0), a = "[object AsyncFunction]", u = "[object Function]", c = "[object GeneratorFunction]", s = "[object Proxy]"; t.exports = r }, function (t, e) { function n(t) { return "number" == typeof t && t > -1 && t % 1 == 0 && t <= r } var r = 9007199254740991; t.exports = n }, function (t, e, n) { function r(t) { return "symbol" == typeof t || i(t) && o(t) == a } var o = n(7), i = n(5), a = "[object Symbol]"; t.exports = r }, function (t, e, n) { var r = n(99), o = n(115), i = o(function (t, e, n) { r(t, e, n) }); t.exports = i }, function (t, e) { t.exports = function (t) { return t.webpackPolyfill || (t.deprecate = function () { }, t.paths = [], t.children || (t.children = []), Object.defineProperty(t, "loaded", { enumerable: !0, get: function () { return t.l } }), Object.defineProperty(t, "id", { enumerable: !0, get: function () { return t.i } }), t.webpackPolyfill = 1), t } }, function (t, e, n) { "use strict"; var r = { searchDirections: [[0, 1], [1, 1], [1, 0], [1, -1], [0, -1], [-1, -1], [-1, 0], [-1, 1]], create: function (t, e) { function n(t, e, n, r) { var o, f, l; for (o = 0; o < 7; o++) { if (f = t.cy + c[t.dir][0], l = t.cx + c[t.dir][1], i = f * s + l, a[i] === e && (0 === u[i] || u[i] === n)) return u[i] = n, t.cy = f, t.cx = l, !0; 0 === u[i] && (u[i] = r), t.dir = (t.dir + 1) % 8 } return !1 } function r(t, e, n) { return { dir: n, x: t, y: e, next: null, prev: null } } function o(t, e, o, i, a) { var u, c, s, f = null, l = { cx: e, cy: t, dir: 0 }; if (n(l, i, o, a)) { f = r(e, t, l.dir), u = f, s = l.dir, c = r(l.cx, l.cy, 0), c.prev = u, u.next = c, c.next = null, u = c; do l.dir = (l.dir + 6) % 8, n(l, i, o, a), s !== l.dir ? (u.dir = l.dir, c = r(l.cx, l.cy, 0), c.prev = u, u.next = c, c.next = null, u = c) : (u.dir = s, u.x = l.cx, u.y = l.cy), s = l.dir; while (l.cx !== e || l.cy !== t); f.prev = u.prev, u.prev.next = f } return f } var i, a = t.data, u = e.data, c = this.searchDirections, s = t.size.x; return { trace: function (t, e, r, o) { return n(t, e, r, o) }, contourTracing: function (t, e, n, r, i) { return o(t, e, n, r, i) } } } }; e.a = r }, function (t, e, n) { "use strict"; function r() { o.a.call(this) } var o = n(2), i = n(8), a = { ALPHABETH_STRING: { value: "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%" }, ALPHABET: { value: [48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 45, 46, 32, 42, 36, 47, 43, 37] }, CHARACTER_ENCODINGS: { value: [52, 289, 97, 352, 49, 304, 112, 37, 292, 100, 265, 73, 328, 25, 280, 88, 13, 268, 76, 28, 259, 67, 322, 19, 274, 82, 7, 262, 70, 22, 385, 193, 448, 145, 400, 208, 133, 388, 196, 148, 168, 162, 138, 42] }, ASTERISK: { value: 148 }, FORMAT: { value: "code_39", writeable: !1 } }; r.prototype = Object.create(o.a.prototype, a), r.prototype.constructor = r, r.prototype._toCounters = function (t, e) { var n, r = this, o = e.length, a = r._row.length, u = !r._row[t], c = 0; for (i.a.init(e, 0), n = t; n < a; n++)if (r._row[n] ^ u) e[c]++; else { if (++c === o) break; e[c] = 1, u = !u } return e }, r.prototype._decode = function () { var t, e, n, r, o = this, a = [0, 0, 0, 0, 0, 0, 0, 0, 0], u = [], c = o._findStart(); if (!c) return null; r = o._nextSet(o._row, c.end); do { if (a = o._toCounters(r, a), (n = o._toPattern(a)) < 0) return null; if ((t = o._patternToChar(n)) < 0) return null; u.push(t), e = r, r += i.a.sum(a), r = o._nextSet(o._row, r) } while ("*" !== t); return u.pop(), u.length && o._verifyTrailingWhitespace(e, r, a) ? { code: u.join(""), start: c.start, end: r, startInfo: c, decodedCodes: u } : null }, r.prototype._verifyTrailingWhitespace = function (t, e, n) { var r = i.a.sum(n); return 3 * (e - t - r) >= r }, r.prototype._patternToChar = function (t) { var e, n = this; for (e = 0; e < n.CHARACTER_ENCODINGS.length; e++)if (n.CHARACTER_ENCODINGS[e] === t) return String.fromCharCode(n.ALPHABET[e]); return -1 }, r.prototype._findNextWidth = function (t, e) { var n, r = Number.MAX_VALUE; for (n = 0; n < t.length; n++)t[n] < r && t[n] > e && (r = t[n]); return r }, r.prototype._toPattern = function (t) { for (var e, n, r = t.length, o = 0, i = r, a = 0, u = this; i > 3;) { for (o = u._findNextWidth(t, o), i = 0, e = 0, n = 0; n < r; n++)t[n] > o && (e |= 1 << r - 1 - n, i++, a += t[n]); if (3 === i) { for (n = 0; n < r && i > 0; n++)if (t[n] > o && (i--, 2 * t[n] >= a)) return -1; return e } } return -1 }, r.prototype._findStart = function () { var t, e, n, r = this, o = r._nextSet(r._row), i = o, a = [0, 0, 0, 0, 0, 0, 0, 0, 0], u = 0, c = !1; for (t = o; t < r._row.length; t++)if (r._row[t] ^ c) a[u]++; else { if (u === a.length - 1) { if (r._toPattern(a) === r.ASTERISK && (n = Math.floor(Math.max(0, i - (t - i) / 4)), r._matchRange(n, i, 0))) return { start: i, end: t }; for (i += a[0] + a[1], e = 0; e < 7; e++)a[e] = a[e + 2]; a[7] = 0, a[8] = 0, u-- } else u++; a[u] = 1, c = !c } return null }, e.a = r }, function (t, e) { function n(t, e) { return t[0] * e[0] + t[1] * e[1] } t.exports = n }, function (t, e, n) { var r = n(22), o = n(4), i = r(o, "Map"); t.exports = i }, function (t, e, n) { function r(t) { var e = -1, n = null == t ? 0 : t.length; for (this.clear(); ++e < n;) { var r = t[e]; this.set(r[0], r[1]) } } var o = n(137), i = n(138), a = n(139), u = n(140), c = n(141); r.prototype.clear = o, r.prototype.delete = i, r.prototype.get = a, r.prototype.has = u, r.prototype.set = c, t.exports = r }, function (t, e, n) { function r(t, e, n) { (void 0 === n || i(t[e], n)) && (void 0 !== n || e in t) || o(t, e, n) } var o = n(21), i = n(17); t.exports = r }, function (t, e, n) { function r(t, e, n) { var r = t[e]; u.call(t, e) && i(r, n) && (void 0 !== n || e in t) || o(t, e, n) } var o = n(21), i = n(17), a = Object.prototype, u = a.hasOwnProperty; t.exports = r }, function (t, e, n) { var r = n(22), o = function () { try { var t = r(Object, "defineProperty"); return t({}, "", {}), t } catch (t) { } }(); t.exports = o }, function (t, e, n) { (function (e) { var n = "object" == typeof e && e && e.Object === Object && e; t.exports = n }).call(e, n(47)) }, function (t, e, n) { var r = n(146), o = r(Object.getPrototypeOf, Object); t.exports = o }, function (t, e) { function n(t) { var e = t && t.constructor; return t === ("function" == typeof e && e.prototype || r) } var r = Object.prototype; t.exports = n }, function (t, e, n) { function r(t, e, n) { return e = i(void 0 === e ? t.length - 1 : e, 0), function () { for (var r = arguments, a = -1, u = i(r.length - e, 0), c = Array(u); ++a < u;)c[a] = r[e + a]; a = -1; for (var s = Array(e + 1); ++a < e;)s[a] = r[a]; return s[e] = n(c), o(t, this, s) } } var o = n(86), i = Math.max; t.exports = r }, function (t, e, n) { var r = n(105), o = n(147), i = o(r); t.exports = i }, function (t, e) { function n(t) { return t } t.exports = n }, function (t, e, n) { (function (t) { var r = n(4), o = n(162), i = "object" == typeof e && e && !e.nodeType && e, a = i && "object" == typeof t && t && !t.nodeType && t, u = a && a.exports === i, c = u ? r.Buffer : void 0, s = c ? c.isBuffer : void 0, f = s || o; t.exports = f }).call(e, n(29)(t)) }, function (t, e, n) { var r = n(97), o = n(108), i = n(144), a = i && i.isTypedArray, u = a ? o(a) : r; t.exports = u }, function (t, e, n) { function r(t) { return a(t) ? o(t, !0) : i(t) } var o = n(87), i = n(98), a = n(24); t.exports = r }, function (t, e) { var n; n = function () { return this }(); try { n = n || Function("return this")() || (0, eval)("this") } catch (t) { "object" == typeof window && (n = window) } t.exports = n }, function (e, n, r) { "use strict"; function o(t) { f(t), P = L.a.create($.decoder, D) } function i(t) { var e; if ("VideoStream" === $.inputStream.type) e = document.createElement("video"), w = V.a.createVideoStream(e); else if ("ImageStream" === $.inputStream.type) w = V.a.createImageStream(); else if ("LiveStream" === $.inputStream.type) { var n = a(); n && ((e = n.querySelector("video")) || (e = document.createElement("video"), n.appendChild(e))), w = V.a.createLiveStream(e), F.a.request(e, $.inputStream.constraints).then(function () { w.trigger("canrecord") }).catch(function (e) { return t(e) }) } w.setAttribute("preload", "auto"), w.setInputStream($.inputStream), w.addEventListener("canrecord", u.bind(void 0, t)) } function a() { var t = $.inputStream.target; if (t && t.nodeName && 1 === t.nodeType) return t; var e = "string" == typeof t ? t : "#interactive.viewport"; return document.querySelector(e) } function u(t) { U.a.checkImageConstraints(w, $.locator), s($), A = H.a.create(w, Y.dom.image), R($.numOfWorkers, function () { 0 === $.numOfWorkers && o(), c(t) }) } function c(t) { w.play(), t() } function s() { if ("undefined" != typeof document) { var t = a(); if (Y.dom.image = document.querySelector("canvas.imgBuffer"), Y.dom.image || (Y.dom.image = document.createElement("canvas"), Y.dom.image.className = "imgBuffer", t && "ImageStream" === $.inputStream.type && t.appendChild(Y.dom.image)), Y.ctx.image = Y.dom.image.getContext("2d"), Y.dom.image.width = w.getCanvasSize().x, Y.dom.image.height = w.getCanvasSize().y, Y.dom.overlay = document.querySelector("canvas.drawingBuffer"), !Y.dom.overlay) { Y.dom.overlay = document.createElement("canvas"), Y.dom.overlay.className = "drawingBuffer", t && t.appendChild(Y.dom.overlay); var e = document.createElement("br"); e.setAttribute("clear", "all"), t && t.appendChild(e) } Y.ctx.overlay = Y.dom.overlay.getContext("2d"), Y.dom.overlay.width = w.getCanvasSize().x, Y.dom.overlay.height = w.getCanvasSize().y } } function f(t) { D = t ? t : new j.a({ x: w.getWidth(), y: w.getHeight() }), S = [q.clone([0, 0]), q.clone([0, D.size.y]), q.clone([D.size.x, D.size.y]), q.clone([D.size.x, 0])], U.a.init(D, $.locator) } function l() { return $.locate ? U.a.locate() : [[q.clone(S[0]), q.clone(S[1]), q.clone(S[2]), q.clone(S[3])]] } function d(t) { function e(t) { for (var e = t.length; e--;)t[e][0] += i, t[e][1] += a } function n(t) { t[0].x += i, t[0].y += a, t[1].x += i, t[1].y += a } var r, o = w.getTopRight(), i = o.x, a = o.y; if (0 !== i || 0 !== a) { if (t.barcodes) for (r = 0; r < t.barcodes.length; r++)d(t.barcodes[r]); if (t.line && 2 === t.line.length && n(t.line), t.box && e(t.box), t.boxes && t.boxes.length > 0) for (r = 0; r < t.boxes.length; r++)e(t.boxes[r]) } } function h(t, e) { e && I && (t.barcodes ? t.barcodes.filter(function (t) { return t.codeResult }).forEach(function (t) { return h(t, e) }) : t.codeResult && I.addResult(e, w.getCanvasSize(), t.codeResult)) } function p(t) { return t && (t.barcodes ? t.barcodes.some(function (t) { return t.codeResult }) : t.codeResult) } function v(t, e) { var n = t; t && K && (d(t), h(t, e), n = t.barcodes || t), k.a.publish("processed", n), p(t) && k.a.publish("detected", n) } function g() { var t, e; e = l(), e ? (t = P.decodeFromBoundingBoxes(e), t = t || {}, t.boxes = e, v(t, D.data)) : v() } function _() { var t; if (K) { if (Q.length > 0) { if (!(t = Q.filter(function (t) { return !t.busy })[0])) return; A.attachData(t.imageData) } else A.attachData(D.data); A.grab() && (t ? (t.busy = !0, t.worker.postMessage({ cmd: "process", imageData: t.imageData }, [t.imageData.buffer])) : g()) } else g() } function y() { var t = null, e = 1e3 / ($.frequency || 60); T = !1, function n(r) { t = t || r, T || (r >= t && (t += e, _()), window.requestAnimFrame(n)) }(performance.now()) } function m() { K && "LiveStream" === $.inputStream.type ? y() : _() } function x(t) { var e, n = { worker: void 0, imageData: new Uint8Array(w.getWidth() * w.getHeight()), busy: !0 }; e = C(), n.worker = new Worker(e), n.worker.onmessage = function (r) { if ("initialized" === r.data.event) return URL.revokeObjectURL(e), n.busy = !1, n.imageData = new Uint8Array(r.data.imageData), t(n); "processed" === r.data.event ? (n.imageData = new Uint8Array(r.data.imageData), n.busy = !1, v(r.data.result, n.imageData)) : r.data.event }, n.worker.postMessage({ cmd: "init", size: { x: w.getWidth(), y: w.getHeight() }, imageData: n.imageData, config: b($) }, [n.imageData.buffer]) } function b(t) { return X({}, t, { inputStream: X({}, t.inputStream, { target: null }) }) } function E(t) { function e(t) { self.postMessage({ event: "processed", imageData: o.data, result: t }, [o.data.buffer]) } function n() { self.postMessage({ event: "initialized", imageData: o.data }, [o.data.buffer]) } if (t) { var r = t().default; if (!r) return void self.postMessage({ event: "error", message: "Quagga could not be created" }) } var o; self.onmessage = function (t) { if ("init" === t.data.cmd) { var i = t.data.config; i.numOfWorkers = 0, o = new r.ImageWrapper({ x: t.data.size.x, y: t.data.size.y }, new Uint8Array(t.data.imageData)), r.init(i, n, o), r.onProcessed(e) } else "process" === t.data.cmd ? (o.data = new Uint8Array(t.data.imageData), r.start()) : "setReaders" === t.data.cmd && r.setReaders(t.data.readers) } } function C() { var e, n; return void 0 !== t && (n = t), e = new Blob(["(" + E.toString() + ")(" + n + ");"], { type: "text/javascript" }), window.URL.createObjectURL(e) } function O(t) { P ? P.setReaders(t) : K && Q.length > 0 && Q.forEach(function (e) { e.worker.postMessage({ cmd: "setReaders", readers: t }) }) } function R(t, e) { var n = t - Q.length; if (0 === n) return e && e(); if (n < 0) { return Q.slice(n).forEach(function (t) { t.worker.terminate() }), Q = Q.slice(0, n), e && e() } for (var r = function (n) { Q.push(n), Q.length >= t && e && e() }, o = 0; o < n; o++)x(r) } Object.defineProperty(n, "__esModule", { value: !0 }); var w, A, T, D, S, P, I, M = r(28), z = r.n(M), N = r(54), j = (r.n(N), r(20)), U = r(64), L = r(57), k = r(51), F = r(59), W = r(9), B = r(49), G = r(55), V = r(63), H = r(61), X = Object.assign || function (t) { for (var e = 1; e < arguments.length; e++) { var n = arguments[e]; for (var r in n) Object.prototype.hasOwnProperty.call(n, r) && (t[r] = n[r]) } return t }, q = { clone: r(6) }, Y = { ctx: { image: null, overlay: null }, dom: { image: null, overlay: null } }, Q = [], K = !0, $ = {}; n.default = { init: function (t, e, n) { if ($ = z()({}, G.a, t), n) return K = !1, o(n), e(); i(e) }, start: function () { m() }, stop: function () { T = !0, R(0), "LiveStream" === $.inputStream.type && (F.a.release(), w.clearEventHandlers()) }, pause: function () { T = !0 }, onDetected: function (t) { k.a.subscribe("detected", t) }, offDetected: function (t) { k.a.unsubscribe("detected", t) }, onProcessed: function (t) { k.a.subscribe("processed", t) }, offProcessed: function (t) { k.a.unsubscribe("processed", t) }, setReaders: function (t) { O(t) }, registerResultCollector: function (t) { t && "function" == typeof t.addResult && (I = t) }, canvas: Y, decodeSingle: function (t, e) { var n = this; t = z()({ inputStream: { type: "ImageStream", sequence: !1, size: 800, src: t.src }, numOfWorkers: 1, locator: { halfSample: !1 } }, t), this.init(t, function () { k.a.once("processed", function (t) { n.stop(), e.call(null, t) }, !0), m() }) }, ImageWrapper: j.a, ImageDebug: W.a, ResultCollector: B.a, CameraAccess: F.a } }, function (t, e, n) { "use strict"; function r(t, e) { return !!e && e.some(function (e) { return Object.keys(e).every(function (n) { return e[n] === t[n] }) }) } function o(t, e) { return "function" != typeof e || e(t) } var i = n(9); e.a = { create: function (t) { function e(e) { return c && e && !r(e, t.blacklist) && o(e, t.filter) } var n = document.createElement("canvas"), a = n.getContext("2d"), u = [], c = t.capacity || 20, s = t.capture === !0; return { addResult: function (t, r, o) { var f = {}; e(o) && (c--, f.codeResult = o, s && (n.width = r.x, n.height = r.y, i.a.drawImage(t, r, a), f.frame = n.toDataURL()), u.push(f)) }, getResults: function () { return u } } } } }, function (t, e, n) { "use strict"; var r = { clone: n(6), dot: n(32) }; e.a = { create: function (t, e) { function n() { o(t), i() } function o(t) { c[t.id] = t, a.push(t) } function i() { var t, e = 0; for (t = 0; t < a.length; t++)e += a[t].rad; u.rad = e / a.length, u.vec = r.clone([Math.cos(u.rad), Math.sin(u.rad)]) } var a = [], u = { rad: 0, vec: r.clone([0, 0]) }, c = {}; return n(), { add: function (t) { c[t.id] || (o(t), i()) }, fits: function (t) { return Math.abs(r.dot(t.point.vec, u.vec)) > e }, getPoints: function () { return a }, getCenter: function () { return u } } }, createPoint: function (t, e, n) { return { rad: t[n], point: t, id: e } } } }, function (t, e, n) { "use strict"; e.a = function () { function t(t) { return o[t] || (o[t] = { subscribers: [] }), o[t] } function e() { o = {} } function n(t, e) { t.async ? setTimeout(function () { t.callback(e) }, 4) : t.callback(e) } function r(e, n, r) { var o; if ("function" == typeof n) o = { callback: n, async: r }; else if (o = n, !o.callback) throw "Callback was not specified on options"; t(e).subscribers.push(o) } var o = {}; return { subscribe: function (t, e, n) { return r(t, e, n) }, publish: function (e, r) { var o = t(e), i = o.subscribers; i.filter(function (t) { return !!t.once }).forEach(function (t) { n(t, r) }), o.subscribers = i.filter(function (t) { return !t.once }), o.subscribers.forEach(function (t) { n(t, r) }) }, once: function (t, e, n) { r(t, { callback: e, async: n, once: !0 }) }, unsubscribe: function (n, r) { var o; n ? (o = t(n), o.subscribers = o && r ? o.subscribers.filter(function (t) { return t.callback !== r }) : []) : e() } } }() }, function (t, e, n) { "use strict"; function r() { return navigator.mediaDevices && "function" == typeof navigator.mediaDevices.enumerateDevices ? navigator.mediaDevices.enumerateDevices() : Promise.reject(new Error("enumerateDevices is not defined")) } function o(t) { return navigator.mediaDevices && "function" == typeof navigator.mediaDevices.getUserMedia ? navigator.mediaDevices.getUserMedia(t) : Promise.reject(new Error("getUserMedia is not defined")) } e.b = r, e.a = o }, function (t, e, n) { "use strict"; function r(t, e, n) { n || (n = { data: null, size: e }), this.data = n.data, this.originalSize = n.size, this.I = n, this.from = t, this.size = e } r.prototype.show = function (t, e) { var n, r, o, i, a, u, c; for (e || (e = 1), n = t.getContext("2d"), t.width = this.size.x, t.height = this.size.y, r = n.getImageData(0, 0, t.width, t.height), o = r.data, i = 0, a = 0; a < this.size.y; a++)for (u = 0; u < this.size.x; u++)c = a * this.size.x + u, i = this.get(u, a) * e, o[4 * c + 0] = i, o[4 * c + 1] = i, o[4 * c + 2] = i, o[4 * c + 3] = 255; r.data = o, n.putImageData(r, 0, 0) }, r.prototype.get = function (t, e) { return this.data[(this.from.y + e) * this.originalSize.x + this.from.x + t] }, r.prototype.updateData = function (t) { this.originalSize = t.size, this.data = t.data }, r.prototype.updateFrom = function (t) { return this.from = t, this }, e.a = r }, function (t, e) { "undefined" != typeof window && (window.requestAnimFrame = function () { return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function (t) { window.setTimeout(t, 1e3 / 60) } }()), Math.imul = Math.imul || function (t, e) { var n = t >>> 16 & 65535, r = 65535 & t, o = e >>> 16 & 65535, i = 65535 & e; return r * i + (n * i + r * o << 16 >>> 0) | 0 }, "function" != typeof Object.assign && (Object.assign = function (t) { "use strict"; if (null === t) throw new TypeError("Cannot convert undefined or null to object"); for (var e = Object(t), n = 1; n < arguments.length; n++) { var r = arguments[n]; if (null !== r) for (var o in r) Object.prototype.hasOwnProperty.call(r, o) && (e[o] = r[o]) } return e }) }, function (t, e, n) { "use strict"; var r = void 0; r = n(56), e.a = r }, function (t, e) { t.exports = { inputStream: { name: "Live", type: "LiveStream", constraints: { width: 640, height: 480, facingMode: "environment" }, area: { top: "0%", right: "0%", left: "0%", bottom: "0%" }, singleChannel: !1 }, locate: !0, numOfWorkers: 4, decoder: { readers: ["code_128_reader"] }, locator: { halfSample: !0, patchSize: "medium" } } }, function (t, e, n) { "use strict"; var r = n(58), o = (n(9), n(69)), i = n(3), a = n(31), u = n(70), c = n(68), s = n(76), f = n(73), l = n(71), d = n(72), h = n(75), p = n(74), v = n(67), g = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (t) { return typeof t } : function (t) { return t && "function" == typeof Symbol && t.constructor === Symbol && t !== Symbol.prototype ? "symbol" : typeof t }, _ = { code_128_reader: o.a, ean_reader: i.a, ean_5_reader: d.a, ean_2_reader: l.a, ean_8_reader: f.a, code_39_reader: a.a, code_39_vin_reader: u.a, codabar_reader: c.a, upc_reader: s.a, upc_e_reader: h.a, i2of5_reader: p.a, "2of5_reader": v.a }; e.a = { create: function (t, e) { function n() { } function o() { t.readers.forEach(function (t) { var e, n = {}, r = []; "object" === (void 0 === t ? "undefined" : g(t)) ? (e = t.format, n = t.config) : "string" == typeof t && (e = t), n.supplements && (r = n.supplements.map(function (t) { return new _[t] })), h.push(new _[e](n, r)) }) } function i() { } function a(t, n, r) { function o(e) { var r = { y: e * Math.sin(n), x: e * Math.cos(n) }; t[0].y -= r.y, t[0].x -= r.x, t[1].y += r.y, t[1].x += r.x } for (o(r); r > 1 && (!e.inImageWithBorder(t[0], 0) || !e.inImageWithBorder(t[1], 0));)r -= Math.ceil(r / 2), o(-r); return t } function u(t) { return [{ x: (t[1][0] - t[0][0]) / 2 + t[0][0], y: (t[1][1] - t[0][1]) / 2 + t[0][1] }, { x: (t[3][0] - t[2][0]) / 2 + t[2][0], y: (t[3][1] - t[2][1]) / 2 + t[2][1] }] } function c(t) { var n, o = null, i = r.a.getBarcodeLine(e, t[0], t[1]); for (r.a.toBinaryLine(i), n = 0; n < h.length && null === o; n++)o = h[n].decodePattern(i.line); return null === o ? null : { codeResult: o, barcodeLine: i } } function s(t, e, n) { var r, o, i, a = Math.sqrt(Math.pow(t[1][0] - t[0][0], 2) + Math.pow(t[1][1] - t[0][1], 2)), u = 16, s = null, f = Math.sin(n), l = Math.cos(n); for (r = 1; r < u && null === s; r++)o = a / u * r * (r % 2 == 0 ? -1 : 1), i = { y: o * f, x: o * l }, e[0].y += i.x, e[0].x -= i.y, e[1].y += i.x, e[1].x -= i.y, s = c(e); return s } function f(t) { return Math.sqrt(Math.pow(Math.abs(t[1].y - t[0].y), 2) + Math.pow(Math.abs(t[1].x - t[0].x), 2)) } function l(t) { var e, n, r, o; d.ctx.overlay; return e = u(t), o = f(e), n = Math.atan2(e[1].y - e[0].y, e[1].x - e[0].x), null === (e = a(e, n, Math.floor(.1 * o))) ? null : (r = c(e), null === r && (r = s(t, e, n)), null === r ? null : { codeResult: r.codeResult, line: e, angle: n, pattern: r.barcodeLine.line, threshold: r.barcodeLine.threshold }) } var d = { ctx: { frequency: null, pattern: null, overlay: null }, dom: { frequency: null, pattern: null, overlay: null } }, h = []; return n(), o(), i(), { decodeFromBoundingBox: function (t) { return l(t) }, decodeFromBoundingBoxes: function (e) { var n, r, o = [], i = t.multiple; for (n = 0; n < e.length; n++) { var a = e[n]; if (r = l(a) || {}, r.box = a, i) o.push(r); else if (r.codeResult) return r } if (i) return { barcodes: o } }, setReaders: function (e) { t.readers = e, h.length = 0, o() } } } } }, function (t, e, n) { "use strict"; var r = (n(20), {}), o = { DIR: { UP: 1, DOWN: -1 } }; r.getBarcodeLine = function (t, e, n) { function r(t, e) { l = y[e * m + t], x += l, b = l < b ? l : b, E = l > E ? l : E, _.push(l) } var o, i, a, u, c, s, f, l, d = 0 | e.x, h = 0 | e.y, p = 0 | n.x, v = 0 | n.y, g = Math.abs(v - h) > Math.abs(p - d), _ = [], y = t.data, m = t.size.x, x = 0, b = 255, E = 0; for (g && (s = d, d = h, h = s, s = p, p = v, v = s), d > p && (s = d, d = p, p = s, s = h, h = v, v = s), o = p - d, i = Math.abs(v - h), a = o / 2 | 0, c = h, u = h < v ? 1 : -1, f = d; f < p; f++)g ? r(c, f) : r(f, c), (a -= i) < 0 && (c += u, a += o); return { line: _, min: b, max: E } }, r.toBinaryLine = function (t) { var e, n, r, i, a, u, c = t.min, s = t.max, f = t.line, l = c + (s - c) / 2, d = [], h = (s - c) / 12, p = -h; for (r = f[0] > l ? o.DIR.UP : o.DIR.DOWN, d.push({ pos: 0, val: f[0] }), a = 0; a < f.length - 2; a++)e = f[a + 1] - f[a], n = f[a + 2] - f[a + 1], i = e + n < p && f[a + 1] < 1.5 * l ? o.DIR.DOWN : e + n > h && f[a + 1] > .5 * l ? o.DIR.UP : r, r !== i && (d.push({ pos: a, val: f[a] }), r = i); for (d.push({ pos: f.length, val: f[f.length - 1] }), u = d[0].pos; u < d[1].pos; u++)f[u] = f[u] > l ? 0 : 1; for (a = 1; a < d.length - 1; a++)for (h = d[a + 1].val > d[a].val ? d[a].val + (d[a + 1].val - d[a].val) / 3 * 2 | 0 : d[a + 1].val + (d[a].val - d[a + 1].val) / 3 | 0, u = d[a].pos; u < d[a + 1].pos; u++)f[u] = f[u] > h ? 0 : 1; return { line: f, threshold: h } }, r.debug = { printFrequency: function (t, e) { var n, r = e.getContext("2d"); for (e.width = t.length, e.height = 256, r.beginPath(), r.strokeStyle = "blue", n = 0; n < t.length; n++)r.moveTo(n, 255), r.lineTo(n, 255 - t[n]); r.stroke(), r.closePath() }, printPattern: function (t, e) { var n, r = e.getContext("2d"); for (e.width = t.length, r.fillColor = "black", n = 0; n < t.length; n++)1 === t[n] && r.fillRect(n, 0, 1, 100) } }, e.a = r }, function (t, e, n) { "use strict"; function r(t) { return new Promise(function (e, n) { function r() { o > 0 ? t.videoWidth > 10 && t.videoHeight > 10 ? e() : window.setTimeout(r, 500) : n("Unable to play video stream. Is webcam working?"), o-- } var o = 10; r() }) } function o(t, e) { return n.i(l.a)(e).then(function (e) { return new Promise(function (n) { c = e, t.setAttribute("autoplay", "true"), t.srcObject = e, t.addEventListener("loadedmetadata", function () { t.play(), n() }) }) }).then(r.bind(null, t)) } function i(t) { var e = f()(t, ["width", "height", "facingMode", "aspectRatio", "deviceId"]); return void 0 !== t.minAspectRatio && t.minAspectRatio > 0 && (e.aspectRatio = t.minAspectRatio, console.log("WARNING: Constraint 'minAspectRatio' is deprecated; Use 'aspectRatio' instead")), void 0 !== t.facing && (e.facingMode = t.facing, console.log("WARNING: Constraint 'facing' is deprecated. Use 'facingMode' instead'")), e } function a(t) { var e = { audio: !1, video: i(t) }; return e.video.deviceId && e.video.facingMode && delete e.video.facingMode, Promise.resolve(e) } function u() { return n.i(l.b)().then(function (t) { return t.filter(function (t) { return "videoinput" === t.kind }) }) } var c, s = n(161), f = n.n(s), l = n(52); e.a = { request: function (t, e) { return a(e).then(o.bind(null, t)) }, release: function () { var t = c && c.getVideoTracks(); t && t.length && t[0].stop(), c = null }, enumerateVideoDevices: u, getActiveStreamLabel: function () { if (c) { var t = c.getVideoTracks(); if (t && t.length) return t[0].label } } } }, function (t, e, n) { "use strict"; function r(t) { var e = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : d; return /^blob\:/i.test(t) ? i(t).then(o).then(function (t) { return a(t, e) }) : Promise.resolve(null) } function o(t) { return new Promise(function (e) { var n = new FileReader; n.onload = function (t) { return e(t.target.result) }, n.readAsArrayBuffer(t) }) } function i(t) { return new Promise(function (e, n) { var r = new XMLHttpRequest; r.open("GET", t, !0), r.responseType = "blob", r.onreadystatechange = function () { r.readyState !== XMLHttpRequest.DONE || 200 !== r.status && 0 !== r.status || e(this.response) }, r.onerror = n, r.send() }) } function a(t) { var e = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : d, n = new DataView(t), r = t.byteLength, o = e.reduce(function (t, e) { var n = Object.keys(l).filter(function (t) { return l[t] === e })[0]; return n && (t[n] = e), t }, {}), i = 2; if (255 !== n.getUint8(0) || 216 !== n.getUint8(1)) return !1; for (; i < r;) { if (255 !== n.getUint8(i)) return !1; if (225 === n.getUint8(i + 1)) return u(n, i + 4, o); i += 2 + n.getUint16(i + 2) } } function u(t, e, n) { if ("Exif" !== f(t, e, 4)) return !1; var r = e + 6, o = void 0; if (18761 === t.getUint16(r)) o = !1; else { if (19789 !== t.getUint16(r)) return !1; o = !0 } if (42 !== t.getUint16(r + 2, !o)) return !1; var i = t.getUint32(r + 4, !o); return !(i < 8) && c(t, r, r + i, n, o) } function c(t, e, n, r, o) { for (var i = t.getUint16(n, !o), a = {}, u = 0; u < i; u++) { var c = n + 12 * u + 2, f = r[t.getUint16(c, !o)]; f && (a[f] = s(t, c, e, n, o)) } return a } function s(t, e, n, r, o) { var i = t.getUint16(e + 2, !o), a = t.getUint32(e + 4, !o); switch (i) { case 3: if (1 === a) return t.getUint16(e + 8, !o) } } function f(t, e, n) { for (var r = "", o = e; o < e + n; o++)r += String.fromCharCode(t.getUint8(o)); return r } e.a = r; var l = { 274: "orientation" }, d = Object.keys(l).map(function (t) { return l[t] }) }, function (t, e, n) { "use strict"; function r(t, e) { t.width !== e.x && (t.width = e.x), t.height !== e.y && (t.height = e.y) } var o = n(19), i = Math.PI / 180, a = {}; a.create = function (t, e) { var a, u = {}, c = t.getConfig(), s = (n.i(o.b)(t.getRealWidth(), t.getRealHeight()), t.getCanvasSize()), f = n.i(o.b)(t.getWidth(), t.getHeight()), l = t.getTopRight(), d = l.x, h = l.y, p = null, v = null; return a = e ? e : document.createElement("canvas"), a.width = s.x, a.height = s.y, p = a.getContext("2d"), v = new Uint8Array(f.x * f.y), u.attachData = function (t) { v = t }, u.getData = function () { return v }, u.grab = function () { var e, u = c.halfSample, l = t.getFrame(), g = l, _ = 0; if (g) { if (r(a, s), "ImageStream" === c.type && (g = l.img, l.tags && l.tags.orientation)) switch (l.tags.orientation) { case 6: _ = 90 * i; break; case 8: _ = -90 * i }return 0 !== _ ? (p.translate(s.x / 2, s.y / 2), p.rotate(_), p.drawImage(g, -s.y / 2, -s.x / 2, s.y, s.x), p.rotate(-_), p.translate(-s.x / 2, -s.y / 2)) : p.drawImage(g, 0, 0, s.x, s.y), e = p.getImageData(d, h, f.x, f.y).data, u ? n.i(o.c)(e, f, v) : n.i(o.d)(e, v, c), !0 } return !1 }, u.getSize = function () { return f }, u }, e.a = a }, function (t, e, n) { "use strict"; function r(t, e) { t.onload = function () { e.loaded(this) } } var o = n(60), i = {}; i.load = function (t, e, i, a, u) { var c, s, f, l = new Array(a), d = new Array(l.length); if (u === !1) l[0] = t; else for (c = 0; c < l.length; c++)f = i + c, l[c] = t + "image-" + ("00" + f).slice(-3) + ".jpg"; for (d.notLoaded = [], d.addImage = function (t) { d.notLoaded.push(t) }, d.loaded = function (r) { for (var i = d.notLoaded, a = 0; a < i.length; a++)if (i[a] === r) { i.splice(a, 1); for (var c = 0; c < l.length; c++) { var s = l[c].substr(l[c].lastIndexOf("/")); if (r.src.lastIndexOf(s) !== -1) { d[c] = { img: r }; break } } break } 0 === i.length && (u === !1 ? n.i(o.a)(t, ["orientation"]).then(function (t) { d[0].tags = t, e(d) }).catch(function (t) { console.log(t), e(d) }) : e(d)) }, c = 0; c < l.length; c++)s = new Image, d.addImage(s), r(s, d), s.src = l[c] }, e.a = i }, function (t, e, n) { "use strict"; var r = n(62), o = {}; o.createVideoStream = function (t) { function e() { var e = t.videoWidth, o = t.videoHeight; n = i.size ? e / o > 1 ? i.size : Math.floor(e / o * i.size) : e, r = i.size ? e / o > 1 ? Math.floor(o / e * i.size) : i.size : o, s.x = n, s.y = r } var n, r, o = {}, i = null, a = ["canrecord", "ended"], u = {}, c = { x: 0, y: 0 }, s = { x: 0, y: 0 }; return o.getRealWidth = function () { return t.videoWidth }, o.getRealHeight = function () { return t.videoHeight }, o.getWidth = function () { return n }, o.getHeight = function () { return r }, o.setWidth = function (t) { n = t }, o.setHeight = function (t) { r = t }, o.setInputStream = function (e) { i = e, t.src = void 0 !== e.src ? e.src : "" }, o.ended = function () { return t.ended }, o.getConfig = function () { return i }, o.setAttribute = function (e, n) { t.setAttribute(e, n) }, o.pause = function () { t.pause() }, o.play = function () { t.play() }, o.setCurrentTime = function (e) { "LiveStream" !== i.type && (t.currentTime = e) }, o.addEventListener = function (e, n, r) { a.indexOf(e) !== -1 ? (u[e] || (u[e] = []), u[e].push(n)) : t.addEventListener(e, n, r) }, o.clearEventHandlers = function () { a.forEach(function (e) { var n = u[e]; n && n.length > 0 && n.forEach(function (n) { t.removeEventListener(e, n) }) }) }, o.trigger = function (t, n) { var r, i = u[t]; if ("canrecord" === t && e(), i && i.length > 0) for (r = 0; r < i.length; r++)i[r].apply(o, n) }, o.setTopRight = function (t) { c.x = t.x, c.y = t.y }, o.getTopRight = function () { return c }, o.setCanvasSize = function (t) { s.x = t.x, s.y = t.y }, o.getCanvasSize = function () { return s }, o.getFrame = function () { return t }, o }, o.createLiveStream = function (t) { t.setAttribute("autoplay", !0); var e = o.createVideoStream(t); return e.ended = function () { return !1 }, e }, o.createImageStream = function () { function t() { l = !1, r.a.load(v, function (t) { if (d = t, t[0].tags && t[0].tags.orientation) switch (t[0].tags.orientation) { case 6: case 8: u = t[0].img.height, c = t[0].img.width; break; default: u = t[0].img.width, c = t[0].img.height } else u = t[0].img.width, c = t[0].img.height; n = a.size ? u / c > 1 ? a.size : Math.floor(u / c * a.size) : u, o = a.size ? u / c > 1 ? Math.floor(c / u * a.size) : a.size : c, x.x = n, x.y = o, l = !0, s = 0, setTimeout(function () { e("canrecord", []) }, 0) }, p, h, a.sequence) } function e(t, e) { var n, r = y[t]; if (r && r.length > 0) for (n = 0; n < r.length; n++)r[n].apply(i, e) } var n, o, i = {}, a = null, u = 0, c = 0, s = 0, f = !0, l = !1, d = null, h = 0, p = 1, v = null, g = !1, _ = ["canrecord", "ended"], y = {}, m = { x: 0, y: 0 }, x = { x: 0, y: 0 }; return i.trigger = e, i.getWidth = function () { return n }, i.getHeight = function () { return o }, i.setWidth = function (t) { n = t }, i.setHeight = function (t) { o = t }, i.getRealWidth = function () { return u }, i.getRealHeight = function () { return c }, i.setInputStream = function (e) { a = e, e.sequence === !1 ? (v = e.src, h = 1) : (v = e.src, h = e.length), t() }, i.ended = function () { return g }, i.setAttribute = function () { }, i.getConfig = function () { return a }, i.pause = function () { f = !0 }, i.play = function () { f = !1 }, i.setCurrentTime = function (t) { s = t }, i.addEventListener = function (t, e) { _.indexOf(t) !== -1 && (y[t] || (y[t] = []), y[t].push(e)) }, i.setTopRight = function (t) { m.x = t.x, m.y = t.y }, i.getTopRight = function () { return m }, i.setCanvasSize = function (t) { x.x = t.x, x.y = t.y }, i.getCanvasSize = function () { return x }, i.getFrame = function () { var t; return l ? (f || (t = d[s], s < h - 1 ? s++ : setTimeout(function () { g = !0, e("ended", []) }, 0)), t) : null }, i }, e.a = o }, function (t, e, n) { "use strict"; (function (t) { function r() { var e; v = p.halfSample ? new w.a({ x: O.size.x / 2 | 0, y: O.size.y / 2 | 0 }) : O, C = n.i(A.e)(p.patchSize, v.size), N.x = v.size.x / C.x | 0, N.y = v.size.y / C.y | 0, E = new w.a(v.size, void 0, Uint8Array, !1), y = new w.a(C, void 0, Array, !0), e = new ArrayBuffer(65536), _ = new w.a(C, new Uint8Array(e, 0, C.x * C.y)), g = new w.a(C, new Uint8Array(e, C.x * C.y * 3, C.x * C.y), void 0, !0), R = n.i(P.a)("undefined" != typeof window ? window : "undefined" != typeof self ? self : t, { size: C.x }, e), b = new w.a({ x: v.size.x / _.size.x | 0, y: v.size.y / _.size.y | 0 }, void 0, Array, !0), m = new w.a(b.size, void 0, void 0, !0), x = new w.a(b.size, void 0, Int32Array, !0) } function o() { p.useWorker || "undefined" == typeof document || (z.dom.binary = document.createElement("canvas"), z.dom.binary.className = "binaryBuffer", z.ctx.binary = z.dom.binary.getContext("2d"), z.dom.binary.width = E.size.x, z.dom.binary.height = E.size.y) } function i(t) { var e, n, r, o, i, a, u, c = E.size.x, s = E.size.y, f = -E.size.x, l = -E.size.y; for (e = 0, n = 0; n < t.length; n++)o = t[n], e += o.rad; for (e /= t.length, e = (180 * e / Math.PI + 90) % 180 - 90, e < 0 && (e += 180), e = (180 - e) * Math.PI / 180, i = M.copy(M.create(), [Math.cos(e), Math.sin(e), -Math.sin(e), Math.cos(e)]), n = 0; n < t.length; n++)for (o = t[n], r = 0; r < 4; r++)I.transformMat2(o.box[r], o.box[r], i); for (n = 0; n < t.length; n++)for (o = t[n], r = 0; r < 4; r++)o.box[r][0] < c && (c = o.box[r][0]), o.box[r][0] > f && (f = o.box[r][0]), o.box[r][1] < s && (s = o.box[r][1]), o.box[r][1] > l && (l = o.box[r][1]); for (a = [[c, s], [f, s], [f, l], [c, l]], u = p.halfSample ? 2 : 1, i = M.invert(i, i), r = 0; r < 4; r++)I.transformMat2(a[r], a[r], i); for (r = 0; r < 4; r++)I.scale(a[r], a[r], u); return a } function a() { n.i(A.f)(v, E), E.zeroBorder() } function u() { var t, e, n, r, o, i, a, u = []; for (t = 0; t < N.x; t++)for (e = 0; e < N.y; e++)n = _.size.x * t, r = _.size.y * e, l(n, r), g.zeroBorder(), T.a.init(y.data, 0), i = D.a.create(g, y), a = i.rasterize(0), o = y.moments(a.count), u = u.concat(d(o, [t, e], n, r)); return u } function c(t) { var e, n, r = []; for (e = 0; e < t; e++)r.push(0); for (n = x.data.length; n--;)x.data[n] > 0 && r[x.data[n] - 1]++; return r = r.map(function (t, e) { return { val: t, label: e + 1 } }), r.sort(function (t, e) { return e.val - t.val }), r.filter(function (t) { return t.val >= 5 }) } function s(t, e) { var n, r, o, a, u = [], c = []; for (n = 0; n < t.length; n++) { for (r = x.data.length, u.length = 0; r--;)x.data[r] === t[n].label && (o = b.data[r], u.push(o)); a = i(u), a && c.push(a) } return c } function f(t) { var e = n.i(A.g)(t, .9), r = n.i(A.h)(e, 1, function (t) { return t.getPoints().length }), o = [], i = []; if (1 === r.length) { o = r[0].item.getPoints(); for (var a = 0; a < o.length; a++)i.push(o[a].point) } return i } function l(t, e) { E.subImageAsCopy(_, n.i(A.b)(t, e)), R.skeletonize() } function d(t, e, n, r) { var o, i, a, u, c = [], s = [], l = Math.ceil(C.x / 3); if (t.length >= 2) { for (o = 0; o < t.length; o++)t[o].m00 > l && c.push(t[o]); if (c.length >= 2) { for (a = f(c), i = 0, o = 0; o < a.length; o++)i += a[o].rad; a.length > 1 && a.length >= c.length / 4 * 3 && a.length > t.length / 4 && (i /= a.length, u = { index: e[1] * N.x + e[0], pos: { x: n, y: r }, box: [I.clone([n, r]), I.clone([n + _.size.x, r]), I.clone([n + _.size.x, r + _.size.y]), I.clone([n, r + _.size.y])], moments: a, rad: i, vec: I.clone([Math.cos(i), Math.sin(i)]) }, s.push(u)) } } return s } function h(t) { function e() { var t; for (t = 0; t < x.data.length; t++)if (0 === x.data[t] && 1 === m.data[t]) return t; return x.length } function n(t) { var e, r, o, u, c, s = { x: t % x.size.x, y: t / x.size.x | 0 }; if (t < x.data.length) for (o = b.data[t], x.data[t] = i, c = 0; c < S.a.searchDirections.length; c++)r = s.y + S.a.searchDirections[c][0], e = s.x + S.a.searchDirections[c][1], u = r * x.size.x + e, 0 !== m.data[u] ? 0 === x.data[u] && Math.abs(I.dot(b.data[u].vec, o.vec)) > a && n(u) : x.data[u] = Number.MAX_VALUE } var r, o, i = 0, a = .95, u = 0; for (T.a.init(m.data, 0), T.a.init(x.data, 0), T.a.init(b.data, null), r = 0; r < t.length; r++)o = t[r], b.data[o.index] = o, m.data[o.index] = 1; for (m.zeroBorder(); (u = e()) < x.data.length;)i++, n(u); return i } var p, v, g, _, y, m, x, b, E, C, O, R, w = n(20), A = n(19), T = n(8), D = (n(9), n(65)), S = n(30), P = n(66), I = { clone: n(6), dot: n(32), scale: n(80), transformMat2: n(81) }, M = { copy: n(77), create: n(78), invert: n(79) }, z = { ctx: { binary: null }, dom: { binary: null } }, N = { x: 0, y: 0 }; e.a = { init: function (t, e) { p = e, O = t, r(), o() }, locate: function () { var t, e; if (p.halfSample && n.i(A.i)(O, v), a(), t = u(), t.length < N.x * N.y * .05) return null; var r = h(t); return r < 1 ? null : (e = c(r), 0 === e.length ? null : s(e, r)) }, checkImageConstraints: function (t, e) { var r, o, i, a = t.getWidth(), u = t.getHeight(), c = e.halfSample ? .5 : 1; if (t.getConfig().area && (i = n.i(A.j)(a, u, t.getConfig().area), t.setTopRight({ x: i.sx, y: i.sy }), t.setCanvasSize({ x: a, y: u }), a = i.sw, u = i.sh), o = { x: Math.floor(a * c), y: Math.floor(u * c) }, r = n.i(A.e)(e.patchSize, o), t.setWidth(Math.floor(Math.floor(o.x / r.x) * (1 / c) * r.x)), t.setHeight(Math.floor(Math.floor(o.y / r.y) * (1 / c) * r.y)), t.getWidth() % r.x == 0 && t.getHeight() % r.y == 0) return !0; throw new Error("Image dimensions do not comply with the current settings: Width (" + a + " )and height (" + u + ") must a multiple of " + r.x) } } }).call(e, n(47)) }, function (t, e, n) { "use strict"; var r = n(30), o = { createContour2D: function () { return { dir: null, index: null, firstVertex: null, insideContours: null, nextpeer: null, prevpeer: null } }, CONTOUR_DIR: { CW_DIR: 0, CCW_DIR: 1, UNKNOWN_DIR: 2 }, DIR: { OUTSIDE_EDGE: -32767, INSIDE_EDGE: -32766 }, create: function (t, e) { var n = t.data, i = e.data, a = t.size.x, u = t.size.y, c = r.a.create(t, e); return { rasterize: function (t) { var e, r, s, f, l, d, h, p, v, g, _, y, m = [], x = 0; for (y = 0; y < 400; y++)m[y] = 0; for (m[0] = n[0], v = null, d = 1; d < u - 1; d++)for (f = 0, r = m[0], l = 1; l < a - 1; l++)if (_ = d * a + l, 0 === i[_]) if ((e = n[_]) !== r) { if (0 === f) s = x + 1, m[s] = e, r = e, null !== (h = c.contourTracing(d, l, s, e, o.DIR.OUTSIDE_EDGE)) && (x++, f = s, p = o.createContour2D(), p.dir = o.CONTOUR_DIR.CW_DIR, p.index = f, p.firstVertex = h, p.nextpeer = v, p.insideContours = null, null !== v && (v.prevpeer = p), v = p); else if (null !== (h = c.contourTracing(d, l, o.DIR.INSIDE_EDGE, e, f))) { for (p = o.createContour2D(), p.firstVertex = h, p.insideContours = null, p.dir = 0 === t ? o.CONTOUR_DIR.CCW_DIR : o.CONTOUR_DIR.CW_DIR, p.index = t, g = v; null !== g && g.index !== f;)g = g.nextpeer; null !== g && (p.nextpeer = g.insideContours, null !== g.insideContours && (g.insideContours.prevpeer = p), g.insideContours = p) } } else i[_] = f; else i[_] === o.DIR.OUTSIDE_EDGE || i[_] === o.DIR.INSIDE_EDGE ? (f = 0, r = i[_] === o.DIR.INSIDE_EDGE ? n[_] : m[0]) : (f = i[_], r = m[f]); for (g = v; null !== g;)g.index = t, g = g.nextpeer; return { cc: v, count: x } }, debug: { drawContour: function (t, e) { var n, r, i, a = t.getContext("2d"), u = e; for (a.strokeStyle = "red", a.fillStyle = "red", a.lineWidth = 1, n = null !== u ? u.insideContours : null; null !== u;) { switch (null !== n ? (r = n, n = n.nextpeer) : (r = u, u = u.nextpeer, n = null !== u ? u.insideContours : null), r.dir) { case o.CONTOUR_DIR.CW_DIR: a.strokeStyle = "red"; break; case o.CONTOUR_DIR.CCW_DIR: a.strokeStyle = "blue"; break; case o.CONTOUR_DIR.UNKNOWN_DIR: a.strokeStyle = "green" }i = r.firstVertex, a.beginPath(), a.moveTo(i.x, i.y); do i = i.next, a.lineTo(i.x, i.y); while (i !== r.firstVertex); a.stroke() } } } } } }; e.a = o }, function (module, __webpack_exports__, __webpack_require__) { "use strict"; function Skeletonizer(stdlib, foreign, buffer) { "use asm"; var images = new stdlib.Uint8Array(buffer), size = foreign.size | 0, imul = stdlib.Math.imul; function erode(inImagePtr, outImagePtr) { inImagePtr = inImagePtr | 0; outImagePtr = outImagePtr | 0; var v = 0, u = 0, sum = 0, yStart1 = 0, yStart2 = 0, xStart1 = 0, xStart2 = 0, offset = 0; for (v = 1; (v | 0) < (size - 1 | 0); v = v + 1 | 0) { offset = offset + size | 0; for (u = 1; (u | 0) < (size - 1 | 0); u = u + 1 | 0) { yStart1 = offset - size | 0; yStart2 = offset + size | 0; xStart1 = u - 1 | 0; xStart2 = u + 1 | 0; sum = (images[inImagePtr + yStart1 + xStart1 | 0] | 0) + (images[inImagePtr + yStart1 + xStart2 | 0] | 0) + (images[inImagePtr + offset + u | 0] | 0) + (images[inImagePtr + yStart2 + xStart1 | 0] | 0) + (images[inImagePtr + yStart2 + xStart2 | 0] | 0) | 0; if ((sum | 0) == (5 | 0)) { images[outImagePtr + offset + u | 0] = 1; } else { images[outImagePtr + offset + u | 0] = 0; } } } return; } function subtract(aImagePtr, bImagePtr, outImagePtr) { aImagePtr = aImagePtr | 0; bImagePtr = bImagePtr | 0; outImagePtr = outImagePtr | 0; var length = 0; length = imul(size, size) | 0; while ((length | 0) > 0) { length = length - 1 | 0; images[outImagePtr + length | 0] = (images[aImagePtr + length | 0] | 0) - (images[bImagePtr + length | 0] | 0) | 0; } } function bitwiseOr(aImagePtr, bImagePtr, outImagePtr) { aImagePtr = aImagePtr | 0; bImagePtr = bImagePtr | 0; outImagePtr = outImagePtr | 0; var length = 0; length = imul(size, size) | 0; while ((length | 0) > 0) { length = length - 1 | 0; images[outImagePtr + length | 0] = images[aImagePtr + length | 0] | 0 | (images[bImagePtr + length | 0] | 0) | 0; } } function countNonZero(imagePtr) { imagePtr = imagePtr | 0; var sum = 0, length = 0; length = imul(size, size) | 0; while ((length | 0) > 0) { length = length - 1 | 0; sum = (sum | 0) + (images[imagePtr + length | 0] | 0) | 0; } return sum | 0; } function init(imagePtr, value) { imagePtr = imagePtr | 0; value = value | 0; var length = 0; length = imul(size, size) | 0; while ((length | 0) > 0) { length = length - 1 | 0; images[imagePtr + length | 0] = value; } } function dilate(inImagePtr, outImagePtr) { inImagePtr = inImagePtr | 0; outImagePtr = outImagePtr | 0; var v = 0, u = 0, sum = 0, yStart1 = 0, yStart2 = 0, xStart1 = 0, xStart2 = 0, offset = 0; for (v = 1; (v | 0) < (size - 1 | 0); v = v + 1 | 0) { offset = offset + size | 0; for (u = 1; (u | 0) < (size - 1 | 0); u = u + 1 | 0) { yStart1 = offset - size | 0; yStart2 = offset + size | 0; xStart1 = u - 1 | 0; xStart2 = u + 1 | 0; sum = (images[inImagePtr + yStart1 + xStart1 | 0] | 0) + (images[inImagePtr + yStart1 + xStart2 | 0] | 0) + (images[inImagePtr + offset + u | 0] | 0) + (images[inImagePtr + yStart2 + xStart1 | 0] | 0) + (images[inImagePtr + yStart2 + xStart2 | 0] | 0) | 0; if ((sum | 0) > (0 | 0)) { images[outImagePtr + offset + u | 0] = 1; } else { images[outImagePtr + offset + u | 0] = 0; } } } return; } function memcpy(srcImagePtr, dstImagePtr) { srcImagePtr = srcImagePtr | 0; dstImagePtr = dstImagePtr | 0; var length = 0; length = imul(size, size) | 0; while ((length | 0) > 0) { length = length - 1 | 0; images[dstImagePtr + length | 0] = images[srcImagePtr + length | 0] | 0; } } function zeroBorder(imagePtr) { imagePtr = imagePtr | 0; var x = 0, y = 0; for (x = 0; (x | 0) < (size - 1 | 0); x = x + 1 | 0) { images[imagePtr + x | 0] = 0; images[imagePtr + y | 0] = 0; y = y + size - 1 | 0; images[imagePtr + y | 0] = 0; y = y + 1 | 0; } for (x = 0; (x | 0) < (size | 0); x = x + 1 | 0) { images[imagePtr + y | 0] = 0; y = y + 1 | 0; } } function skeletonize() { var subImagePtr = 0, erodedImagePtr = 0, tempImagePtr = 0, skelImagePtr = 0, sum = 0, done = 0; erodedImagePtr = imul(size, size) | 0; tempImagePtr = erodedImagePtr + erodedImagePtr | 0; skelImagePtr = tempImagePtr + erodedImagePtr | 0; init(skelImagePtr, 0); zeroBorder(subImagePtr); do { erode(subImagePtr, erodedImagePtr); dilate(erodedImagePtr, tempImagePtr); subtract(subImagePtr, tempImagePtr, tempImagePtr); bitwiseOr(skelImagePtr, tempImagePtr, skelImagePtr); memcpy(erodedImagePtr, subImagePtr); sum = countNonZero(subImagePtr) | 0; done = (sum | 0) == 0 | 0; } while (!done); } return { skeletonize: skeletonize }; } __webpack_exports__["a"] = Skeletonizer; }, function (t, e, n) { "use strict"; function r(t) { o.a.call(this, t), this.barSpaceRatio = [1, 1] } var o = n(2), i = 1, a = 3, u = { START_PATTERN: { value: [a, i, a, i, i, i] }, STOP_PATTERN: { value: [a, i, i, i, a] }, CODE_PATTERN: { value: [[i, i, a, a, i], [a, i, i, i, a], [i, a, i, i, a], [a, a, i, i, i], [i, i, a, i, a], [a, i, a, i, i], [i, a, a, i, i], [i, i, i, a, a], [a, i, i, a, i], [i, a, i, a, i]] }, SINGLE_CODE_ERROR: { value: .78, writable: !0 }, AVG_CODE_ERROR: { value: .3, writable: !0 }, FORMAT: { value: "2of5" } }, c = u.START_PATTERN.value.reduce(function (t, e) { return t + e }, 0); r.prototype = Object.create(o.a.prototype, u), r.prototype.constructor = r, r.prototype._findPattern = function (t, e, n, r) { var o, i, a, u, c = [], s = this, f = 0, l = { error: Number.MAX_VALUE, code: -1, start: 0, end: 0 }, d = s.AVG_CODE_ERROR; for (n = n || !1, r = r || !1, e || (e = s._nextSet(s._row)), o = 0; o < t.length; o++)c[o] = 0; for (o = e; o < s._row.length; o++)if (s._row[o] ^ n) c[f]++; else { if (f === c.length - 1) { for (u = 0, a = 0; a < c.length; a++)u += c[a]; if ((i = s._matchPattern(c, t)) < d) return l.error = i, l.start = o - u, l.end = o, l; if (!r) return null; for (a = 0; a < c.length - 2; a++)c[a] = c[a + 2]; c[c.length - 2] = 0, c[c.length - 1] = 0, f-- } else f++; c[f] = 1, n = !n } return null }, r.prototype._findStart = function () { for (var t, e, n = this, r = n._nextSet(n._row), o = 1; !e;) { if (!(e = n._findPattern(n.START_PATTERN, r, !1, !0))) return null; if (o = Math.floor((e.end - e.start) / c), (t = e.start - 5 * o) >= 0 && n._matchRange(t, e.start, 0)) return e; r = e.end, e = null } }, r.prototype._verifyTrailingWhitespace = function (t) { var e, n = this; return e = t.end + (t.end - t.start) / 2, e < n._row.length && n._matchRange(t.end, e, 0) ? t : null }, r.prototype._findEnd = function () { var t, e, n, r = this; return r._row.reverse(), n = r._nextSet(r._row), t = r._findPattern(r.STOP_PATTERN, n, !1, !0), r._row.reverse(), null === t ? null : (e = t.start, t.start = r._row.length - t.end, t.end = r._row.length - e, null !== t ? r._verifyTrailingWhitespace(t) : null) }, r.prototype._decodeCode = function (t) { var e, n, r, o = this, i = 0, a = o.AVG_CODE_ERROR, u = { error: Number.MAX_VALUE, code: -1, start: 0, end: 0 }; for (e = 0; e < t.length; e++)i += t[e]; for (r = 0; r < o.CODE_PATTERN.length; r++)(n = o._matchPattern(t, o.CODE_PATTERN[r])) < u.error && (u.code = r, u.error = n); if (u.error < a) return u }, r.prototype._decodePayload = function (t, e, n) { for (var r, o, i = this, a = 0, u = t.length, c = [0, 0, 0, 0, 0]; a < u;) { for (r = 0; r < 5; r++)c[r] = t[a] * this.barSpaceRatio[0], a += 2; if (!(o = i._decodeCode(c))) return null; e.push(o.code + ""), n.push(o) } return o }, r.prototype._verifyCounterLength = function (t) { return t.length % 10 == 0 }, r.prototype._decode = function () { var t, e, n, r = this, o = [], i = []; return (t = r._findStart()) ? (i.push(t), (e = r._findEnd()) ? (n = r._fillCounters(t.end, e.start, !1), r._verifyCounterLength(n) && r._decodePayload(n, o, i) ? o.length < 5 ? null : (i.push(e), { code: o.join(""), start: t.start, end: e.end, startInfo: t, decodedCodes: i }) : null) : null) : null }, e.a = r }, function (t, e, n) { "use strict"; function r() { o.a.call(this), this._counters = [] } var o = n(2), i = { ALPHABETH_STRING: { value: "0123456789-$:/.+ABCD" }, ALPHABET: { value: [48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 45, 36, 58, 47, 46, 43, 65, 66, 67, 68] }, CHARACTER_ENCODINGS: { value: [3, 6, 9, 96, 18, 66, 33, 36, 48, 72, 12, 24, 69, 81, 84, 21, 26, 41, 11, 14] }, START_END: { value: [26, 41, 11, 14] }, MIN_ENCODED_CHARS: { value: 4 }, MAX_ACCEPTABLE: { value: 2 }, PADDING: { value: 1.5 }, FORMAT: { value: "codabar", writeable: !1 } }; r.prototype = Object.create(o.a.prototype, i), r.prototype.constructor = r, r.prototype._decode = function () { var t, e, n, r, o, i = this, a = []; if (this._counters = i._fillCounters(), !(t = i._findStart())) return null; r = t.startCounter; do { if ((n = i._toPattern(r)) < 0) return null; if ((e = i._patternToChar(n)) < 0) return null; if (a.push(e), r += 8, a.length > 1 && i._isStartEnd(n)) break } while (r < i._counters.length); return a.length - 2 < i.MIN_ENCODED_CHARS || !i._isStartEnd(n) ? null : i._verifyWhitespace(t.startCounter, r - 8) && i._validateResult(a, t.startCounter) ? (r = r > i._counters.length ? i._counters.length : r, o = t.start + i._sumCounters(t.startCounter, r - 8), { code: a.join(""), start: t.start, end: o, startInfo: t, decodedCodes: a }) : null }, r.prototype._verifyWhitespace = function (t, e) { return (t - 1 <= 0 || this._counters[t - 1] >= this._calculatePatternLength(t) / 2) && (e + 8 >= this._counters.length || this._counters[e + 7] >= this._calculatePatternLength(e) / 2) }, r.prototype._calculatePatternLength = function (t) { var e, n = 0; for (e = t; e < t + 7; e++)n += this._counters[e]; return n }, r.prototype._thresholdResultPattern = function (t, e) { var n, r, o, i, a, u = this, c = { space: { narrow: { size: 0, counts: 0, min: 0, max: Number.MAX_VALUE }, wide: { size: 0, counts: 0, min: 0, max: Number.MAX_VALUE } }, bar: { narrow: { size: 0, counts: 0, min: 0, max: Number.MAX_VALUE }, wide: { size: 0, counts: 0, min: 0, max: Number.MAX_VALUE } } }, s = e; for (o = 0; o < t.length; o++) { for (a = u._charToPattern(t[o]), i = 6; i >= 0; i--)n = 2 == (1 & i) ? c.bar : c.space, r = 1 == (1 & a) ? n.wide : n.narrow, r.size += u._counters[s + i], r.counts++, a >>= 1; s += 8 } return ["space", "bar"].forEach(function (t) { var e = c[t]; e.wide.min = Math.floor((e.narrow.size / e.narrow.counts + e.wide.size / e.wide.counts) / 2), e.narrow.max = Math.ceil(e.wide.min), e.wide.max = Math.ceil((e.wide.size * u.MAX_ACCEPTABLE + u.PADDING) / e.wide.counts) }), c }, r.prototype._charToPattern = function (t) { var e, n = this, r = t.charCodeAt(0); for (e = 0; e < n.ALPHABET.length; e++)if (n.ALPHABET[e] === r) return n.CHARACTER_ENCODINGS[e]; return 0 }, r.prototype._validateResult = function (t, e) { var n, r, o, i, a, u, c = this, s = c._thresholdResultPattern(t, e), f = e; for (n = 0; n < t.length; n++) { for (u = c._charToPattern(t[n]), r = 6; r >= 0; r--) { if (o = 0 == (1 & r) ? s.bar : s.space, i = 1 == (1 & u) ? o.wide : o.narrow, (a = c._counters[f + r]) < i.min || a > i.max) return !1; u >>= 1 } f += 8 } return !0 }, r.prototype._patternToChar = function (t) { var e, n = this; for (e = 0; e < n.CHARACTER_ENCODINGS.length; e++)if (n.CHARACTER_ENCODINGS[e] === t) return String.fromCharCode(n.ALPHABET[e]); return -1 }, r.prototype._computeAlternatingThreshold = function (t, e) { var n, r, o = Number.MAX_VALUE, i = 0; for (n = t; n < e; n += 2)r = this._counters[n], r > i && (i = r), r < o && (o = r); return (o + i) / 2 | 0 }, r.prototype._toPattern = function (t) { var e, n, r, o, i = 7, a = t + i, u = 1 << i - 1, c = 0; if (a > this._counters.length) return -1; for (e = this._computeAlternatingThreshold(t, a), n = this._computeAlternatingThreshold(t + 1, a), r = 0; r < i; r++)o = 0 == (1 & r) ? e : n, this._counters[t + r] > o && (c |= u), u >>= 1; return c }, r.prototype._isStartEnd = function (t) { var e; for (e = 0; e < this.START_END.length; e++)if (this.START_END[e] === t) return !0; return !1 }, r.prototype._sumCounters = function (t, e) { var n, r = 0; for (n = t; n < e; n++)r += this._counters[n]; return r }, r.prototype._findStart = function () { var t, e, n, r = this, o = r._nextUnset(r._row); for (t = 1; t < this._counters.length; t++)if ((e = r._toPattern(t)) !== -1 && r._isStartEnd(e)) return o += r._sumCounters(0, t), n = o + r._sumCounters(t, t + 8), { start: o, end: n, startCounter: t, endCounter: t + 8 } }, e.a = r }, function (t, e, n) { "use strict"; function r() { i.a.call(this) } function o(t, e, n) { for (var r = n.length, o = 0, i = 0; r--;)i += t[n[r]], o += e[n[r]]; return i / o } var i = n(2), a = { CODE_SHIFT: { value: 98 }, CODE_C: { value: 99 }, CODE_B: { value: 100 }, CODE_A: { value: 101 }, START_CODE_A: { value: 103 }, START_CODE_B: { value: 104 }, START_CODE_C: { value: 105 }, STOP_CODE: { value: 106 }, CODE_PATTERN: { value: [[2, 1, 2, 2, 2, 2], [2, 2, 2, 1, 2, 2], [2, 2, 2, 2, 2, 1], [1, 2, 1, 2, 2, 3], [1, 2, 1, 3, 2, 2], [1, 3, 1, 2, 2, 2], [1, 2, 2, 2, 1, 3], [1, 2, 2, 3, 1, 2], [1, 3, 2, 2, 1, 2], [2, 2, 1, 2, 1, 3], [2, 2, 1, 3, 1, 2], [2, 3, 1, 2, 1, 2], [1, 1, 2, 2, 3, 2], [1, 2, 2, 1, 3, 2], [1, 2, 2, 2, 3, 1], [1, 1, 3, 2, 2, 2], [1, 2, 3, 1, 2, 2], [1, 2, 3, 2, 2, 1], [2, 2, 3, 2, 1, 1], [2, 2, 1, 1, 3, 2], [2, 2, 1, 2, 3, 1], [2, 1, 3, 2, 1, 2], [2, 2, 3, 1, 1, 2], [3, 1, 2, 1, 3, 1], [3, 1, 1, 2, 2, 2], [3, 2, 1, 1, 2, 2], [3, 2, 1, 2, 2, 1], [3, 1, 2, 2, 1, 2], [3, 2, 2, 1, 1, 2], [3, 2, 2, 2, 1, 1], [2, 1, 2, 1, 2, 3], [2, 1, 2, 3, 2, 1], [2, 3, 2, 1, 2, 1], [1, 1, 1, 3, 2, 3], [1, 3, 1, 1, 2, 3], [1, 3, 1, 3, 2, 1], [1, 1, 2, 3, 1, 3], [1, 3, 2, 1, 1, 3], [1, 3, 2, 3, 1, 1], [2, 1, 1, 3, 1, 3], [2, 3, 1, 1, 1, 3], [2, 3, 1, 3, 1, 1], [1, 1, 2, 1, 3, 3], [1, 1, 2, 3, 3, 1], [1, 3, 2, 1, 3, 1], [1, 1, 3, 1, 2, 3], [1, 1, 3, 3, 2, 1], [1, 3, 3, 1, 2, 1], [3, 1, 3, 1, 2, 1], [2, 1, 1, 3, 3, 1], [2, 3, 1, 1, 3, 1], [2, 1, 3, 1, 1, 3], [2, 1, 3, 3, 1, 1], [2, 1, 3, 1, 3, 1], [3, 1, 1, 1, 2, 3], [3, 1, 1, 3, 2, 1], [3, 3, 1, 1, 2, 1], [3, 1, 2, 1, 1, 3], [3, 1, 2, 3, 1, 1], [3, 3, 2, 1, 1, 1], [3, 1, 4, 1, 1, 1], [2, 2, 1, 4, 1, 1], [4, 3, 1, 1, 1, 1], [1, 1, 1, 2, 2, 4], [1, 1, 1, 4, 2, 2], [1, 2, 1, 1, 2, 4], [1, 2, 1, 4, 2, 1], [1, 4, 1, 1, 2, 2], [1, 4, 1, 2, 2, 1], [1, 1, 2, 2, 1, 4], [1, 1, 2, 4, 1, 2], [1, 2, 2, 1, 1, 4], [1, 2, 2, 4, 1, 1], [1, 4, 2, 1, 1, 2], [1, 4, 2, 2, 1, 1], [2, 4, 1, 2, 1, 1], [2, 2, 1, 1, 1, 4], [4, 1, 3, 1, 1, 1], [2, 4, 1, 1, 1, 2], [1, 3, 4, 1, 1, 1], [1, 1, 1, 2, 4, 2], [1, 2, 1, 1, 4, 2], [1, 2, 1, 2, 4, 1], [1, 1, 4, 2, 1, 2], [1, 2, 4, 1, 1, 2], [1, 2, 4, 2, 1, 1], [4, 1, 1, 2, 1, 2], [4, 2, 1, 1, 1, 2], [4, 2, 1, 2, 1, 1], [2, 1, 2, 1, 4, 1], [2, 1, 4, 1, 2, 1], [4, 1, 2, 1, 2, 1], [1, 1, 1, 1, 4, 3], [1, 1, 1, 3, 4, 1], [1, 3, 1, 1, 4, 1], [1, 1, 4, 1, 1, 3], [1, 1, 4, 3, 1, 1], [4, 1, 1, 1, 1, 3], [4, 1, 1, 3, 1, 1], [1, 1, 3, 1, 4, 1], [1, 1, 4, 1, 3, 1], [3, 1, 1, 1, 4, 1], [4, 1, 1, 1, 3, 1], [2, 1, 1, 4, 1, 2], [2, 1, 1, 2, 1, 4], [2, 1, 1, 2, 3, 2], [2, 3, 3, 1, 1, 1, 2]] }, SINGLE_CODE_ERROR: { value: .64 }, AVG_CODE_ERROR: { value: .3 }, FORMAT: { value: "code_128", writeable: !1 }, MODULE_INDICES: { value: { bar: [0, 2, 4], space: [1, 3, 5] } } }; r.prototype = Object.create(i.a.prototype, a), r.prototype.constructor = r, r.prototype._decodeCode = function (t, e) { var n, r, i, a = [0, 0, 0, 0, 0, 0], u = this, c = t, s = !u._row[c], f = 0, l = { error: Number.MAX_VALUE, code: -1, start: t, end: t, correction: { bar: 1, space: 1 } }; for (n = c; n < u._row.length; n++)if (u._row[n] ^ s) a[f]++; else { if (f === a.length - 1) { for (e && u._correct(a, e), r = 0; r < u.CODE_PATTERN.length; r++)(i = u._matchPattern(a, u.CODE_PATTERN[r])) < l.error && (l.code = r, l.error = i); return l.end = n, l.code === -1 || l.error > u.AVG_CODE_ERROR ? null : (u.CODE_PATTERN[l.code] && (l.correction.bar = o(u.CODE_PATTERN[l.code], a, this.MODULE_INDICES.bar), l.correction.space = o(u.CODE_PATTERN[l.code], a, this.MODULE_INDICES.space)), l) } f++, a[f] = 1, s = !s } return null }, r.prototype._correct = function (t, e) { this._correctBars(t, e.bar, this.MODULE_INDICES.bar), this._correctBars(t, e.space, this.MODULE_INDICES.space) }, r.prototype._findStart = function () { var t, e, n, r, i, a = [0, 0, 0, 0, 0, 0], u = this, c = u._nextSet(u._row), s = !1, f = 0, l = { error: Number.MAX_VALUE, code: -1, start: 0, end: 0, correction: { bar: 1, space: 1 } }; for (t = c; t < u._row.length; t++)if (u._row[t] ^ s) a[f]++; else { if (f === a.length - 1) { for (i = 0, r = 0; r < a.length; r++)i += a[r]; for (e = u.START_CODE_A; e <= u.START_CODE_C; e++)(n = u._matchPattern(a, u.CODE_PATTERN[e])) < l.error && (l.code = e, l.error = n); if (l.error < u.AVG_CODE_ERROR) return l.start = t - i, l.end = t, l.correction.bar = o(u.CODE_PATTERN[l.code], a, this.MODULE_INDICES.bar), l.correction.space = o(u.CODE_PATTERN[l.code], a, this.MODULE_INDICES.space), l; for (r = 0; r < 4; r++)a[r] = a[r + 2]; a[4] = 0, a[5] = 0, f-- } else f++; a[f] = 1, s = !s } return null }, r.prototype._decode = function () { var t, e, n = this, r = n._findStart(), o = null, i = !1, a = [], u = 0, c = 0, s = [], f = [], l = !1, d = !0; if (null === r) return null; switch (o = { code: r.code, start: r.start, end: r.end, correction: { bar: r.correction.bar, space: r.correction.space } }, f.push(o), c = o.code, o.code) { case n.START_CODE_A: t = n.CODE_A; break; case n.START_CODE_B: t = n.CODE_B; break; case n.START_CODE_C: t = n.CODE_C; break; default: return null }for (; !i;) { if (e = l, l = !1, null !== (o = n._decodeCode(o.end, o.correction))) switch (o.code !== n.STOP_CODE && (d = !0), o.code !== n.STOP_CODE && (s.push(o.code), u++, c += u * o.code), f.push(o), t) { case n.CODE_A: if (o.code < 64) a.push(String.fromCharCode(32 + o.code)); else if (o.code < 96) a.push(String.fromCharCode(o.code - 64)); else switch (o.code !== n.STOP_CODE && (d = !1), o.code) { case n.CODE_SHIFT: l = !0, t = n.CODE_B; break; case n.CODE_B: t = n.CODE_B; break; case n.CODE_C: t = n.CODE_C; break; case n.STOP_CODE: i = !0 }break; case n.CODE_B: if (o.code < 96) a.push(String.fromCharCode(32 + o.code)); else switch (o.code !== n.STOP_CODE && (d = !1), o.code) { case n.CODE_SHIFT: l = !0, t = n.CODE_A; break; case n.CODE_A: t = n.CODE_A; break; case n.CODE_C: t = n.CODE_C; break; case n.STOP_CODE: i = !0 }break; case n.CODE_C: if (o.code < 100) a.push(o.code < 10 ? "0" + o.code : o.code); else switch (o.code !== n.STOP_CODE && (d = !1), o.code) { case n.CODE_A: t = n.CODE_A; break; case n.CODE_B: t = n.CODE_B; break; case n.STOP_CODE: i = !0 } } else i = !0; e && (t = t === n.CODE_A ? n.CODE_B : n.CODE_A) } return null === o ? null : (o.end = n._nextUnset(n._row, o.end), n._verifyTrailingWhitespace(o) ? (c -= u * s[s.length - 1]) % 103 !== s[s.length - 1] ? null : a.length ? (d && a.splice(a.length - 1, 1), { code: a.join(""), start: r.start, end: o.end, codeset: t, startInfo: r, decodedCodes: f, endInfo: o }) : null : null) }, i.a.prototype._verifyTrailingWhitespace = function (t) { var e, n = this; return e = t.end + (t.end - t.start) / 2, e < n._row.length && n._matchRange(t.end, e, 0) ? t : null }, e.a = r }, function (t, e, n) { "use strict"; function r() { o.a.call(this) } var o = n(31), i = { IOQ: /[IOQ]/g, AZ09: /[A-Z0-9]{17}/ }; r.prototype = Object.create(o.a.prototype), r.prototype.constructor = r, r.prototype._decode = function () { var t = o.a.prototype._decode.apply(this); if (!t) return null; var e = t.code; return e ? (e = e.replace(i.IOQ, ""), e.match(i.AZ09) && this._checkChecksum(e) ? (t.code = e, t) : null) : null }, r.prototype._checkChecksum = function (t) { return !!t }, e.a = r }, function (t, e, n) { "use strict"; function r() { o.a.call(this) } var o = n(3), i = { FORMAT: { value: "ean_2", writeable: !1 } }; r.prototype = Object.create(o.a.prototype, i), r.prototype.constructor = r, r.prototype.decode = function (t, e) { this._row = t; var n, r = 0, o = 0, i = e, a = this._row.length, u = [], c = []; for (o = 0; o < 2 && i < a; o++) { if (!(n = this._decodeCode(i))) return null; c.push(n), u.push(n.code % 10), n.code >= this.CODE_G_START && (r |= 1 << 1 - o), 1 != o && (i = this._nextSet(this._row, n.end), i = this._nextUnset(this._row, i)) } return 2 != u.length || parseInt(u.join("")) % 4 !== r ? null : { code: u.join(""), decodedCodes: c, end: n.end } }, e.a = r }, function (t, e, n) { "use strict"; function r() { a.a.call(this) } function o(t) { var e; for (e = 0; e < 10; e++)if (t === c[e]) return e; return null } function i(t) { var e, n = t.length, r = 0; for (e = n - 2; e >= 0; e -= 2)r += t[e]; for (r *= 3, e = n - 1; e >= 0; e -= 2)r += t[e]; return (r *= 3) % 10 } var a = n(3), u = { FORMAT: { value: "ean_5", writeable: !1 } }, c = [24, 20, 18, 17, 12, 6, 3, 10, 9, 5]; r.prototype = Object.create(a.a.prototype, u), r.prototype.constructor = r, r.prototype.decode = function (t, e) { this._row = t; var n, r = 0, a = 0, u = e, c = this._row.length, s = [], f = []; for (a = 0; a < 5 && u < c; a++) { if (!(n = this._decodeCode(u))) return null; f.push(n), s.push(n.code % 10), n.code >= this.CODE_G_START && (r |= 1 << 4 - a), 4 != a && (u = this._nextSet(this._row, n.end), u = this._nextUnset(this._row, u)) } return 5 != s.length ? null : i(s) !== o(r) ? null : { code: s.join(""), decodedCodes: f, end: n.end } }, e.a = r }, function (t, e, n) { "use strict"; function r(t, e) { o.a.call(this, t, e) } var o = n(3), i = { FORMAT: { value: "ean_8", writeable: !1 } }; r.prototype = Object.create(o.a.prototype, i), r.prototype.constructor = r, r.prototype._decodePayload = function (t, e, n) { var r, o = this; for (r = 0; r < 4; r++) { if (!(t = o._decodeCode(t.end, o.CODE_G_START))) return null; e.push(t.code), n.push(t) } if (null === (t = o._findPattern(o.MIDDLE_PATTERN, t.end, !0, !1))) return null; for (n.push(t), r = 0; r < 4; r++) { if (!(t = o._decodeCode(t.end, o.CODE_G_START))) return null; n.push(t), e.push(t.code) } return t }, e.a = r }, function (t, e, n) { "use strict"; function r(t) { t = a()(o(), t), u.a.call(this, t), this.barSpaceRatio = [1, 1], t.normalizeBarSpaceWidth && (this.SINGLE_CODE_ERROR = .38, this.AVG_CODE_ERROR = .09) } function o() { var t = {}; return Object.keys(r.CONFIG_KEYS).forEach(function (e) { t[e] = r.CONFIG_KEYS[e].default }), t } var i = n(28), a = n.n(i), u = n(2), c = 1, s = 3, f = { START_PATTERN: { value: [c, c, c, c] }, STOP_PATTERN: { value: [c, c, s] }, CODE_PATTERN: { value: [[c, c, s, s, c], [s, c, c, c, s], [c, s, c, c, s], [s, s, c, c, c], [c, c, s, c, s], [s, c, s, c, c], [c, s, s, c, c], [c, c, c, s, s], [s, c, c, s, c], [c, s, c, s, c]] }, SINGLE_CODE_ERROR: { value: .78, writable: !0 }, AVG_CODE_ERROR: { value: .38, writable: !0 }, MAX_CORRECTION_FACTOR: { value: 5 }, FORMAT: { value: "i2of5" } }; r.prototype = Object.create(u.a.prototype, f), r.prototype.constructor = r, r.prototype._matchPattern = function (t, e) { if (this.config.normalizeBarSpaceWidth) { var n, r = [0, 0], o = [0, 0], i = [0, 0], a = this.MAX_CORRECTION_FACTOR, c = 1 / a; for (n = 0; n < t.length; n++)r[n % 2] += t[n], o[n % 2] += e[n]; for (i[0] = o[0] / r[0], i[1] = o[1] / r[1], i[0] = Math.max(Math.min(i[0], a), c), i[1] = Math.max(Math.min(i[1], a), c), this.barSpaceRatio = i, n = 0; n < t.length; n++)t[n] *= this.barSpaceRatio[n % 2] } return u.a.prototype._matchPattern.call(this, t, e) }, r.prototype._findPattern = function (t, e, n, r) { var o, i, a, u, c = [], s = this, f = 0, l = { error: Number.MAX_VALUE, code: -1, start: 0, end: 0 }, d = s.AVG_CODE_ERROR; for (n = n || !1, r = r || !1, e || (e = s._nextSet(s._row)), o = 0; o < t.length; o++)c[o] = 0; for (o = e; o < s._row.length; o++)if (s._row[o] ^ n) c[f]++; else { if (f === c.length - 1) { for (u = 0, a = 0; a < c.length; a++)u += c[a]; if ((i = s._matchPattern(c, t)) < d) return l.error = i, l.start = o - u, l.end = o, l; if (!r) return null; for (a = 0; a < c.length - 2; a++)c[a] = c[a + 2]; c[c.length - 2] = 0, c[c.length - 1] = 0, f-- } else f++; c[f] = 1, n = !n } return null }, r.prototype._findStart = function () { for (var t, e, n = this, r = n._nextSet(n._row), o = 1; !e;) { if (!(e = n._findPattern(n.START_PATTERN, r, !1, !0))) return null; if (o = Math.floor((e.end - e.start) / 4), (t = e.start - 10 * o) >= 0 && n._matchRange(t, e.start, 0)) return e; r = e.end, e = null } }, r.prototype._verifyTrailingWhitespace = function (t) { var e, n = this; return e = t.end + (t.end - t.start) / 2, e < n._row.length && n._matchRange(t.end, e, 0) ? t : null }, r.prototype._findEnd = function () { var t, e, n = this; return n._row.reverse(), t = n._findPattern(n.STOP_PATTERN), n._row.reverse(), null === t ? null : (e = t.start, t.start = n._row.length - t.end, t.end = n._row.length - e, null !== t ? n._verifyTrailingWhitespace(t) : null) }, r.prototype._decodePair = function (t) { var e, n, r = [], o = this; for (e = 0; e < t.length; e++) { if (!(n = o._decodeCode(t[e]))) return null; r.push(n) } return r }, r.prototype._decodeCode = function (t) { var e, n, r, o = this, i = 0, a = o.AVG_CODE_ERROR, u = { error: Number.MAX_VALUE, code: -1, start: 0, end: 0 }; for (e = 0; e < t.length; e++)i += t[e]; for (r = 0; r < o.CODE_PATTERN.length; r++)(n = o._matchPattern(t, o.CODE_PATTERN[r])) < u.error && (u.code = r, u.error = n); if (u.error < a) return u }, r.prototype._decodePayload = function (t, e, n) { for (var r, o, i = this, a = 0, u = t.length, c = [[0, 0, 0, 0, 0], [0, 0, 0, 0, 0]]; a < u;) { for (r = 0; r < 5; r++)c[0][r] = t[a] * this.barSpaceRatio[0], c[1][r] = t[a + 1] * this.barSpaceRatio[1], a += 2; if (!(o = i._decodePair(c))) return null; for (r = 0; r < o.length; r++)e.push(o[r].code + ""), n.push(o[r]) } return o }, r.prototype._verifyCounterLength = function (t) { return t.length % 10 == 0 }, r.prototype._decode = function () { var t, e, n, r = this, o = [], i = []; return (t = r._findStart()) ? (i.push(t), (e = r._findEnd()) ? (n = r._fillCounters(t.end, e.start, !1), r._verifyCounterLength(n) && r._decodePayload(n, o, i) ? o.length % 2 != 0 || o.length < 6 ? null : (i.push(e), { code: o.join(""), start: t.start, end: e.end, startInfo: t, decodedCodes: i }) : null) : null) : null }, r.CONFIG_KEYS = { normalizeBarSpaceWidth: { type: "boolean", default: !1, description: "If true, the reader tries to normalize thewidth-difference between bars and spaces" } }, e.a = r }, function (t, e, n) { "use strict"; function r(t, e) { o.a.call(this, t, e) } var o = n(3), i = { CODE_FREQUENCY: { value: [[56, 52, 50, 49, 44, 38, 35, 42, 41, 37], [7, 11, 13, 14, 19, 25, 28, 21, 22, 26]] }, STOP_PATTERN: { value: [1 / 6 * 7, 1 / 6 * 7, 1 / 6 * 7, 1 / 6 * 7, 1 / 6 * 7, 1 / 6 * 7] }, FORMAT: { value: "upc_e", writeable: !1 } }; r.prototype = Object.create(o.a.prototype, i), r.prototype.constructor = r, r.prototype._decodePayload = function (t, e, n) { var r, o = this, i = 0; for (r = 0; r < 6; r++) { if (!(t = o._decodeCode(t.end))) return null; t.code >= o.CODE_G_START && (t.code = t.code - o.CODE_G_START, i |= 1 << 5 - r), e.push(t.code), n.push(t) } return o._determineParity(i, e) ? t : null }, r.prototype._determineParity = function (t, e) { var n, r; for (r = 0; r < this.CODE_FREQUENCY.length; r++)for (n = 0; n < this.CODE_FREQUENCY[r].length; n++)if (t === this.CODE_FREQUENCY[r][n]) return e.unshift(r), e.push(n), !0; return !1 }, r.prototype._convertToUPCA = function (t) { var e = [t[0]], n = t[t.length - 2]; return e = n <= 2 ? e.concat(t.slice(1, 3)).concat([n, 0, 0, 0, 0]).concat(t.slice(3, 6)) : 3 === n ? e.concat(t.slice(1, 4)).concat([0, 0, 0, 0, 0]).concat(t.slice(4, 6)) : 4 === n ? e.concat(t.slice(1, 5)).concat([0, 0, 0, 0, 0, t[5]]) : e.concat(t.slice(1, 6)).concat([0, 0, 0, 0, n]), e.push(t[t.length - 1]), e }, r.prototype._checksum = function (t) { return o.a.prototype._checksum.call(this, this._convertToUPCA(t)) }, r.prototype._findEnd = function (t, e) { return e = !0, o.a.prototype._findEnd.call(this, t, e) }, r.prototype._verifyTrailingWhitespace = function (t) { var e, n = this; if ((e = t.end + (t.end - t.start) / 2) < n._row.length && n._matchRange(t.end, e, 0)) return t }, e.a = r }, function (t, e, n) { "use strict"; function r(t, e) { o.a.call(this, t, e) } var o = n(3), i = { FORMAT: { value: "upc_a", writeable: !1 } }; r.prototype = Object.create(o.a.prototype, i), r.prototype.constructor = r, r.prototype._decode = function () { var t = o.a.prototype._decode.call(this); return t && t.code && 13 === t.code.length && "0" === t.code.charAt(0) ? (t.code = t.code.substring(1), t) : null }, e.a = r }, function (t, e) { function n(t, e) { return t[0] = e[0], t[1] = e[1], t[2] = e[2], t[3] = e[3], t } t.exports = n }, function (t, e) { function n() { var t = new Float32Array(4); return t[0] = 1, t[1] = 0, t[2] = 0, t[3] = 1, t } t.exports = n }, function (t, e) { function n(t, e) { var n = e[0], r = e[1], o = e[2], i = e[3], a = n * i - o * r; return a ? (a = 1 / a, t[0] = i * a, t[1] = -r * a, t[2] = -o * a, t[3] = n * a, t) : null } t.exports = n }, function (t, e) { function n(t, e, n) { return t[0] = e[0] * n, t[1] = e[1] * n, t } t.exports = n }, function (t, e) { function n(t, e, n) { var r = e[0], o = e[1]; return t[0] = n[0] * r + n[2] * o, t[1] = n[1] * r + n[3] * o, t } t.exports = n }, function (t, e) { function n(t) { var e = new Float32Array(3); return e[0] = t[0], e[1] = t[1], e[2] = t[2], e } t.exports = n }, function (t, e, n) { function r(t) { var e = -1, n = null == t ? 0 : t.length; for (this.clear(); ++e < n;) { var r = t[e]; this.set(r[0], r[1]) } } var o = n(121), i = n(122), a = n(123), u = n(124), c = n(125); r.prototype.clear = o, r.prototype.delete = i, r.prototype.get = a, r.prototype.has = u, r.prototype.set = c, t.exports = r }, function (t, e, n) { function r(t) { var e = this.__data__ = new o(t); this.size = e.size } var o = n(10), i = n(148), a = n(149), u = n(150), c = n(151), s = n(152); r.prototype.clear = i, r.prototype.delete = a, r.prototype.get = u, r.prototype.has = c, r.prototype.set = s, t.exports = r }, function (t, e, n) { var r = n(4), o = r.Uint8Array; t.exports = o }, function (t, e) { function n(t, e, n) { switch (n.length) { case 0: return t.call(e); case 1: return t.call(e, n[0]); case 2: return t.call(e, n[0], n[1]); case 3: return t.call(e, n[0], n[1], n[2]) }return t.apply(e, n) } t.exports = n }, function (t, e, n) { function r(t, e) { var n = a(t), r = !n && i(t), f = !n && !r && u(t), d = !n && !r && !f && s(t), h = n || r || f || d, p = h ? o(t.length, String) : [], v = p.length; for (var g in t) !e && !l.call(t, g) || h && ("length" == g || f && ("offset" == g || "parent" == g) || d && ("buffer" == g || "byteLength" == g || "byteOffset" == g) || c(g, v)) || p.push(g); return p } var o = n(106), i = n(18), a = n(1), u = n(44), c = n(15), s = n(45), f = Object.prototype, l = f.hasOwnProperty; t.exports = r }, function (t, e) { function n(t, e) { for (var n = -1, r = null == t ? 0 : t.length, o = Array(r); ++n < r;)o[n] = e(t[n], n, t); return o } t.exports = n }, function (t, e) { function n(t, e) { for (var n = -1, r = e.length, o = t.length; ++n < r;)t[o + n] = e[n]; return t } t.exports = n }, function (t, e, n) { var r = n(0), o = Object.create, i = function () { function t() { } return function (e) { if (!r(e)) return {}; if (o) return o(e); t.prototype = e; var n = new t; return t.prototype = void 0, n } }(); t.exports = i }, function (t, e, n) { function r(t, e, n, a, u) { var c = -1, s = t.length; for (n || (n = i), u || (u = []); ++c < s;) { var f = t[c]; e > 0 && n(f) ? e > 1 ? r(f, e - 1, n, a, u) : o(u, f) : a || (u[u.length] = f) } return u } var o = n(89), i = n(127); t.exports = r }, function (t, e, n) { var r = n(116), o = r(); t.exports = o }, function (t, e, n) { function r(t, e) { e = o(e, t); for (var n = 0, r = e.length; null != t && n < r;)t = t[i(e[n++])]; return n && n == r ? t : void 0 } var o = n(13), i = n(23); t.exports = r }, function (t, e) { function n(t, e) { return null != t && e in Object(t) } t.exports = n }, function (t, e, n) { function r(t) { return i(t) && o(t) == a } var o = n(7), i = n(5), a = "[object Arguments]"; t.exports = r }, function (t, e, n) { function r(t) { return !(!a(t) || i(t)) && (o(t) ? p : s).test(u(t)) } var o = n(25), i = n(131), a = n(0), u = n(154), c = /[\\^$.*+?()[\]{}|]/g, s = /^\[object .+?Constructor\]$/, f = Function.prototype, l = Object.prototype, d = f.toString, h = l.hasOwnProperty, p = RegExp("^" + d.call(h).replace(c, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"); t.exports = r }, function (t, e, n) { function r(t) { return a(t) && i(t.length) && !!u[o(t)] } var o = n(7), i = n(26), a = n(5), u = {}; u["[object Float32Array]"] = u["[object Float64Array]"] = u["[object Int8Array]"] = u["[object Int16Array]"] = u["[object Int32Array]"] = u["[object Uint8Array]"] = u["[object Uint8ClampedArray]"] = u["[object Uint16Array]"] = u["[object Uint32Array]"] = !0, u["[object Arguments]"] = u["[object Array]"] = u["[object ArrayBuffer]"] = u["[object Boolean]"] = u["[object DataView]"] = u["[object Date]"] = u["[object Error]"] = u["[object Function]"] = u["[object Map]"] = u["[object Number]"] = u["[object Object]"] = u["[object RegExp]"] = u["[object Set]"] = u["[object String]"] = u["[object WeakMap]"] = !1, t.exports = r }, function (t, e, n) { function r(t) { if (!o(t)) return a(t); var e = i(t), n = []; for (var r in t) ("constructor" != r || !e && c.call(t, r)) && n.push(r); return n } var o = n(0), i = n(40), a = n(143), u = Object.prototype, c = u.hasOwnProperty; t.exports = r }, function (t, e, n) { function r(t, e, n, f, l) { t !== e && a(e, function (a, s) { if (c(a)) l || (l = new o), u(t, e, s, n, r, f, l); else { var d = f ? f(t[s], a, s + "", t, e, l) : void 0; void 0 === d && (d = a), i(t, s, d) } }, s) } var o = n(84), i = n(35), a = n(92), u = n(100), c = n(0), s = n(46); t.exports = r }, function (t, e, n) { function r(t, e, n, r, y, m, x) { var b = t[n], E = e[n], C = x.get(E); if (C) return void o(t, n, C); var O = m ? m(b, E, n + "", t, e, x) : void 0, R = void 0 === O; if (R) { var w = f(E), A = !w && d(E), T = !w && !A && g(E); O = E, w || A || T ? f(b) ? O = b : l(b) ? O = u(b) : A ? (R = !1, O = i(E, !0)) : T ? (R = !1, O = a(E, !0)) : O = [] : v(E) || s(E) ? (O = b, s(b) ? O = _(b) : (!p(b) || r && h(b)) && (O = c(E))) : R = !1 } R && (x.set(E, O), y(O, E, r, m, x), x.delete(E)), o(t, n, O) } var o = n(35), i = n(110), a = n(111), u = n(112), c = n(126), s = n(18), f = n(1), l = n(158), d = n(44), h = n(25), p = n(0), v = n(159), g = n(45), _ = n(163); t.exports = r }, function (t, e, n) { function r(t, e) { return o(t, e, function (e, n) { return i(t, n) }) } var o = n(102), i = n(157); t.exports = r }, function (t, e, n) { function r(t, e, n) { for (var r = -1, u = e.length, c = {}; ++r < u;) { var s = e[r], f = o(t, s); n(f, s) && i(c, a(s, t), f) } return c } var o = n(93), i = n(104), a = n(13); t.exports = r }, function (t, e, n) { function r(t, e) { return a(i(t, e, o), t + "") } var o = n(43), i = n(41), a = n(42); t.exports = r }, function (t, e, n) { function r(t, e, n, r) { if (!u(t)) return t; e = i(e, t); for (var s = -1, f = e.length, l = f - 1, d = t; null != d && ++s < f;) { var h = c(e[s]), p = n; if (s != l) { var v = d[h]; p = r ? r(v, h, d) : void 0, void 0 === p && (p = u(v) ? v : a(e[s + 1]) ? [] : {}) } o(d, h, p), d = d[h] } return t } var o = n(36), i = n(13), a = n(15), u = n(0), c = n(23); t.exports = r }, function (t, e, n) { var r = n(155), o = n(37), i = n(43), a = o ? function (t, e) { return o(t, "toString", { configurable: !0, enumerable: !1, value: r(e), writable: !0 }) } : i; t.exports = a }, function (t, e) { function n(t, e) { for (var n = -1, r = Array(t); ++n < t;)r[n] = e(n); return r } t.exports = n }, function (t, e, n) { function r(t) { if ("string" == typeof t) return t; if (a(t)) return i(t, r) + ""; if (u(t)) return f ? f.call(t) : ""; var e = t + ""; return "0" == e && 1 / t == -c ? "-0" : e } var o = n(11), i = n(88), a = n(1), u = n(27), c = 1 / 0, s = o ? o.prototype : void 0, f = s ? s.toString : void 0; t.exports = r }, function (t, e) { function n(t) { return function (e) { return t(e) } } t.exports = n }, function (t, e, n) { function r(t) { var e = new t.constructor(t.byteLength); return new o(e).set(new o(t)), e } var o = n(85); t.exports = r }, function (t, e, n) { (function (t) { function r(t, e) { if (e) return t.slice(); var n = t.length, r = s ? s(n) : new t.constructor(n); return t.copy(r), r } var o = n(4), i = "object" == typeof e && e && !e.nodeType && e, a = i && "object" == typeof t && t && !t.nodeType && t, u = a && a.exports === i, c = u ? o.Buffer : void 0, s = c ? c.allocUnsafe : void 0; t.exports = r }).call(e, n(29)(t)) }, function (t, e, n) { function r(t, e) { var n = e ? o(t.buffer) : t.buffer; return new t.constructor(n, t.byteOffset, t.length) } var o = n(109); t.exports = r }, function (t, e) { function n(t, e) { var n = -1, r = t.length; for (e || (e = Array(r)); ++n < r;)e[n] = t[n]; return e } t.exports = n }, function (t, e, n) { function r(t, e, n, r) { var a = !n; n || (n = {}); for (var u = -1, c = e.length; ++u < c;) { var s = e[u], f = r ? r(n[s], t[s], s, n, t) : void 0; void 0 === f && (f = t[s]), a ? i(n, s, f) : o(n, s, f) } return n } var o = n(36), i = n(21); t.exports = r }, function (t, e, n) { var r = n(4), o = r["__core-js_shared__"]; t.exports = o }, function (t, e, n) { function r(t) { return o(function (e, n) { var r = -1, o = n.length, a = o > 1 ? n[o - 1] : void 0, u = o > 2 ? n[2] : void 0; for (a = t.length > 3 && "function" == typeof a ? (o--, a) : void 0, u && i(n[0], n[1], u) && (a = o < 3 ? void 0 : a, o = 1), e = Object(e); ++r < o;) { var c = n[r]; c && t(e, c, r, a) } return e }) } var o = n(103), i = n(128); t.exports = r }, function (t, e) { function n(t) { return function (e, n, r) { for (var o = -1, i = Object(e), a = r(e), u = a.length; u--;) { var c = a[t ? u : ++o]; if (n(i[c], c, i) === !1) break } return e } } t.exports = n }, function (t, e, n) { function r(t) { return a(i(t, void 0, o), t + "") } var o = n(156), i = n(41), a = n(42); t.exports = r }, function (t, e, n) { function r(t) { var e = a.call(t, c), n = t[c]; try { t[c] = void 0; var r = !0 } catch (t) { } var o = u.call(t); return r && (e ? t[c] = n : delete t[c]), o } var o = n(11), i = Object.prototype, a = i.hasOwnProperty, u = i.toString, c = o ? o.toStringTag : void 0; t.exports = r }, function (t, e) { function n(t, e) { return null == t ? void 0 : t[e] } t.exports = n }, function (t, e, n) { function r(t, e, n) { e = o(e, t); for (var r = -1, f = e.length, l = !1; ++r < f;) { var d = s(e[r]); if (!(l = null != t && n(t, d))) break; t = t[d] } return l || ++r != f ? l : !!(f = null == t ? 0 : t.length) && c(f) && u(d, f) && (a(t) || i(t)) } var o = n(13), i = n(18), a = n(1), u = n(15), c = n(26), s = n(23); t.exports = r }, function (t, e, n) { function r() { this.__data__ = o ? o(null) : {}, this.size = 0 } var o = n(16); t.exports = r }, function (t, e) { function n(t) { var e = this.has(t) && delete this.__data__[t]; return this.size -= e ? 1 : 0, e } t.exports = n }, function (t, e, n) { function r(t) { var e = this.__data__; if (o) { var n = e[t]; return n === i ? void 0 : n } return u.call(e, t) ? e[t] : void 0 } var o = n(16), i = "__lodash_hash_undefined__", a = Object.prototype, u = a.hasOwnProperty; t.exports = r }, function (t, e, n) { function r(t) { var e = this.__data__; return o ? void 0 !== e[t] : a.call(e, t) } var o = n(16), i = Object.prototype, a = i.hasOwnProperty; t.exports = r }, function (t, e, n) { function r(t, e) { var n = this.__data__; return this.size += this.has(t) ? 0 : 1, n[t] = o && void 0 === e ? i : e, this } var o = n(16), i = "__lodash_hash_undefined__"; t.exports = r }, function (t, e, n) { function r(t) { return "function" != typeof t.constructor || a(t) ? {} : o(i(t)) } var o = n(90), i = n(39), a = n(40); t.exports = r }, function (t, e, n) { function r(t) { return a(t) || i(t) || !!(u && t && t[u]) } var o = n(11), i = n(18), a = n(1), u = o ? o.isConcatSpreadable : void 0; t.exports = r }, function (t, e, n) { function r(t, e, n) { if (!u(n)) return !1; var r = typeof e; return !!("number" == r ? i(n) && a(e, n.length) : "string" == r && e in n) && o(n[e], t) } var o = n(17), i = n(24), a = n(15), u = n(0); t.exports = r }, function (t, e, n) { function r(t, e) { if (o(t)) return !1; var n = typeof t; return !("number" != n && "symbol" != n && "boolean" != n && null != t && !i(t)) || (u.test(t) || !a.test(t) || null != e && t in Object(e)) } var o = n(1), i = n(27), a = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, u = /^\w*$/; t.exports = r }, function (t, e) { function n(t) { var e = typeof t; return "string" == e || "number" == e || "symbol" == e || "boolean" == e ? "__proto__" !== t : null === t } t.exports = n }, function (t, e, n) { function r(t) { return !!i && i in t } var o = n(114), i = function () { var t = /[^.]+$/.exec(o && o.keys && o.keys.IE_PROTO || ""); return t ? "Symbol(src)_1." + t : "" }(); t.exports = r }, function (t, e) { function n() { this.__data__ = [], this.size = 0 } t.exports = n }, function (t, e, n) { function r(t) { var e = this.__data__, n = o(e, t); return !(n < 0) && (n == e.length - 1 ? e.pop() : a.call(e, n, 1), --this.size, !0) } var o = n(12), i = Array.prototype, a = i.splice; t.exports = r }, function (t, e, n) { function r(t) { var e = this.__data__, n = o(e, t); return n < 0 ? void 0 : e[n][1] } var o = n(12); t.exports = r }, function (t, e, n) { function r(t) { return o(this.__data__, t) > -1 } var o = n(12); t.exports = r }, function (t, e, n) { function r(t, e) { var n = this.__data__, r = o(n, t); return r < 0 ? (++this.size, n.push([t, e])) : n[r][1] = e, this } var o = n(12); t.exports = r }, function (t, e, n) { function r() { this.size = 0, this.__data__ = { hash: new o, map: new (a || i), string: new o } } var o = n(83), i = n(10), a = n(33); t.exports = r }, function (t, e, n) { function r(t) { var e = o(this, t).delete(t); return this.size -= e ? 1 : 0, e } var o = n(14); t.exports = r }, function (t, e, n) { function r(t) { return o(this, t).get(t) } var o = n(14); t.exports = r }, function (t, e, n) { function r(t) { return o(this, t).has(t) } var o = n(14); t.exports = r }, function (t, e, n) { function r(t, e) { var n = o(this, t), r = n.size; return n.set(t, e), this.size += n.size == r ? 0 : 1, this } var o = n(14); t.exports = r }, function (t, e, n) { function r(t) { var e = o(t, function (t) { return n.size === i && n.clear(), t }), n = e.cache; return e } var o = n(160), i = 500; t.exports = r }, function (t, e) { function n(t) { var e = []; if (null != t) for (var n in Object(t)) e.push(n); return e } t.exports = n }, function (t, e, n) { (function (t) { var r = n(38), o = "object" == typeof e && e && !e.nodeType && e, i = o && "object" == typeof t && t && !t.nodeType && t, a = i && i.exports === o, u = a && r.process, c = function () { try { return u && u.binding && u.binding("util") } catch (t) { } }(); t.exports = c }).call(e, n(29)(t)) }, function (t, e) { function n(t) { return o.call(t) } var r = Object.prototype, o = r.toString; t.exports = n }, function (t, e) { function n(t, e) { return function (n) { return t(e(n)) } } t.exports = n }, function (t, e) { function n(t) { var e = 0, n = 0; return function () { var a = i(), u = o - (a - n); if (n = a, u > 0) { if (++e >= r) return arguments[0] } else e = 0; return t.apply(void 0, arguments) } } var r = 800, o = 16, i = Date.now; t.exports = n }, function (t, e, n) { function r() { this.__data__ = new o, this.size = 0 } var o = n(10); t.exports = r }, function (t, e) { function n(t) { var e = this.__data__, n = e.delete(t); return this.size = e.size, n } t.exports = n }, function (t, e) { function n(t) { return this.__data__.get(t) } t.exports = n }, function (t, e) { function n(t) { return this.__data__.has(t) } t.exports = n }, function (t, e, n) { function r(t, e) { var n = this.__data__; if (n instanceof o) { var r = n.__data__; if (!i || r.length < u - 1) return r.push([t, e]), this.size = ++n.size, this; n = this.__data__ = new a(r) } return n.set(t, e), this.size = n.size, this } var o = n(10), i = n(33), a = n(34), u = 200; t.exports = r }, function (t, e, n) { var r = n(142), o = /^\./, i = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, a = /\\(\\)?/g, u = r(function (t) { var e = []; return o.test(t) && e.push(""), t.replace(i, function (t, n, r, o) { e.push(r ? o.replace(a, "$1") : n || t) }), e }); t.exports = u }, function (t, e) { function n(t) { if (null != t) { try { return o.call(t) } catch (t) { } try { return t + "" } catch (t) { } } return "" } var r = Function.prototype, o = r.toString; t.exports = n }, function (t, e) { function n(t) { return function () { return t } } t.exports = n }, function (t, e, n) { function r(t) { return (null == t ? 0 : t.length) ? o(t, 1) : [] } var o = n(91); t.exports = r }, function (t, e, n) { function r(t, e) { return null != t && i(t, e, o) } var o = n(94), i = n(120); t.exports = r }, function (t, e, n) { function r(t) { return i(t) && o(t) } var o = n(24), i = n(5); t.exports = r }, function (t, e, n) { function r(t) { if (!a(t) || o(t) != u) return !1; var e = i(t); if (null === e) return !0; var n = l.call(e, "constructor") && e.constructor; return "function" == typeof n && n instanceof n && f.call(n) == d } var o = n(7), i = n(39), a = n(5), u = "[object Object]", c = Function.prototype, s = Object.prototype, f = c.toString, l = s.hasOwnProperty, d = f.call(Object); t.exports = r }, function (t, e, n) { function r(t, e) { if ("function" != typeof t || null != e && "function" != typeof e) throw new TypeError(i); var n = function () { var r = arguments, o = e ? e.apply(this, r) : r[0], i = n.cache; if (i.has(o)) return i.get(o); var a = t.apply(this, r); return n.cache = i.set(o, a) || i, a }; return n.cache = new (r.Cache || o), n } var o = n(34), i = "Expected a function"; r.Cache = o, t.exports = r }, function (t, e, n) { var r = n(101), o = n(117), i = o(function (t, e) { return null == t ? {} : r(t, e) }); t.exports = i }, function (t, e) { function n() { return !1 } t.exports = n }, function (t, e, n) { function r(t) { return o(t, i(t)) } var o = n(113), i = n(46); t.exports = r }, function (t, e, n) { function r(t) { return null == t ? "" : o(t) } var o = n(107); t.exports = r }, function (t, e, n) { t.exports = n(48) }]) });

$(window).resize(function () {
    //$('.dataTable').DataTable().columns.adjust().responsive.recalc();
});

function cambioTamanioPed() {
    var windowWidth = $(window).width();
    var v_tabla = $('#tablaPedidos').dataTable();
    //var settings = v_tabla.fnSettings();
    var botoneraPedido = $('#botoneraPedido');
    //var boton = $('#btnNuevoPedido, #bultoDetail, #bultoNuevo, #bultoNing, #bultoSelec, #btnClientSearch');
    var botonSM = $('.boton-small');
    if (windowWidth < 400) {
        //settings._iDisplayLength = 6;
        botoneraPedido.addClass('botoneraInf');
        //boton.removeClass('boton').addClass('boton-small');
    } else if (windowWidth > 400) {
        //botoneraPedido.removeClass('botoneraInf');
        //settings._iDisplayLength = 8;
        botonSM.removeClass('boton-small').addClass('boton');
    }
    v_tabla.fnDraw();
}

function cambioTamanioMenu() {
    var windowWidth = $(window).width();
    var carrusel = $('.item-carrusel-3');
    var carruselSM = $('.item-carrusel-2');

    if (windowWidth < 400) {
        carrusel.removeClass('item-carrusel-3').addClass('item-carrusel-2');
        //$('.modal-dialog').height('100%');
        //$('.modal-dialog > .modal-content').height('100%');
    } else if (windowWidth > 400) {
        carruselSM.removeClass('item-carrusel-2').addClass('item-carrusel-3');

        //$('.modal-dialog > .modal-content').height('410px !important');
    }
}

function cambioTamanioInventario() {
    var v_windowWidth = $(window).width();
    var v_input = $('#buscaAlmacen div');
    setFieldsetSize(v_windowWidth);
    setFieldSize(v_windowWidth);
    if (v_windowWidth < 400) {
        //$('#Entradas #lb-cant, #Salidas #lb-cant').removeClass('col-xs-5').addClass('col-xs-3');

        //$('#tipoMovimiento label').removeClass('col-xs-4').addClass('col-xs-6');
        //$('#tipoMovimiento div').removeClass('col-xs-7').addClass('col-xs-5');

        //$('#buscaAlmacen label').removeClass('col-xs-2').addClass('col-xs-4');
        //$('#buscaAlmacen div').removeClass('col-xs-8').addClass('col-xs-6');

        $('#articulo .fieldset').removeClass('col-xs-6');

    } else if (v_windowWidth > 400) {
        //    $('#Entradas #lb-cant, #Salidas #lb-cant').removeClass('col-xs-3').addClass('col-xs-5');;

        //    $('#tipoMovimiento label').removeClass('col-xs-6').addClass('col-xs-4');
        //    $('#tipoMovimiento div').removeClass('col-xs-5').addClass('col-xs-7');

        //    $('#buscaAlmacen label').removeClass('col-xs-4').addClass('col-xs-2');
        //    $('#buscaAlmacen div').removeClass('col-xs-6').addClass('col-xs-8');

        $('#articulo .fieldset').addClass('col-xs-6');


    }
}

function cambioTamanioConsulta() {

    var v_tabla = $('#tablaPedidos');
    var v_fields = $('#consulta #type, #consulta #copy, #consulta #existField, #consulta #agrupField');

    v_tabla.prop("width", "100%");
    v_fields.css({ "padding": 0 });
}

function cambioTamanioImpresion() {
    //var v_windowWidth = $(window).width();
    //var v_inputs = $('.campSupUbi input').parent('div');
    //var v_labels = $('.campSupUbi label');

    //if (v_windowWidth < 400) {
    //    v_inputs.removeClass('col-xs-8').addClass('col-xs-12');
    //    v_labels.removeClass('col-xs-4 control-label').addClass('col-xs-12 label-form');
    //} else if (v_windowWidth > 400) {
    //    v_inputs.removeClass('col-xs-12').addClass('col-xs-8');
    //    v_labels.removeClass('col-xs-12 label-form').addClass('col-xs-4 control-label');
    //}
}
var v_fecha;
var v_fecha_string;

$(document).ready(function () {
});

function menuDatePicker() {
    $('#menuDate div input').datepicker({
        format: Globalize($("html").attr("lang")).culture().calendar.patterns.d.toLowerCase(),
        language: Globalize($("html").attr("lang")).cultureSelector.split('-')[0],
        autoclose: true,
        orientation: "bottom right",
        useLocalTimezone: false,
        widgetPositioning: {
            horizontal: 'right',
            vertical: 'bottom'
        }
    });


    $('#menuDate div input > .form-control').prop('disabled', true);
    var dateShowing = false;
    $('#menuDate div input').datepicker()
        .on('hide', function (e) {
            dateShowing = false;

        });
    $('li#menuDate').on('click', function () {
        if (typeof data !== 'undefined') {
            if (dateShowing) {
                $('#menuDate div input').datepicker('hide');
            } else {
                $('#menuDate div input').datepicker('show');
                dateShowing = true;
            }

        }
    });
}

function dateToString(v_date) {
    var format = Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase();
    return moment(new Date(v_date)).format(format);
}

function updateDatePicker(v_date) {
    $('#menuDate div input').datepicker('setDate', new Date(v_date));
}

function getDateAlb(albaran) {
    var v_date = albaran ? albaran.F_ALBARAN_HID : new Date();
    return v_date;
}

function fechaAlbaran(fecha_string) {
    var date;
    if (fecha_string === "") {
        date = new Date();
    } else {
        date = new Date(fecha_string);
    }
    return date;
}

function getFechaAlbaran() {
    var d = $('#menuDate div input').datepicker('getDate');
    console.log(d);
    return new Date(d.getTime() - d.getTimezoneOffset() * 60000).toJSON();
}

var Resources;
var json;

$(document).ready(function () {
    // Resize
    var body = this.body;
    var height = body.offsetHeight;
    this.defaultView.onresize = function () {
        var tables = $('.dataTable');
        tables.map(function (i) {
            if (tables[i].id && $(tables[i]).is(":visible")) {
                SpyFilter().applyFilters('#' + tables[i].id);
            }
        });
        var newHeight = body.offsetHeight;
        // Height Resize
        if (newHeight !== height) {
            height = newHeight;

        }
    };

    // --Resize

    cambioTamanioMenu();
    cameraFunction();
    //$('.disabled').prop('disabled', true);
    //if ($('#submenu_area').val() !== "") {
    //    setTimeout(function () {
    //        var anchor = document.createElement('a');
    //        anchor.id = "back";
    //        var span = document.createElement('span');
    //        span.classList = "glyphicon glyphicon-circle-arrow-left";
    //        var title = $('#title #tituloPrincipal');
    //        $(span).appendTo(anchor);
    //        title.appendTo(anchor);
    //        $(anchor).appendTo($('#title'));

    $('#atras').on('click', function () {
        window.history.back();
    });
    $('#salir').on('click', function () {
        lanzarConfirmacion('¿Esta seguro de querer cerrar sesión?', function () {
            //window.location.href = Router.action("Login", "Logout");
            window.location.href = "Login/Logout";
        });
        //window.location.href = Router.action("Login", "Logout");
    });
    //    }, 0);
    //$('#title h2').prepend('<a><span id="back" class="glyphicon glyphicon-circle-arrow-left"></span></a>');
    //}

    toUpper();
    this.tabulado = tabulado();
    autoselect();
});

function toUpper() {
    $('.code').on('blur', function () {
        $(this).val($(this).val().toUpperCase());
    });
    $('.code').on('input', function (e) {
        //var input = $(this);
        var v_cursor = $(this)[0].selectionStart;
        $(this).val($(this).val().toUpperCase());
        $(this)[0].selectionStart = $(this)[0].selectionEnd = v_cursor;
    });
}


$(window).resize(function () {
    cambioTamanioMenu();
    console.log("Resize")


});

function dialog(dialog, href, table, func) {

    $.ajax({
        url: href,
        cache: false,
        dataType: 'json',
        success: function (response, status, xhr) {
            if (response.Ok) {
                $(dialog).html(response.Mensaje);
                showDialog(dialog);
                if (table) {
                    createTable(table);
                }

                if (func) {
                    func();
                }

            } else {
                lanzarMensaje(response.Ok, response.Mensaje);
            }
            $('.disabled').prop('disabled', true);
        }
    });
    return false;
}

function dialogAuto(dialog, href, table, func) {
    $.ajax({
        url: href,
        cache: false,
        dataType: 'json',
        success: function (response, status, xhr) {
            if (response.Ok) {
                $(dialog).html(response.Mensaje);
                showDialog(dialog);
                if (table) {
                    $(dialog + " table").prop("id", table.split('#')[1]);
                    createTable(table);
                }

                if (func) {
                    func();
                }
                toUpper();
            } else {
                lanzarMensaje(response.Ok, response.Mensaje);
            }
            $('.disabled').prop('disabled', true);
        }
    });

    return false;
}

function dialogMessage(href, message) {
    var dialog = "#dialogMessage";
    showDialog(dialog);
    var error = "{data:" + JSON.stringify(error) + "}";
    $(dialog).load(href, error);
}
/**
 * Añade la característica de la selección de filas a la tabla indicada.
 * 
 * string table : "#ejemplo"
 * @param {string} table ID de la tabla
 * @param {boolean} multipleSelection Permitir seleccionar varios campos a la vez
 */
function selectRow(table, multipleSelection) {
    var v_datatable = $(table).dataTable();

    $(table).on("mousedown", "tr", function () {
        var v_table = $(table).DataTable();
        if (v_table.rows().count() !== 0) {
            if (multipleSelection) {
                $(this).toggleClass('selected');
            } else {
                v_table.row('.selected').nodes().to$().removeClass('selected');
                $(this).addClass('selected');
            }
        }
    });

    if (table !== "#empresas") {
        var firstRow = v_datatable.find('tbody tr:first');
        //firstRow.trigger('mousedown');
        firstRow.addClass('selected');
    }
}

function moveFilter(table, searchField) {
    //setTimeout(function () {
    var modal = $(table + "_filter").parents('.modal-bodyContainer')[0];
    $(table + "_filter label").addClass('col-xs-12');
    $(table + "_filter").prependTo(modal);
    //}, 0);
    searchField ? $(table + "_filter").css('display', 'table-row') : $(table + "_filter").hide();
}
/**
 * Lanza una ventana modal con un mensaje, que al aceptar lanzará la función introducida.
 * Si el mensaje NO es de error, redirigirá al url indicado (redirectTo)
 * @param {boolean} Ok Tipo de mensaje  -  True => Mensaje  \\  False => Error
 * @param {string} Message Mensaje a mostrar
 * @param {string} RedirectTo URL de redireccion. Esto ocurre al pulsar el botón aceptar.
 * @param {function} functionName Función lanzada una vez se haga click en el botón aceptar.
 */
function lanzarMensajeRedirect(Ok, Message, RedirectTo, functionName) {
    showDialog('#dialogMessage');
    $('#dialogMessage #messageAccept').focus();
    $('#dialogMessage #messageAccept').unbind();
    var close = true;
    $('#dialogMessage #messageAccept').on('keydown click', function (e) {
        if (e.which === 13) {
            close = false;
            $('#dialogMessage #messageAccept').on('keyup', function (e) {
                if (e.which === 13) {
                    close = true;
                    closeMessageDialog();
                }
            });
        } else if (e.which === 1 && close === true) {
            closeMessageDialog();
        }
    });

    function closeMessageDialog() {
        $('#dialogMessage').modal('hide');
        $('.modal-header').css('background-color', '#2a75c2');
        if (functionName) {
            functionName();
        }

    }

    //$('.modal-close').on('click', function () {
    //    closeMessageDialog();
    //});

    Ok ? $('#dialogMessage .modal-title').html(Resources.title_message) : $('#dialogMessage .modal-title').html(Resources.title_error);
    Ok ? $('.modal-header').css('background-color', '#2a75c2') : $('.modal-header').css('background-color', '#b00020');
    $('#dialogMessage .txtMessage').html('<div>' + Message.replace(/\n/g, '<br />') + '</div>');

    // Busca la ventana modal con mayor zindex y suma 1
    var zindex = eval($($('.modal')[$('.modal').length - 1]).css("z-index")) + 1;
    $($('.modal-backdrop')[$('.modal-backdrop').length - 1]).css("z-index", zindex);
    $('#dialogMessage').css("z-index", eval(zindex) + 1);
    if (RedirectTo && Ok) {
        $('#dialogMessage .close, #dialogMessage, #dialogMessage #messageAccept').on('click', function () {
            window.location.href = RedirectTo;
        });
        $('.modal-body, .modal-header').on("click", function (e) {
            e.stopPropagation();
            return false;
        });
    }
}


/**
 * Lanza un mensaje de confirmación; Si se acepta, se lanzará la función indicada.
 * @param {String} Message Mensaje a mostrar
 * @param {function} functionAccept Función lanzada una vez se haga click en el botón aceptar.
 * @param {function} functionCancel Función lanzada una vez se haga click en el botón cancelar.
 */
function lanzarConfirmacion(Message, functionAccept, functionCancel) {
    showDialog('#dialogConfirm');
    $('#dialogConfirm #messageAccept').unbind();
    $('#dialogConfirm #messageAccept').off();
    $('#dialogConfirm #messageAccept').on('click', function () {
        $('#dialogConfirm').modal('hide');
    });

    $('#dialogConfirm .txtMessage').html('<div>' + Message.replace(/\n/g, '<br />') + '</div>');
    var zindex = eval($($('.modal')[$('.modal').length - 1]).css("z-index")) + 1;
    $($('.modal-backdrop')[$('.modal-backdrop').length - 1]).css("z-index", zindex);
    $('#dialogConfirm').css("z-index", eval(zindex) + 1);

    $('#btnConfirm, #btnCancel').unbind();
    //$('#btnConfirm').off();

    //Encapsulamos la función para que en el caso que utilicen "this" no cojan el botón de confirmar.
    $('#btnConfirm').on('click', function () { functionAccept(); });
    if (functionCancel)
        $('#btnCancel').on('click', function () { functionCancel(); });
    $('#btnConfirm, #btnCancel').on('click', function () {
        closeModal('#dialogConfirm');
    });
}


/**
 * Lanza una función u otra dependiendo del Ok recibido en response.
 * *Si el response tiene un mensaje se mostrará en pantalla ANTES de lanzarse la función.
 * *La función se lanzará al cerrar el dialogo del mensaje.
 * @param {any} response Objeto de respuesta del API => {Ok: false, Mensaje: <null || ""> , Objeto: {}}
 * @param {function} successFn Función si la respuesta es Ok
 * @param {function} errorFn Función si la respuesta NO es Ok
 * @param {boolean} bSuccessMessage False => Lanza una ventana de información || True => Muestra el mensaje en el título para no detener al usuario.
 */
function handleResponse(response, successFn, errorFn, bSuccessMessage) {
    var fn = response.Ok ? successFn : errorFn;
    if (!response.Ok || (response.Mensaje && !bSuccessMessage)) {
        lanzarMensaje(response.Ok, response.Mensaje, fn);
    } else if (response.Mensaje && bSuccessMessage) {
        successMessage(response.Mensaje);
        if (fn) fn();
    }
    else if (fn)
        fn();
}
function lanzarMensaje(Ok, Message, functionName) {
    lanzarMensajeRedirect(Ok, Message, null, functionName);
}

function createTable(table, displayLength, zeroRecordsMessage, responsive, multipleSelection) {
    if (!displayLength) {
        var windowWidth = $(window).width();
        displayLength = windowWidth < 400 ? 4 : 7;
    }
    if (!zeroRecordsMessage) {
        zeroRecordsMessage = Resources.zeroRecordsMessage;
    }
    $(table).dataTable({
        "ordering": false,
        "autoWidth": true,
        responsive: responsive,
        "displayLenght": 1,
        "pagingType": "simple",
        scroller: false,
        "scrollY": true,
        "scrollCollapse": true,
        "scrollX": false,
        "bInfo": false,
        "paginate": {
            "next": '&#8594;', // '→'
            "previous": '&#8592;' // '←' 
        },
        "deferRender": false,
        "aoColumnDefs": [
            { "sType": "numeric" }
        ],
        "drawCallback": function () {
            $('.dataTable').each(function (e) {
                //applyFilters(this)
                //$(this).DataTable().columns.adjust().responsive.recalc();
            });
            navigateArrows(table);
        },
        "initComplete": function (settings, json) {
            SpyFilter().applyFilters(table);
        },
        "language": {
            "sProcessing": "Procesando...",
            "sZeroRecords": "No se encontraron resultados",
            "sEmptyTable": zeroRecordsMessage,
            "sInfo": Resources.table_sinfo,
            "sInfoEmpty": Resources.table_sinfo_empty,
            "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
            "sInfoPostFix": "",
            "sSearch": Resources.table_search + ":",
            "sUrl": "",
            "sInfoThousands": ",",
            "sLoadingRecords": Resources.table_loading_records,
            "oPaginate": {
                "sFirst": "Primero",
                "sLast": "Último",
                "sNext": '<i class="glyphicon glyphicon-arrow-right gi-lg"/>',
                "sPrevious": '<i class="glyphicon glyphicon-arrow-left gi-lg"/>'
            },
            "oAria": {
                "sSortAscending": ": Activar para ordenar la columna de manera ascendente",
                "sSortDescending": ": Activar para ordenar la columna de manera descendente"
            }
        }
    }),
        $('.dataTable').each(function (e) {
            //$(this).DataTable().columns.adjust();
        });
    $('.dataTables_filter input').addClass('col-xs-7 input-xs');
    selectRow(table, multipleSelection);
    moveFilter(table);
}

/**
 * Genera una tabla a partir de un JSON:
 * 
 * Ejemplo: 
 * var table = "#ejemplo";
 * var data = [{ID: 1, Art: "Art1"}, {ID: 2, Art: "Art2"}, ...];
 * 
 * // La clave de data debe coincidir con la id de la columna
 * var columns = [
 *      generateColumn('ID', 'ID', true),              
 *      generateColumn('Art', 'Articulo', true)
 *  ];       
 * 
 * // Registros a mostrar
 * var displayLength = 6;   
 * 
 * var zeroRecordsMessage = "No se encuentran artículos";
 * 
 * var columnsDefs = []   (https://datatables.net/reference/option/columnDefs)
 * 
 * var responsive = true;
 * 
 * // Se lanza cada vez que se pinta la tabla
 * var drawCallBackFN = function () {}
 * @param {string} table ID de la tabla
 * @param {JSON} data Array o JSON de registros a mostrar en la tabla
 * @param {Array} columns Array de columnas a mostrar en la tabla
 * @param {number} displayLength Número de registros a mostrar (Actualmente no utilizado por el alto dinámico de las tablas)
 * @param {string} zeroRecordsMessage Mensaje a mostrar en caso de no tener registros
 * @param {Array<JSON>} columnDefs Definiciones de columnas: https://datatables.net/reference/option/columnDefs
 * @param {boolean} responsive Tablas responsive (Actualmente no se utiliza)
 * @param {function} drawCallbackFn Funcion que se llama cada vez que se modifica la tabla
 * @param {boolean} searchField Mostrar campo de búsqueda
 * @param {boolean} multipleSelection Seleccionar un registro no quita la seleccion del resto. Seleccionar un registro ya seleccionado, quita la seleccion de este.
 * @param {Array} orderDef Indica el orden inicial de las columnas. 
 */
function createTableJson(table, data, columns, displayLength, zeroRecordsMessage, columnDefs, responsive, drawCallbackFn, searchField, multipleSelection, orderDef) {
    responsive = !responsive ? true : responsive;

    var ordering = orderDef ? true : false;

    if (!zeroRecordsMessage) {
        zeroRecordsMessage = Resources.table_no_data;
    }
    if (!drawCallbackFn) {
        drawCallbackFn = function () { };
    }
    console.log(table);
    $(table)
        .on('error.dt', function (e, settings, techNote, message) {
            lanzarMensaje(false, "Ha ocurrido un error de DT: \n\n" + message);
        })
        .dataTable({
            "ordering": ordering,
            "order": orderDef,
            "aaData": data,
            "autoWidth": false,
            "aoColumns": columns,
            "columnDefs": columnDefs,
            "displayLenght": 1,
            "responsive": false,
            "pagingType": "simple",
            "scrollY": false,
            "scrollCollapse": true,
            "scrollX": false,
            "deferRender": true,
            "bInfo": false,
            paginate: {
                next: '&#8594;', // or '→'
                previous: '&#8592;' // or '←' 
            },
            "drawCallback": function () {
                navigateArrows(table);
                drawCallbackFn();
            },
            "initComplete": function (settings, json) {
                SpyFilter().applyFilters(table);
            },
            "fnRowCallback": function (nRow, aData, iDisplayIndex) {
                //$(table).DataTable().columns.adjust().responsive.rebuild().responsive.recalc();
                return nRow;
            },
            "language": {
                "sProcessing": "Procesando...",
                "sLengthMenu": Resources.table_length_menu,
                "sZeroRecords": "No se encontraron resultados",
                "sEmptyTable": zeroRecordsMessage,
                "sInfo": Resources.table_sinfo,
                "sInfoEmpty": Resources.table_sinfo_empty,
                "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
                "sInfoPostFix": "",
                "sSearch": Resources.table_search + ":",
                "sUrl": "",
                "sInfoThousands": ",",
                "sLoadingRecords": Resources.table_loading_records,
                "oPaginate": {
                    "sFirst": "Primero",
                    "sLast": "Último",
                    "sNext": '<i class="glyphicon glyphicon-arrow-right gi-2x"/>',
                    "sPrevious": '<i class="glyphicon glyphicon-arrow-left gi-2x"/>'
                },
                "oAria": {
                    "sSortAscending": ": Activar para ordenar la columna de manera ascendente",
                    "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                }
            }
        });
    $('.dataTables_filter input').addClass('pull-right form-control input-xs');
    $(table).DataTable().page.len(1).draw();
    console.log($(table));
    selectRow(table, multipleSelection);
    moveFilter(table, searchField);
}

var v_code;
function obtenerCodBarras(JQInput) {
    v_code = leerEtiqueta(JQInput.val());
}

function getToken() {
    redirectToLogin();
    var v_token = sessionStorage.getItem('token');
    sessionStorage.setItem('token', v_token);
    return v_token;
}

function validationError(message) {
    //lanzarMensajeRedirect(true, message, Router.action('Login', 'Logout'));
    lanzarMensajeRedirect(true, message, "Login/Logout");
}
function redirectToLogin() {
    //if (!sessionStorage.getItem('token') && window.location.pathname !== Router.action('Login', 'Login')) {
    if (!sessionStorage.getItem('token') && window.location.pathname !== "Login/Login") {
        var message = "La sesión ha expirado";
        validationError(message);
    }
}

/**
 * @param {string} dialog ID del dialogo a cerrar.
 */
function closeModal(dialog) {
    $(dialog).modal('hide');
}

//Inicia la pantalla de carga
function startLoading() {
    $('#loadingScreen').show();
}

//Finaliza la pantalla de carga
function completedLoading() {
    $('#loadingScreen').hide();
}


/**
 * Función que genera una llamada Ajax a un Api
 * @param {string} url URL de llamada
 * @param {string} method Método de la llamada
 * @param {JSON} data Datos a enviar al API ({emp_cod: 'CTI', ...})
 * @param {function} successFunction Función que se lanzará al obtener datos desde el API (devuelve response)
 */
function apiGeneral(url, method, data, successFunction) {
    var authorizationToken = getToken();

    if (url.charAt(0) === "/")
        url = url.slice(1, url.length);


    var ajaxSettings = {
        method: method,
        url: v_apiBaseUrl + url,
        headers: {
            app: "RF",
            sid: authorizationToken
        },
        beforeSend: startLoading,
        cache: false,
        complete: completedLoading,
        success: function (response) {
            // En caso de que se haya accedido al API, ejecutará la funcion con el objeto devuelto del mismo.
            successFunction(response);
            llamado = false;
        },
        dataType: "json",
        error: function (xhr, status, error) {
            completedLoading();
            switch (xhr.status) {
                case 401:
                    reLog(
                        function () { apiGeneral(url, method, data, successFunction, beforeSendFunction, completeFunction); }
                    );
                    break;
                case 403:
                    lanzarMensaje(false, error, function () { window.history.back(); });
                    break;
                default:
                    lanzarMensaje(false, error);
                    break;
            }
            llamado = false;
        }
    };

    if (method === "POST" || method === "PUT") {
        ajaxSettings.contentType = "application/json";
        ajaxSettings.data = JSON.stringify(data);
        if (method === "POST")
            ajaxSettings.processData = false;
    }
    else {
        ajaxSettings.data = data;
    }

    $.ajax(ajaxSettings);

}

function showDialog(dialog) {
    $(dialog).modal({
        backdrop: 'static',
        keyboard: false
    });
    $(dialog).css('display', "table");
}

/**
 * Vincula un elemento del DOM a una función
 * 
 * Ej: 
 * ---------------------------
 * var element = document.getElementById('ejemplo');
 * 
 * function funcionEjemplo() {}
 * 
 * addEvent(element, 'click', funcionEjemplo, false);
 * 
 * @param {Element} elemento Elemento HTML
 * @param {string} nomevento Nombre del evento que desencadena la acción ('click', 'mousedown', ...)
 * @param {function} funcion Nombre de la función a lanzar o 'function () {funcionesALanzar(params);}'
 * @param {boolean} captura Usar captura
 * 
 * @returns {boolean} Evento añadido
 */
function addEvent(elemento, nomevento, funcion, captura) {
    if (elemento.attachEvent) {
        /* Encapsulo la funcion en otro function() para que los "this" que pueda tener la función no referencien al elemento, 
        sino a lo que realmente deben referenciar.*/
        elemento.attachEvent('on' + nomevento, function () { funcion(); });
        return true;
    }
    else
        if (elemento.addEventListener) {
            elemento.addEventListener(nomevento, function () { funcion(); }, captura);
            return true;
        }
        else
            return false;
}

/**
 * Añade un evento onChange a un elemento del DOM.
 * @param {any} element HTMLElement, id o class de un elemento.
 * @param {any} onChangeFunction Nombre de la función a ejecutar al producirse el cambio.
 */
function addChangeEvent(element, onChangeFunction) {
    $(element).change(function () {
        onChangeFunction();
    });
}


/**
 * Crea un elemento que se añade al menú desplegable
 * @param {string} name Nombre del elemento de menú a mostrar
 * @param {string} icon Clase del icono de Glyphicon a mostrar (sólamente el nombre del icono, sin 'glyphicon-')
 * @param {string} href Ruta
 * @param {string} value Valor del input.
 * @param {string} valueIcon Clase del icono de Glyphicon a mostrar para el valor del elemento de menú (sólamente el nombre del icono, sin 'glyphicon-')
 * @param {string} id ID del elemento de menú
 * @param {string} others Otras propiedades que pueda necesitar el menú ('data="data"')
 */
function menuElement(name, icon, href, value, valueIcon, id, others) {

    var menuHtml = '<li id="' + id + '" class="menuElement">';
    menuHtml += '<div class="menuItem">';
    menuHtml += '<div class="icon-container">';
    menuHtml += '<div class="rf-icon rf-' + icon + '" ></div > ';
    menuHtml += '</div>';
    menuHtml += '<div class="menuItemContent">';
    menuHtml += '<label>' + name + '</label>';
    menuHtml += '<input class="invisible-input" readonly value="' + value + '"' + (typeof others !== 'undefined' ? others : '') + '>';
    menuHtml += '</div>';
    menuHtml += '<div class="icon-container">';
    menuHtml += '<div class="rf-icon rf-' + valueIcon + '" ></div> ';
    menuHtml += '</div>';
    menuHtml += '</div>';
    menuHtml += '</li>';
    //if (value !== '') {
    //    menuHtml = menuHtml + '<div><input class="invisible-input" readonly value="' + value + '"' + others + '><div class="rf-icon rf-' + valueIcon + '"> </div></div>';
    //}
    //menuHtml = menuHtml + '</a></li>';
    $('#sessionElement').before(menuHtml);
}


/**
 * Muestra un mensaje transformando la cabecera de la página y devolviendolo a la normalidad tras 3 segundos.
 * Esto permite que el usuario siga trabajando sin necesidad de cerrar ninguna ventana de mensaje.
 * @param {string} message Mensaje
 */
function successMessage(message) {
    var successMessageContainer = $('#successMessage');
    var messageLabel = document.createElement('label');
    messageLabel.innerText = message;
    successMessageContainer.html(messageLabel);
    $('.navbar-spyro').fadeOut(300, function () {
        successMessageContainer.addClass('in');
        $(this).css('background-color', '#44b549').fadeIn(300);
    });

    setTimeout(devolvTitulo, 3000);

    function devolvTitulo() {
        $('.navbar-spyro').fadeOut(300, function () {
            successMessageContainer.removeClass('in');
            $(this).css('background-color', '#2a75c2').fadeIn(300);
        });
    }
}


/**
 * Modifica el color de la fila seleccionada en la tabla para indicar que se ha realizado un cambio
 * @param {string} tableId JQuery id de la tabla.
 */
function cambioColorPedido(tableId) {
    var v_table = $(tableId).DataTable();
    var row = v_table.row('.selected').node();
    $(row).addClass('green');
}

/**
 * Intenta transformar un string en Integer y devolverlo
 * Si no lo consigue, devuelve el número por defecto
 * @param {string} str String a transformar en Integer.
 * @param {number} defaultValue Valor que se devuelve en caso de error.
 * 
 * @returns {number} Número entero
 */
function TryParseInt(str, defaultValue) {
    var retValue = defaultValue;
    if (str && !isNaN(str)) {
        retValue = parseInt(str);
    }
    return retValue;
}
/**
 * Intenta transformar un string en float y devolverlo.
 * Si no lo consigue, devuelve el número por defecto.
 * @param {string} str Cadena a transformar.
 * @param {number} defaultValue Número que devuelve en caso de error.
 * 
 * @returns {number} Sin error: número obtenido del str. Con error: número por defecto. 
 */
function TryParseFloat(str, defaultValue) {
    var retValue = defaultValue;
    if (str) {
        str = str.replace(',', '.');
        if (str.trim().length > 0) {
            if (!isNaN(str)) {
                retValue = parseFloat(str);
            }
        }
    }
    return retValue;
}


/**
 * Busca y selecciona una fila de la tabla mediante la variable JSON 
 * de la columna y el valor a buscar.
 * Parametros: (string) idTabla, (Array Json) 
 * [
 *   {KEY: "KEY1", VALUE: "VALUE1"}, 
 *   {KEY: "KEY2", VALUE: "VALUE2"}, 
 *   ...
 *]
 * @param {string} table Jquery ID de la tabla <"#tableName" || tableElement>
 * @param {any[]} jsonArray [
 *   {KEY: "KEY1", VALUE: "VALUE1"},
 *   {KEY: "KEY2", VALUE: "VALUE2"},
 *   ...
 *]
 * @returns {boolean} Encontrado SI / NO
 */
function seleccionFila(table, jsonArray) {
    var v_table = $(table).DataTable();
    var encontrado = false;
    if (v_table.rows().count() !== 0) {
        v_table.row('.selected').nodes().to$().removeClass('selected');
        v_table.rows(function (idx, data, node) {
            if (!encontrado) {
                encontrado = true;
                for (i = 0; i < jsonArray.length; i++) {
                    if (data[jsonArray[i].KEY] !== jsonArray[i].VALUE) {
                        return encontrado = false;
                    }
                }
                if (encontrado) {
                    var v_pag = Math.floor(idx / v_table.page.len());
                    v_table.page(v_pag).draw('page');
                    return encontrado;
                }
            }
        }).nodes().to$().addClass('selected');
        if (v_table.row('.selected').nodes().count() !== 0) {
            var v_row = $(v_table.row('.selected').node());
            $(table + '_wrapper .dataTables_scrollBody').animate({
                scrollTop: v_row.offset().top - $(table + '_wrapper .dataTables_scrollBody').offset().top
            }, 300);
        }
    }
    console.log(encontrado);
    return encontrado;
}

function dameDatosFila(table, jsonArray) {
    var v_table = $(table).DataTable();
    var line = null;
    var encontrado = false;
    if (v_table.rows().count() !== 0) {
        v_table.rows(function (idx, data, node) {
            if (!encontrado) {
                encontrado = true;
                for (i = 0; i < jsonArray.length; i++) {
                    if (data[jsonArray[i].KEY] !== jsonArray[i].VALUE) {
                        return encontrado = false;
                    }
                }
                if (encontrado)
                    line = data;
            }
        });
    }
    return line;
}

function dameIndexFila(table, jsonArray) {
    var v_table = $(table).DataTable();
    var line = null;
    var encontrado = false;
    if (v_table.rows().count() !== 0) {
        v_table.rows(function (idx, data, node) {
            if (!encontrado) {
                encontrado = true;
                for (i = 0; i < jsonArray.length; i++) {
                    if (data[jsonArray[i].KEY] !== jsonArray[i].VALUE) {
                        return encontrado = false;
                    }
                }
                if (encontrado)
                    line = idx;
            }
        });
    }
    return line;
}

/**
 * Hace focus en el siguiente elemento '.focusable' al presionar la tecla Enter
 * Sin 'dialogId': Obtiene todos los elementos '.focusable'
 * Con 'dialogId': Obtiene los elementos '.focusable' del dialog introducido
 * @param {string} dialogId JQuery id de la ventana modal
 * @returns {object} objeto para controlar la tabulación
 */
function tabulado(dialogId) {
    var v_tabulado = {
        siguiente: (function () {
            var v_siguiente, v_navegacion = null, v_temporizador;

            function estableceFoco() {
                if (v_siguiente) {
                    console.log("foco por " + v_navegacion + " en " + v_siguiente.id || v_siguiente.tagName);
                    $(v_siguiente).focus();
                    v_siguiente = v_navegacion = v_temporizador = null;
                }
            }

            return function (p_siguiente, p_teclado) {
                if (arguments.length > 0) {
                    if (p_siguiente instanceof jQuery) {
                        p_siguiente = p_siguiente[0];
                    } else {
                        p_siguiente = p_siguiente;
                    }

                    p_teclado = arguments.length < 2 ? false : p_teclado;

                    if (p_siguiente) {
                        if (v_navegacion === null) {
                            if (p_teclado) { v_navegacion = 'teclado'; }
                            else { v_navegacion = 'proceso'; }
                            v_siguiente = p_siguiente;
                        } else if (v_navegacion === 'teclado') {
                            if (p_teclado) {
                                // Esta opción carece de sentido
                                debugger;
                            } else {
                                // Se cancela la navegacion por teclado
                                v_navegacion = 'proceso';
                                v_siguiente = p_siguiente;
                            }
                        } else if (v_navegacion === 'proceso') {
                            if (p_teclado) {
                                // Prevalece la navegación por proceso
                            } else {
                                // Se navegaba por proceso y se quiere navegar por proceso a otro elemento
                                v_siguiente = p_siguiente;
                            }
                        }
                        if (v_temporizador) {
                            clearTimeout(v_temporizador);
                        }
                        v_temporizador = setTimeout(estableceFoco.bind(this), 0);
                        //if (this.navegacionTeclado) {
                        //    estableceFoco.apply(this);
                        //}
                    }
                    else {
                        v_siguiente = null;
                        v_navegacion = null;
                    }
                } else {
                    return v_siguiente;
                }
            };
        })()
        //,
        //navegacionTeclado: false,

        //navegacionTecladoIniciada: function () {
        //    this.siguiente(null);
        //    this.navegacionTeclado = true;
        //},

        //navegacionTecladoTerminada: function () {
        //    this.navegacionTeclado = false;
        //}
    };

    //Busca el siguiente elemento '.focusable'
    var focusableInputs = !dialogId ? $('.focusable') : $(dialogId + ' .focusable');
    focusableInputs.attr('autocomplete', 'off');
    if (focusableInputs.length > 0) {
        // RBM 03/03/20 retraso el foco del dialogo
        let v_focoInicial = document.querySelectorAll('*:not([disabled]).focusable.foco-inicial')[0];
        if (typeof v_focoInicial !== 'undefined') {
            setTimeout(function () { v_focoInicial.focus(); }, 0);
            //this.en(v_focoInicial);
            return v_focoInicial;
        }
        //setTimeout(function () { nextFocus(); }, 0);
    }

    focusableInputs.keydown(function (e) {
        if (e.keyCode === 9 || e.keyCode === 13) {
            //v_tabulado.navegacionTecladoIniciada();

            if (e.keyCode === 9) {
                // Si mantenemos la tecla shift irá al lado contrario.
                if (e.shiftKey) {
                    previousFocus($(this));
                } else {
                    nextFocus($(this));
                }
                e.preventDefault();
            }
        }
    });
    focusableInputs.keyup(function (e) {
        //var v_siguiente = v_tabulado.siguiente();

        if (e.keyCode === 13) {
            //if (v_siguiente === null) {
            //    nextFocus($(this));
            //} else {
            //    //$(v_siguiente).focus().select();
            //    v_tabulado.siguiente(v_siguiente);
            //}
            ////v_tabulado.navegacionTecladoTerminada();
            e.preventDefault();
        } else if (e.keyCode === 9) {
            //if (v_siguiente !== null) {
            //    //$(v_siguiente).focus().select();
            //    v_tabulado.siguiente(v_siguiente);
            //}
            ////v_tabulado.navegacionTecladoTerminada();
            e.preventDefault();
        }
    });
    function nextFocus(input) {
        input = !input ? $(focusableInputs[focusableInputs.length - 1]) : $(input);
        var originInput = input.get(0);
        do {
            var currentInput = input.get(0);
            var next = focusableInputs.index(input) + 1;
            next = next >= focusableInputs.length ? 0 : next;
            input = $(focusableInputs[next]);
        } while (originInput !== input.get(0) && input.get(0) !== currentInput && (input.prop('readonly') || input.prop('disabled') || !input.is(':visible')));
        console.log('next');
        //input.focus();
        v_tabulado.siguiente(input, true);
    }

    function previousFocus(input) {
        input = !input ? $(focusableInputs[focusableInputs.length - 1]) : $(input);
        var originInput = input.get(0);
        do {
            var currentInput = input.get(0);
            var previous = focusableInputs.index(input) - 1;
            previous = previous < 0 ? focusableInputs.length - 1 : previous;
            input = $(focusableInputs[previous]);
        } while (originInput !== input.get(0) && input.get(0) !== currentInput && (input.prop('readonly') || input.prop('disabled') || !input.is(':visible')));
        //input.focus();
        v_tabulado.siguiente(input, true);
    }

    focusableInputs.on('focus', function () { $(this).select(); });

    return v_tabulado;
}

function autoselect(dialogId) {
    var inputs = !dialogId ? $('input:not(.invisible-input,:disabled)') : $(dialogId + ' input:not(.invisible-input,:disabled)');

    for (var i = 0; i < inputs.length; i++) {
        $(inputs[i]).on('focus', function () {
            $(this).select();
        });
    }
}


/**
 * Añade flechas que permiten navegar entre los registros
 * 
 * Parametros: String table: "#ejemplo";
 * @param {string} table JQuery id de la tabla
 */
function navigateArrows(table) {
    var $dataTable = $(table).dataTable();
    var dataTable = $(table).DataTable();
    $(table + ' tbody').on('click', function () {
        var selectedRowIndex = $dataTable.find('.selected').index();
        disableRow(selectedRowIndex);
    });
    var nextButton = '<a class="paginate_button nextRow"><i class="glyphicon glyphicon-arrow-down gi-2x"/></a>';
    var previousButton = '<a class="paginate_button previousRow"><i class="glyphicon glyphicon-arrow-up gi-2x"/></a>';

    paginationFirstButton = $(table + '_paginate a:first-child');

    paginationFirstButton.after(nextButton);
    paginationFirstButton.after(previousButton);

    var v_index = dataTable.rows().data().length > 1 ? $dataTable.find('.selected').index() : 0;
    disableRow(v_index);

    var previousRow = $(table + '_paginate .previousRow');
    var nextRow = $(table + '_paginate .nextRow');
    var nextPage = $(table + '_paginate .next');
    var prevPage = $(table + '_paginate .previous');

    $(table + '_paginate').appendTo($(table + '_wrapper .dataTables_scroll'));


    // Botón linea siguiente
    nextRow.on('click', function () {
        if (!nextRow.hasClass('disabled')) {
            var selectedRowIndex = $dataTable.find('.selected').index();

            var nextIndex = selectedRowIndex + 1;
            var next = $dataTable.find('tbody tr:eq(' + nextIndex + ')');

            disableRow(nextIndex);

            if (nextIndex === $dataTable.find('tbody').find('tr').length && !nextPage.hasClass('disabled')) {
                nextPage.click();
                next = $dataTable.find('tbody tr:eq(0)');
                var $v_dataTable = $(table).dataTable();

                dataTable.row('.selected').nodes().to$().removeClass('selected');
                next.addClass('selected');
            } else {
                dataTable.row('.selected').nodes().to$().removeClass('selected');
                next.addClass('selected');

            }
            var v_row = $(dataTable.row('.selected').node());
            $(table + '_wrapper .dataTables_scrollBody').animate({
                scrollTop: v_row.offset().top + v_row.height() - 2 * $(table + '_wrapper .dataTables_scrollBody').offset().top
            }, 100);
            next.trigger('mousedown');
        }
    });

    // Botón linea anterior
    previousRow.on('click', function () {
        if (!previousRow.hasClass('disabled')) {
            var selectedRowIndex = $dataTable.find('.selected').index();

            var prevIndex = selectedRowIndex - 1;
            var prev = $dataTable.find('tbody tr:eq(' + prevIndex + ')');
            if (prevIndex < 0 && !prevPage.hasClass('disabled')) {
                prevPage.click();
                prev = $dataTable.find('tbody tr:eq(-1)');
                var $v_dataTable = $(table).dataTable();

                dataTable.row('.selected').nodes().to$().removeClass('selected');
                prev.addClass('selected');
                selectedRowIndex = $dataTable.find('.selected').index();
                prevIndex = selectedRowIndex - 1;
            } else {
                dataTable.row('.selected').nodes().to$().removeClass('selected');
                prev.addClass('selected');
            }
            disableRow(prevIndex);
            var v_row = $(dataTable.row('.selected').node());

            $(table + '_wrapper .dataTables_scrollBody').animate({
                scrollTop: v_row.offset().top - $(table + '_wrapper .dataTables_scrollBody').offset().top
            }, 100);
            prev.trigger('mousedown');
        }
    });


    // Deshabilita o habilita los botones de linea siguiente/anterior 
    // en funcion de los elementos que haya en la tabla.
    function disableRow(rowIndex) {
        var pageLength = $dataTable.find('tbody').find('tr').length;
        var disablePrev = rowIndex <= 0 ? true : false;
        var disableNext = rowIndex === pageLength - 1 ? true : false;

        var nextRow = $(table + '_paginate .nextRow');
        var prevRow = $(table + '_paginate .previousRow');

        var nextPage = $(table + '_paginate .next').hasClass('disabled') ? false : true;
        var prevPage = $(table + '_paginate .previous').hasClass('disabled') ? false : true;

        if (disableNext && nextPage) {
            disableNext = false;
        }
        disableNext ? nextRow.addClass('disabled') : nextRow.removeClass('disabled');


        if (disablePrev && prevPage) {
            disablePrev = false;
        }
        disablePrev ? prevRow.addClass('disabled') : prevRow.removeClass('disabled');
    }
}

/**
 * Obtiene el número de registros que se deben mostrar en la tabla dependiendo del alto de esta.
 * * Ajusta el alto al alto de pantalla teniendo en cuenta otros elementos que pueda haber de por medio.
 * * Calcula la página que debería mostrarse al cambiar el número de registros.
 * * * TODO AAZ: Realizar el calculo con el registro seleccionado en lugar de hacerlo con el primer registro. 
 * 
 * @returns {any} Función que se aplica a la tabla cada vez que ocurre un resize.
 **/
function SpyFilter() {
    return {
        applyFilters: function (tableId) {
            setTimeout(function () {
                var oldLength = $(tableId).DataTable().page.len();
                var oldPage = $(tableId).DataTable().page.info().page + 1;
                var tableHeight = $(tableId + '_wrapper .dataTables_scrollBody').height();

                var row = $(tableId + ' tbody tr').eq(0);

                var rowHeight = row ? row.height() : 11;

                // tableHeight - 0.1 => para ocultar el último registro cuando la tabla sea del mismo tamaño que la suma de los registros.
                // Sin esto, el alto mínimo de la tabla queda fijada al alto de los registros.
                var pageLength = Math.floor((tableHeight - 0.1) / rowHeight);
                pageLength = pageLength === 0 ? 1 : pageLength;
                if (oldLength !== pageLength) {
                    $(tableId).DataTable().page.len(1).draw();
                    // Cálculo de página (resize)

                    // Obtiene el primer registro de la paginación antes del resize 
                    // TODO AAZ Sería preferible que coger el registro seleccionado
                    var initialRegister = oldLength * oldPage - (oldLength - 1);

                    // Obtiene la página en la que debería aparecer el registro con la nueva longitud de registros
                    var newPage = Math.ceil(initialRegister / pageLength);
                    $(tableId).DataTable().page.len(pageLength).draw();
                    $(tableId).DataTable().page(newPage - 1).draw('page');
                    oldLength = pageLength;
                }
            }, 0);
        }
    };
}

/**
 * 
 * @param {number} pendingQty Cantidad disponible para sacar
 * @param {number} qty Cantidad total a servir
 * 
 * @return {number} Cantidad a sacar de la ubicación seleccionada.
 */
function setOptimumQty(pendingQty, qty) {
    var v_num = pendingQty > qty ? qty : pendingQty;
    if (v_num < 0) v_num = 0;
    return v_num;
}


/**
* @param {any} p_tabla Referencia a la tabla
* @param {string} p_nombreColumna Nombre de la columna
 * Funcion para hacer modificables las columnas de las DataTable
 */
function ModifyCellValue(p_tabla, p_nombreColumna) {
    this.Active = true;
    this.Table = $(p_tabla).DataTable();
    this.Column = p_nombreColumna;
    this.AfterChangeArray = [];

    this.Activate = function () {
        this.Active = true;
        this.ChangeColumnColor();
    };
    this.Deactivate = function () {
        this.Active = false;
        this.ChangeColumnColor();
    };

    this.AddDrawCallback = function () {
        // Se ejecutan las funciones añadidas al aoDrawCallback cada vez que se ejecuta la funcion draw() de dataTable.
        var self = this;
        var DrawCallBack = {
            "fn": function () {
                self.ChangeColumnColor();
            },
            "sName": "Colour"
        };
        $(p_tabla).dataTable().fnSettings().aoDrawCallback.push(DrawCallBack);
    };

    this.AfterChange = function (p_afterChangeFn) {
        this.AfterChangeArray.push(p_afterChangeFn);
    };

    this.ChangeColumnColor = function () {
        var _this = this;
        var columns = _this.Table.settings().init().aoColumns;

        columns.forEach(function (col, i) {
            if (col.mDataProp === _this.Column) {
                if (_this.Active)
                    _this.Table.columns(i).nodes()[0].forEach(function (n) { $(n).addClass("green"); });
                else
                    _this.Table.columns(i).nodes()[0].forEach(function (n) { $(n).removeClass("green"); });

            }
        });
    };

    this.AddDrawCallback();

    /**
    * Hace que los valores de una columna se puedan modificar.

    * @param {Function} p_onchange Función lanzada al modificar el valor (callback => newValue, oldValue, row).
    * @param {string} p_type Indica el tipo de dato (String, Int, Float...)
    * @param {boolean} UpperCase Indica si debe ir escrito en mayúsculas
    */
    this.modCellValue = function (p_onchange, p_type, UpperCase) {
        var self = this;
        var columns = self.Table.settings().init().aoColumns;
        if (!p_type) {
            p_type = "Int";
        }

        if (!UpperCase) {
            UpperCase = false;
        }

        $(self.Table.table().container()).on('click', 'td', function (e) {
            var cell = self.Table.cell(this);
            var index = cell.index();
            var $cell = $(this);
            if (columns[index.column]["mDataProp"] === self.Column) {
                if (self.Active) {
                    e.stopImmediatePropagation();
                    if (!$(this).find('input').length) {
                        var v_cellValue = $cell.context.innerHTML;
                        var upperClass = UpperCase ? "code" : "";
                        if (p_type.toUpperCase() !== "STRING")
                            $cell.context.innerHTML = '<input id="modInput" class="col-xs-12 form-control input-sm input-xs code text-right" value="' + v_cellValue + '" />';
                        else
                            $cell.context.innerHTML = '<input id="modInput" class="col-xs-12 form-control input-sm input-xs ' + upperClass + ' " value="' + v_cellValue + '" />';
                        $('#modInput').focus().select();
                        $('#modInput').on('click', function () {
                            $(this).select();
                        });
                        $('#modInput').keypress(function (e) { if (e.which === 13) { $("#modInput").blur(); } });

                        var blurFn = function () {
                            if (RemovableFocus) {
                                var data = self.Table.row(index.row).data();
                                var oldValue = v_cellValue;
                                var newValue = $(this).val();
                                if (p_type.toUpperCase() === "INT")
                                    data[self.Column] = TryParseInt(newValue, oldValue);
                                else if (p_type.toUpperCase() === "FLOAT")
                                    data[self.Column] = TryParseFloat(newValue, oldValue);
                                else
                                    UpperCase ? data[self.Column] = newValue.toUpperCase() : data[self.Column] = newValue;

                                self.Table.row(index.row).invalidate();
                                self.AfterChangeArray.forEach(function (fn) {
                                    fn();
                                });
                            }
                        };
                        $('#modInput').on('blur', blurFn);

                        var resizeTimer;
                        var RemovableFocus = true;
                        window.onresize = function () {
                            if (resizeTimer) {

                                clearTimeout(resizeTimer);   // clear any previous pending timer
                            } else {
                                RemovableFocus = false;
                                $('#modInput').off('blur', blurFn);
                            }
                            // set new timer

                            resizeTimer = setTimeout(function () {
                                resizeTimer = null;
                                RemovableFocus = true;

                                $('#modInput').on('blur', blurFn);
                            }, 500);
                        };

                        $('#modInput').on('change', function () {
                            var oldValue = v_cellValue;
                            var newValue = $(this).val();
                            data = self.Table.row(index.row).data();
                            newValue = UpperCase ? newValue.toUpperCase() : newValue;
                            if (p_onchange)
                                p_onchange(newValue, oldValue, index.row);
                        });
                    }
                }
            }
        });
    };
}

function leerEtiqueta(p_etiqueta) {

    var v_sinConversion = function (p_texto) { return p_texto; };

    var v_conversionFecha = function (p_texto) {
        var v_anyo = Number(p_texto.substr(0, 2));
        var v_mes = Number(p_texto.substr(2, 2));
        var v_dia = Number(p_texto.substr(4, 2));
        if (v_anyo < 50) {
            v_anyo = 2000 + v_anyo;
        }
        return new Date(v_anyo, v_mes, v_dia);
    };


    //var v_gs = "\x1d";
    //var v_gs = "\[GS]";
    var v_gs = String.fromCharCode(29);

    var v_exclusion = "[^" + v_gs + "]";
    //var v_alfanumerico = "[a-zA-Z][0-9]";
    // v_alfanumerico + "{    =>     ".{
    var v_fijos = [
        { ia: "00", patron: "[0-9]{18}", conversor: v_sinConversion },
        { ia: "01", patron: "[0-9]{14}", conversor: v_sinConversion },
        { ia: "02", patron: "[0-9]{14}", conversor: v_sinConversion },
        { ia: "11", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "12", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "13", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "15", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "17", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "20", patron: "[0-9]{2}", conversor: v_sinConversion },
        { ia: "402", patron: "[0-9]{17}", conversor: v_sinConversion },
        { ia: "410", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "411", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "412", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "413", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "414", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "415", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "422", patron: "[0-9]{3}", conversor: v_sinConversion },
        { ia: "424", patron: "[0-9]{3}", conversor: v_sinConversion },
        { ia: "425", patron: "[0-9]{3}", conversor: v_sinConversion },
        { ia: "426", patron: "[0-9]{3}", conversor: v_sinConversion },
        { ia: "7001", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "8001", patron: "[0-9]{14}", conversor: v_sinConversion },
        { ia: "8005", patron: "[0-9]{6}", conversor: v_sinConversion },
        { ia: "8006", patron: "[0-9]{14}[0-9]{2}[0-9]{2}", conversor: v_sinConversion },
        { ia: "8018", patron: "[0-9]{18}", conversor: v_sinConversion },
        { ia: "8100", patron: "[0-9]{1}[0-9]{5}", conversor: v_sinConversion },
        { ia: "8101", patron: "[0-9]{1}[0-9]{5}[0-9]{4}", conversor: v_sinConversion },
        { ia: "8102", patron: "[0-9]{1}[0-9]{1}", conversor: v_sinConversion }
    ];

    var v_variables = [
        { ia: "10", patron: v_exclusion + "{1,20}", conversor: v_sinConversion },
        { ia: "21", patron: v_exclusion + "{1,20}", conversor: v_sinConversion },
        { ia: "22", patron: v_exclusion + "{1,29}", conversor: v_sinConversion },
        { ia: "240", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "241", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "250", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "251", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "37", patron: "[0-9]{1,8}", conversor: parseInt },

        { ia: "3900", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3901", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3902", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3903", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3904", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3905", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3906", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3907", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3908", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3909", patron: "[0-9]{1,15}", conversor: parseInt },

        { ia: "3910", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3911", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3912", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3913", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3914", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3915", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3916", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3917", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3918", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3919", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },

        { ia: "3920", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3921", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3922", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3923", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3924", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3925", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3926", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3927", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3928", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3929", patron: "[0-9]{1,15}", conversor: parseInt },

        { ia: "3930", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3931", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3932", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3933", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3934", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3935", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3936", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3937", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3938", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3939", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },

        { ia: "400", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "401", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "403", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },

        { ia: "420", patron: "[0-9]{1,20}", conversor: v_sinConversion },
        { ia: "421", patron: "[0-9]{3}.{1,9}", conversor: v_sinConversion },
        { ia: "423", patron: "[0-9]{3}[0-9]{1,12}", conversor: v_sinConversion },

        { ia: "7002", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "7030", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7031", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7032", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7033", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7034", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7035", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7036", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7037", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7038", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7039", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },

        { ia: "8002", patron: "[0-9]{1,20}", conversor: v_sinConversion },
        { ia: "8003", patron: "[0-9]{14}.{1,16}", conversor: v_sinConversion },
        { ia: "8004", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },

        { ia: "8007", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "8008", patron: "[0-9]{8}[0-9]{1,4}", conversor: v_sinConversion },
        { ia: "8020", patron: v_exclusion + "{1,25}", conversor: v_sinConversion },

        { ia: "90", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "91", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "92", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "93", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "94", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "95", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "96", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "97", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "98", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "99", patron: v_exclusion + "{1,30}", conversor: v_sinConversion }
    ];


    var v_descriptores = getDescriptores();

    function getDescriptores() {
        var map = new Array();
        var v_todos = new Array();
        for (i = 0; i < v_fijos.length; i++) {
            v_todos.push({ ia: v_fijos[i].ia, patron: "(" + v_fijos[i].ia + "(?:" + v_fijos[i].patron + "))", conversor: v_fijos[i].conversor });
        }
        for (i = 0; i < v_variables.length; i++) {
            v_todos.push({ ia: v_variables[i].ia, patron: "(" + v_variables[i].ia + "(?:" + v_variables[i].patron + ")" + v_gs + ")", conversor: v_variables[i].conversor });
        }
        for (i = 0; i < v_variables.length; i++) {
            v_todos.push({ ia: v_variables[i].ia, patron: "(" + v_variables[i].ia + "(?:" + v_variables[i].patron + "))", conversor: v_variables[i].conversor });
        }
        for (i = 0; i < v_todos.length; i++) {
            map.push({ ia: v_todos[i].ia, posicion: i, patron: v_todos[i].patron, conversor: v_todos[i].conversor });
        }
        return map;
    }

    var v_patron = "^" + v_gs + "?";
    for (i = 0; i < v_descriptores.length; i++) {
        v_patron = v_patron + v_descriptores[i].patron + "|"
    }
    v_patron = v_patron.replace(/.$/, "$");

    var v_regex = new RegExp(v_patron, "gy");

    var v_conversores = new Array();
    for (i = 0; i < v_descriptores.length; i++) {
        v_conversores.push([v_descriptores[i].ia, v_descriptores[i].conversor]);
    }
    v_conversores = objectify(v_conversores);
    function objectify(array) {
        return array.reduce(function (p, c) {
            p[c[0]] = c[1];
            return p;
        }, {});
    }

    var obtenerIdentificadores = function (p_etiqueta) {
        var v_identificadores = [];
        var v_coincidencia;
        while ((v_coincidencia = v_regex.exec(p_etiqueta)) !== null) {
            // This is necessary to avoid infinite loops with zero-width matches
            if (v_coincidencia.index === p_etiqueta.lastIndex) {
                p_etiqueta.lastIndex++;
            }

            v_coincidencia.forEach(function (p_coincidencia, p_posicion) {
                if (p_coincidencia != null && p_posicion > 0) {
                    var v_ia = v_descriptores[p_posicion - 1].ia;
                    var v_texto = p_coincidencia.substring(v_ia.length);
                    var v_conversor = v_conversores[v_ia];
                    var v_valor = v_conversor(v_texto.replace(v_gs, ""));
                    v_identificadores.push({ ia: v_ia, valor: v_valor });
                }
            });
        }

        return v_identificadores;
    };
    return { obtenerIdentificadores: obtenerIdentificadores(p_etiqueta) };
};


$(document).ready(function () {
    //var t = $('#User, #Password, #db');
    //t.on('keypress', function (e) {
    //    if (e.which === 13) {
    //        $('#btnConnect').click();
    //    }
    //});
    $('#btnConnect').on('click', function () {
        var href = v_apiBaseUrl + "login";
        var user = $('#User').val();
        var pass = $('#Password').val();
        var db = $('#db').val();
        var parameters = "=" + user + "/" + pass + "@" + db;
        $.ajax({
            url: href,
            beforeSend: startLoading,
            cache: false,
            complete: completedLoading,
            type: 'POST',
            data: parameters,
            headers: {
                app: "RF"
            },
            dataType: 'json',
            contentType: 'application/x-www-form-urlencoded; charset=utf-8',
            success: function (response, status, xhr) {
                if (response.Ok) {
                    sessionStorage.setItem("token", response.Objeto);
                    sessionStorage.setItem("user", user);
                    sessionStorage.setItem("pass", pass);
                    sessionStorage.setItem("db", db);
                    localStorage.setItem("token", response.Objeto);
                    $('#token').val(response.Objeto);
                    $('#loginForm').submit();
                } else {
                    handleResponse(response);
                }
            },
            error: function (xhr, status, error) {
                if (xhr.status === 0) {
                    error = "Ha ocurrido un error en la conexión.";
                }
                lanzarMensaje(false, error);
            }
        });
    });
});

function reLog(apiFunction) {
    var v_user = sessionStorage.getItem("user");
    var v_pass = sessionStorage.getItem("pass");
    var v_db = sessionStorage.getItem("db");
    var v_parameters = "=" + v_user + "/" + v_pass + "@" + v_db;

    var v_href = v_apiBaseUrl + "login";

    $.ajax({
        url: v_href,
        cache: false,
        type: 'POST',
        data: v_parameters,
        dataType: 'json',
        contentType: 'application/x-www-form-urlencoded; charset=utf-8',
        success: function (response, status, xhr) {
            if (response.Ok) {
                sessionStorage.setItem("token", response.Objeto);
                apiFunction();
            } else {
                validationError(response.Mensaje);
            }
        },
        error: function (xhr, status, error) {
            if (xhr.status === 401) {
                //window.location.href = Router.action('Login', 'Logout');
                window.location.href = "Login/Logout";
            }
        }
    });
}

/**
 * TODO AAZ: Faltan descripciones de parametros
 * 
 * Genera una ventana modal que adapta su contenido a los elementos que se se añaden en la función.
 * 
 * var dialog = "#ejemplo";
 * var columnsWidth => número entre [ 1 - 12 ]
 * 
 * @param {string} href                x
 * @param {string} dialog              x
 * @param {string} tableName           x
 * @param {JSON} data                  x
 * @param {Array<JSON>} dataJSON       x
 * @param {Array} columnsJSON          x
 * @param {Array} buttonArray          x
 * @param {Array} inputArray           x
 * @param {Array} upperInputArray      x
 * @param {function} funcionName       x
 * @param {string} title               x
 * @param {Array<string>} innerDialogs x
 * @param {string} message             x
 * @param {number} columnsWidth        x
 * @param {string} zeroRecordsMessage  x
 * @param {number} displayLength       x
 * @param {boolean} responsive         x
 * @param {Array<Object>} columnDefs   x
 * @param {boolean} searchField        Mostrar Campo de búsqueda
 * 
 * @returns {boolean} false
 */
function generarDialogAuto(href, dialog, tableName, data, dataJSON, columnsJSON, buttonArray, inputArray, upperInputArray,
    funcionName, title, innerDialogs, message, columnsWidth, zeroRecordsMessage, displayLength, responsive, columnDefs, searchField, closable) {

    $.ajax({
        url: href,
        cache: false,
        dataType: 'json',
        data: data,
        success: function (response, status, xhr) {
            if (response.Ok) {
                if (response.Objeto) {
                    dataJSON = JSON.parse(response.Objeto);
                }
                $(dialog).html(response.Mensaje);
                showDialog(dialog);
                if (tableName) {
                    $(dialog + ' table').prop('id', tableName);
                    generateTable(dialog, dataJSON, columnsJSON, tableName, zeroRecordsMessage, displayLength, responsive, columnDefs, searchField);
                } else {
                    $(dialog + ' .lateralTable').hide();
                }

                if (message) {
                    generateMessage(message, dialog, tableName);
                    if (!tableName && !inputArray)
                        $(dialog + ' #lovMessage').css('height', '100%');
                }

                if (buttonArray) {
                    generateButtons(buttonArray, dialog, inputArray, message, tableName);
                }
                if (inputArray) {
                    generateInputs(inputArray, dialog);
                    if (tableName) {
                        $(dialog + ' .lateralTable').addClass('hasInputField');
                    } else
                        $(dialog + ' .lateralInputs').css('height', '100%');
                    $(dialog + ' .lateralInputs').css('display', 'table-row');
                }

                if (upperInputArray) {
                    generateUpperInputs(upperInputArray, dialog);
                }
                if (funcionName) {
                    funcionName();
                }
                toUpper();

                if (innerDialogs) {
                    newDialogs(innerDialogs, dialog);
                }
                autoselect(dialog);

                tabulado(dialog);

                $(dialog + ' .modal-header .modal-title').html(title);
                //$('#' + tableName).DataTable().columns.adjust().responsive.rebuild().responsive.recalc();
                $('.disabled').prop('disabled', true);

                if (closable === false) {
                    $(dialog + ' .modal-close').css('display', 'none');
                }
            } else {
                lanzarMensaje(response.Ok, response.Mensaje);
            }
        },
        error: function (xhr, error) {
            console.log(xhr);
        }
    });

    return false;
}

function generateButtons(buttons, dialog, inputs, message, tableName) {
    if (!buttons) {
        buttons = [];
    }
    var buttonString = "";
    for (i = 0; i < buttons.length; i++) {
        var position = "pull-right";
        if (buttons[i].position && buttons[i].position !== "") {
            position = buttons[i].position;
        }
        var btnClass = buttons[i].btnClass ? buttons[i].btnClass : "default";
        buttonString = buttonString + "<button class='boton boton-" + btnClass + " " + position + "' id='" + buttons[i].id + "'>" + buttons[i].value + "</button>";
    }
    if (buttons.length === 1) {
        $(dialog + " .botoneraInf").html(buttonString);
        $(dialog + " .modal-bodyContainer.spy-display.spy-display-table").addClass("blank-space");
        //$(dialog + " .botoneraInf").css('position', 'absolute').css('left', '0').css('bottom', '0');
        $(dialog + " .botoneraInf button").css('width', '100%');
    } else {
        $(dialog + " .buttonPlaceholder").html(buttonString);
    }

    if ((buttons.length > 2 /*|| message*/) && buttons.length <= 5 && !inputs) {
        $(dialog + " .botoneraDialog").addClass('botoneraLateral');
        if (buttons.length === 4) {
            $(dialog + " .buttonPlaceholder").addClass('botones-4');
        }
    } else if (buttons.length > 5 && !inputs) {
        $(dialog + " .buttonPlaceholder").addClass('medium-button-field');
    } else if ((inputs || message) && buttons.length > 2) {
        $(dialog + " .buttonPlaceholder").addClass('small-button-field');
    } else if (!inputs && !message && buttons.length <= 2) {
        $(dialog + " .botoneraDialog").addClass('botoneraLarga');
        $('#' + tableName + "_wrapper").addClass('longTable');
    }
}

function generateSingleInput(width, label, inputId, value, fieldsetId, className, isNumeric, type, disabled) {
    var input = { width: width, label: label, id: inputId, value: value, fieldId: fieldsetId, className: className, isNumeric: isNumeric, type: type, disabled: disabled };
    return input;
}

function generateSearchInput(width, label, id, value, descriptionField, validationFunction, searchButtonFunction, className) {
    var input = {
        width: width,
        label: label,
        id: id,
        value: value,
        validationFunction: validationFunction,
        className: className,
        descriptionField: descriptionField,
        searchButtonFunction: searchButtonFunction,
        search: true
    };
    return input;
}

//<div id="buscaAlmacen" class=" col-xs-12">
//    @Html.LabelFor(p => p.v_almacen, new { @class = "col-xs-4 control-label" })
//                        <div class="col-xs-8">
//        <div class="searchField">
//            @Html.TextBoxFor(p => p.v_almacen, new { @id = "GAALMNOM_COD", @class = "form-control input-sm input-xs" })
//                            </div>
//        <div class="rf-icon-button rf-buscador" id="btnBuscaAlmacen"></div>
//    </div>
//    <input type="text" id="GAALMNOM_DESCRIP" class="form-control input-sm input-xs" disabled="disabled" />
//</div>

//function generateInputs(inputs, dialog) {
//    for (i = 0; i < inputs.length; i++) {
//        var fieldSet = document.createElement('div');
//        $(fieldSet).addClass('col-xs-' + inputs[i].width).prop('id', inputs[i].fieldId);
//        var label = document.createElement('label');
//        $(label).addClass(labelClass).text(inputs[i].label);
//        var input = document.createElement('input'); 
//        $(input).prop('id', inputs[i].id).addClass('form-control input-xs ' + inputs[i].className).val(inputs[i].value);

//        if (search) {
//            $(fieldSet).addClass("searchInput");
//        } else {
//            var labelClass = "";
//            if (inputs[i].className)
//                if (inputs[i].className.indexOf('text-right') !== -1) {
//                    labelClass = 'numberInputLabel';
//                }
//            if (inputs[i].isNumeric) {
//                $(input).prop('type', 'text');
//                labelClass = 'pull-right';
//            }
//        }
//        $(fieldSet).append(label);
//        $(fieldSet).append(input);
//        $(dialog + " .inputField").append(fieldSet);    
//    }
//}

function generateInputs(inputs, dialog) {
    for (i = 0; i < inputs.length; i++) {
        var fieldSet = document.createElement('div');
        $(fieldSet).addClass('col-xs-' + inputs[i].width).prop('id', inputs[i].fieldId);
        var labelClass = "";
        if (inputs[i].className)
            if (inputs[i].className.indexOf('text-right') !== -1) {
                labelClass = 'numberInputLabel';
            }
        var label = document.createElement('label');
        $(label).addClass(labelClass).text(inputs[i].label);
        var input;
        if (inputs[i].search) {
            var searchFieldDiv = document.createElement('div');
            $(searchFieldDiv).addClass('searchField');

            input = document.createElement('input');
            $(input).prop('id', inputs[i].id).addClass('form-control input-xs');

            $(searchFieldDiv).append(input);

            var searchButton = document.createElement('div');
            $(searchButton).addClass('rf-icon-button rf-buscador');
            var labelContainer = document.createElement("div");
            labelContainer.classList = "fillAvailable";
            $(labelContainer).append(label);
            $(fieldSet).append(labelContainer);
            $(fieldSet).append(searchFieldDiv);
            $(fieldSet).append(searchButton);
            if (inputs[i].descriptionField) {
                var searchDescripFieldset = document.createElement('div');
                $(searchDescripFieldset).addClass('col-xs-12');
                var descrInput = document.createElement('input');
                $(descrInput).addClass("form-control input-sm input-xs");
                $(descrInput).prop('disabled', 'disabled');
                $(descrInput).prop('id', inputs[i].descriptionField);

                $(searchDescripFieldset).append(descrInput);
                $(fieldSet).append(searchDescripFieldset);
            }
            addEvent(input, 'change', inputs[i].validationFunction);
            addEvent(searchButton, 'click', inputs[i].searchButtonFunction);
        } else {
            input = document.createElement('input');
            if (inputs[i].isNumeric) {
                $(input).prop('type', 'text');
                $(input).addClass('text-right');
                $(input).on('change', function () { $(input).val(TryParseFloat($(input).val(), 0)); })
                $(fieldSet).css("text-align", "right");
            }
            $(input).prop('id', inputs[i].id).addClass('form-control input-xs ' + inputs[i].className).val(inputs[i].value);
            $(input).prop('disabled', inputs[i].disabled);
            $(fieldSet).append(label);
            $(fieldSet).append(input);
        }
        $(dialog + " .inputField").append(fieldSet);
    }
}


function generateTable(dialog, dataJSON, columnsJSON, table, zeroRecordsMessage, displayLength, responsive, columnDefs, searchField) {
    if (columnsJSON) {
        var col = "";
        for (i = 0; i < columnsJSON.length; i++) {
            col = col + '<th>' + columnsJSON[i].name + '</th>';
        }
        $(dialog + ' #' + table + ' thead tr').html(col);

        createTableJson('#' + table, dataJSON, columnsJSON, displayLength, zeroRecordsMessage, columnDefs, responsive, null, searchField);
    } else {
        createTable('#' + table, null, zeroRecordsMessage, responsive, searchField);
    }
}

function generateUpperInputs(upperInputs, dialog) {
    var inputField = document.createElement('div');
    $(inputField).addClass('campSupUbi');
    for (i = 0; i < upperInputs.length; i++) {
        var fieldSet = document.createElement('div');
        var input = document.createElement('input');
        var label = document.createElement("label");
        if (upperInputs[i].type === "Button") {

            var btnClass = upperInputs[i].className ? upperInputs[i].className : "default";
            var button = document.createElement("button");
            $(fieldSet).addClass('fieldset col-xs-' + upperInputs[i].width);
            button.classList = "boton boton-" + btnClass;
            button.id = upperInputs[i].id;
            button.innerText = upperInputs[i].value;
            $(button).css("display", "block").css("width", "100%");
            //buttonString = buttonString + "<button class='boton boton-" + btnClass + " " + position + "' id='" + upperInputs[i].id + "'>" + upperInputs[i].value + "</button>";

            $(fieldSet).append(label);
            $(fieldSet).append(button);

        } else {
            var labelClass = "";
            if (upperInputs[i].className)
                if (upperInputs[i].className.indexOf('text-right') !== -1) {
                    labelClass = 'pull-right';
                }
            $(fieldSet).addClass('fieldset col-xs-' + upperInputs[i].width).prop('id', upperInputs[i].fieldId);
            $(label).addClass(labelClass).text(upperInputs[i].label);
            if (upperInputs[i].search) {
                var searchFieldDiv = document.createElement('div');
                $(searchFieldDiv).addClass('searchField');

                $(input).prop('id', upperInputs[i].id).addClass('form-control input-xs focusable ' + upperInputs[i].className);
                $(input).prop("disabled", upperInputs[i].disabled);

                $(searchFieldDiv).append(input);

                var searchButton = document.createElement('div');
                $(searchButton).addClass('rf-icon-button rf-buscador');


                var labelContainer = document.createElement("div");
                labelContainer.classList = "fillAvailable";
                $(labelContainer).append(label);
                $(fieldSet).append(labelContainer);

                $(fieldSet).append(searchFieldDiv);
                $(fieldSet).append(searchButton);
                if (upperInputs[i].descriptionField) {
                    var searchDescripFieldset = document.createElement('div');
                    $(searchDescripFieldset).addClass('col-xs-12');
                    var descrInput = document.createElement('input');
                    $(descrInput).addClass("form-control input-sm input-xs");
                    $(descrInput).prop('disabled', 'disabled');
                    $(descrInput).prop('id', upperInputs[i].descriptionField);

                    $(searchDescripFieldset).append(descrInput);
                    $(fieldSet).append(searchDescripFieldset);
                }

                addEvent(input, 'change', upperInputs[i].validationFunction);
                addEvent(searchButton, 'click', upperInputs[i].searchButtonFunction);

            } else {
                $(input).prop('id', upperInputs[i].id).addClass('form-control input-xs focusable ' + upperInputs[i].className).val(upperInputs[i].value);
                $(input).prop("disabled", upperInputs[i].disabled);
                if (upperInputs[i].isNumeric) {
                    $(input).addClass('text-right');
                    $(input).prop('type', 'text');
                    $(input).on('change', function () { $(input).val(TryParseFloat($(input).val(), 0)); })
                    $(fieldSet).css("text-align", "right");
                }
                $(label).addClass(labelClass).text(upperInputs[i].label);
                $(fieldSet).append(label);
                $(fieldSet).append(input);
            }
        }

        $(inputField).append(fieldSet);
    }

    $(dialog + ' .lateralTable ').before(inputField);

    //var inputString = "<div class='campSupUbi'>";
    //var inputClass = 'form-control input-xs ';
    //for (i = 0; i < upperInputs.length; i++) {
    //    inputString = inputString +
    //        "<div class='fieldset col-xs-" + upperInputs[i].width + "' id='" + upperInputs[i].fieldId + "'> \
    //            <label>" + upperInputs[i].label + ":</label> \
    //            <input id='" + upperInputs[i].id + "' class='" + inputClass + upperInputs[i].className + "' value='" + upperInputs[i].value + "'> \
    //        </div>";
    //}
    //inputString = inputString  + '</div>';
    //$(dialog + ' .modal-bodyContainer').prepend(inputString);
}

function generateSingleButton(id, name, position, btnClass) {
    return { id: id, value: name, position: position, btnClass: btnClass };
}

function newDialogs(dialogs, dialog) {
    var dialogString = "";
    for (i = 0; i < dialogs.length; i++) {
        dialogString = dialogString + '<div class="modal fade" id="' + dialogs[i] + '" role="dialog"></div>';
    }
    $(dialog).append(dialogString);
}

function generateColumn(code, name, bVisible, bNumeric, sClass) {
    sClass = sClass || "";
    if (bNumeric) sClass += ' dt-right';
    bVisible = typeof bVisible === 'undefined' || bVisible === null || bVisible ? true : false;
    var data = { 'name': name, 'title': name, "bVisible": bVisible };
    if (code) {
        data.mDataProp = code;
    }
    if (sClass !== "") {
        data.sClass = sClass;
    }
    return data;
}

function generateMessage(message, dialog, table) {
    var v_message;
    if (table) {
        v_message = '<div id="lovMessage">\
                            <div>\
                                ' + message + '\
                            </div>\
                        </div>';
        $(dialog + ' .dataTables_scrollBody').addClass('messageTable');
        $(dialog + ' .modal-bodyContainer').prepend(v_message);
    } else {
        v_message = '<div id="lovMessage" style="height:1px;">\
                            <div style="max-height: unset; margin: 10px 0">\
                                ' + message + '\
                            </div>\
                        </div>';
        $(dialog + ' .modal-bodyContainer').prepend(v_message);
    }
}
/*!
 * Globalize
 *
 * http://github.com/jquery/globalize
 *
 * Copyright Software Freedom Conservancy, Inc.
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 */

(function (window, undefined) {

    var Globalize,
        // private variables
        regexHex,
        regexInfinity,
        regexParseFloat,
        regexTrim,
        // private JavaScript utility functions
        arrayIndexOf,
        endsWith,
        extend,
        isArray,
        isFunction,
        isObject,
        startsWith,
        trim,
        truncate,
        zeroPad,
        // private Globalization utility functions
        appendPreOrPostMatch,
        expandFormat,
        formatDate,
        formatNumber,
        getTokenRegExp,
        getEra,
        getEraYear,
        parseExact,
        parseNegativePattern;

    // Global variable (Globalize) or CommonJS module (globalize)
    Globalize = function (cultureSelector) {
        return new Globalize.prototype.init(cultureSelector);
    };

    if (typeof require !== "undefined" &&
        typeof exports !== "undefined" &&
        typeof module !== "undefined") {
        // Assume CommonJS
        module.exports = Globalize;
    } else {
        // Export as global variable
        window.Globalize = Globalize;
    }

    Globalize.cultures = {};

    Globalize.prototype = {
        constructor: Globalize,
        init: function (cultureSelector) {
            this.cultures = Globalize.cultures;
            this.cultureSelector = cultureSelector;

            return this;
        }
    };
    Globalize.prototype.init.prototype = Globalize.prototype;

    // 1. When defining a culture, all fields are required except the ones stated as optional.
    // 2. Each culture should have a ".calendars" object with at least one calendar named "standard"
    //    which serves as the default calendar in use by that culture.
    // 3. Each culture should have a ".calendar" object which is the current calendar being used,
    //    it may be dynamically changed at any time to one of the calendars in ".calendars".
    Globalize.cultures["default"] = {
        // A unique name for the culture in the form <language code>-<country/region code>
        name: "en",
        // the name of the culture in the english language
        englishName: "English",
        // the name of the culture in its own language
        nativeName: "English",
        // whether the culture uses right-to-left text
        isRTL: false,
        // "language" is used for so-called "specific" cultures.
        // For example, the culture "es-CL" means "Spanish, in Chili".
        // It represents the Spanish-speaking culture as it is in Chili,
        // which might have different formatting rules or even translations
        // than Spanish in Spain. A "neutral" culture is one that is not
        // specific to a region. For example, the culture "es" is the generic
        // Spanish culture, which may be a more generalized version of the language
        // that may or may not be what a specific culture expects.
        // For a specific culture like "es-CL", the "language" field refers to the
        // neutral, generic culture information for the language it is using.
        // This is not always a simple matter of the string before the dash.
        // For example, the "zh-Hans" culture is netural (Simplified Chinese).
        // And the "zh-SG" culture is Simplified Chinese in Singapore, whose lanugage
        // field is "zh-CHS", not "zh".
        // This field should be used to navigate from a specific culture to it's
        // more general, neutral culture. If a culture is already as general as it
        // can get, the language may refer to itself.
        language: "en",
        // numberFormat defines general number formatting rules, like the digits in
        // each grouping, the group separator, and how negative numbers are displayed.
        numberFormat: {
            // [negativePattern]
            // Note, numberFormat.pattern has no "positivePattern" unlike percent and currency,
            // but is still defined as an array for consistency with them.
            //   negativePattern: one of "(n)|-n|- n|n-|n -"
            pattern: ["-n"],
            // number of decimal places normally shown
            decimals: 2,
            // string that separates number groups, as in 1,000,000
            ",": ",",
            // string that separates a number from the fractional portion, as in 1.99
            ".": ".",
            // array of numbers indicating the size of each number group.
            // TODO: more detailed description and example
            groupSizes: [3],
            // symbol used for positive numbers
            "+": "+",
            // symbol used for negative numbers
            "-": "-",
            // symbol used for NaN (Not-A-Number)
            "NaN": "NaN",
            // symbol used for Negative Infinity
            negativeInfinity: "-Infinity",
            // symbol used for Positive Infinity
            positiveInfinity: "Infinity",
            percent: {
                // [negativePattern, positivePattern]
                //   negativePattern: one of "-n %|-n%|-%n|%-n|%n-|n-%|n%-|-% n|n %-|% n-|% -n|n- %"
                //   positivePattern: one of "n %|n%|%n|% n"
                pattern: ["-n %", "n %"],
                // number of decimal places normally shown
                decimals: 2,
                // array of numbers indicating the size of each number group.
                // TODO: more detailed description and example
                groupSizes: [3],
                // string that separates number groups, as in 1,000,000
                ",": ",",
                // string that separates a number from the fractional portion, as in 1.99
                ".": ".",
                // symbol used to represent a percentage
                symbol: "%"
            },
            currency: {
                // [negativePattern, positivePattern]
                //   negativePattern: one of "($n)|-$n|$-n|$n-|(n$)|-n$|n-$|n$-|-n $|-$ n|n $-|$ n-|$ -n|n- $|($ n)|(n $)"
                //   positivePattern: one of "$n|n$|$ n|n $"
                pattern: ["($n)", "$n"],
                // number of decimal places normally shown
                decimals: 2,
                // array of numbers indicating the size of each number group.
                // TODO: more detailed description and example
                groupSizes: [3],
                // string that separates number groups, as in 1,000,000
                ",": ",",
                // string that separates a number from the fractional portion, as in 1.99
                ".": ".",
                // symbol used to represent currency
                symbol: "$"
            }
        },
        // calendars defines all the possible calendars used by this culture.
        // There should be at least one defined with name "standard", and is the default
        // calendar used by the culture.
        // A calendar contains information about how dates are formatted, information about
        // the calendar's eras, a standard set of the date formats,
        // translations for day and month names, and if the calendar is not based on the Gregorian
        // calendar, conversion functions to and from the Gregorian calendar.
        calendars: {
            standard: {
                // name that identifies the type of calendar this is
                name: "Gregorian_USEnglish",
                // separator of parts of a date (e.g. "/" in 11/05/1955)
                "/": "/",
                // separator of parts of a time (e.g. ":" in 05:44 PM)
                ":": ":",
                // the first day of the week (0 = Sunday, 1 = Monday, etc)
                firstDay: 0,
                days: {
                    // full day names
                    names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                    // abbreviated day names
                    namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                    // shortest day names
                    namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
                },
                months: {
                    // full month names (13 months for lunar calendards -- 13th month should be "" if not lunar)
                    names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", ""],
                    // abbreviated month names
                    namesAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", ""]
                },
                // AM and PM designators in one of these forms:
                // The usual view, and the upper and lower case versions
                //   [ standard, lowercase, uppercase ]
                // The culture does not use AM or PM (likely all standard date formats use 24 hour time)
                //   null
                AM: ["AM", "am", "AM"],
                PM: ["PM", "pm", "PM"],
                eras: [
                    // eras in reverse chronological order.
                    // name: the name of the era in this culture (e.g. A.D., C.E.)
                    // start: when the era starts in ticks (gregorian, gmt), null if it is the earliest supported era.
                    // offset: offset in years from gregorian calendar
                    {
                        "name": "A.D.",
                        "start": null,
                        "offset": 0
                    }
                ],
                // when a two digit year is given, it will never be parsed as a four digit
                // year greater than this year (in the appropriate era for the culture)
                // Set it as a full year (e.g. 2029) or use an offset format starting from
                // the current year: "+19" would correspond to 2029 if the current year 2010.
                twoDigitYearMax: 2029,
                // set of predefined date and time patterns used by the culture
                // these represent the format someone in this culture would expect
                // to see given the portions of the date that are shown.
                patterns: {
                    // short date pattern
                    d: "M/d/yyyy",
                    // long date pattern
                    D: "dddd, MMMM dd, yyyy",
                    // short time pattern
                    t: "h:mm tt",
                    // long time pattern
                    T: "h:mm:ss tt",
                    // long date, short time pattern
                    f: "dddd, MMMM dd, yyyy h:mm tt",
                    // long date, long time pattern
                    F: "dddd, MMMM dd, yyyy h:mm:ss tt",
                    // month/day pattern
                    M: "MMMM dd",
                    // month/year pattern
                    Y: "yyyy MMMM",
                    // S is a sortable format that does not vary by culture
                    S: "yyyy\u0027-\u0027MM\u0027-\u0027dd\u0027T\u0027HH\u0027:\u0027mm\u0027:\u0027ss"
                }
                // optional fields for each calendar:
                /*
                monthsGenitive:
                    Same as months but used when the day preceeds the month.
                    Omit if the culture has no genitive distinction in month names.
                    For an explaination of genitive months, see http://blogs.msdn.com/michkap/archive/2004/12/25/332259.aspx
                convert:
                    Allows for the support of non-gregorian based calendars. This convert object is used to
                    to convert a date to and from a gregorian calendar date to handle parsing and formatting.
                    The two functions:
                        fromGregorian( date )
                            Given the date as a parameter, return an array with parts [ year, month, day ]
                            corresponding to the non-gregorian based year, month, and day for the calendar.
                        toGregorian( year, month, day )
                            Given the non-gregorian year, month, and day, return a new Date() object
                            set to the corresponding date in the gregorian calendar.
                */
            }
        },
        // For localized strings
        messages: {}
    };

    Globalize.cultures["default"].calendar = Globalize.cultures["default"].calendars.standard;

    Globalize.cultures.en = Globalize.cultures["default"];

    Globalize.cultureSelector = "en";

    //
    // private variables
    //

    regexHex = /^0x[a-f0-9]+$/i;
    regexInfinity = /^[+\-]?infinity$/i;
    regexParseFloat = /^[+\-]?\d*\.?\d*(e[+\-]?\d+)?$/;
    regexTrim = /^\s+|\s+$/g;

    //
    // private JavaScript utility functions
    //

    arrayIndexOf = function (array, item) {
        if (array.indexOf) {
            return array.indexOf(item);
        }
        for (var i = 0, length = array.length; i < length; i++) {
            if (array[i] === item) {
                return i;
            }
        }
        return -1;
    };

    endsWith = function (value, pattern) {
        return value.substr(value.length - pattern.length) === pattern;
    };

    extend = function () {
        var options, name, src, copy, copyIsArray, clone,
            target = arguments[0] || {},
            i = 1,
            length = arguments.length,
            deep = false;

        // Handle a deep copy situation
        if (typeof target === "boolean") {
            deep = target;
            target = arguments[1] || {};
            // skip the boolean and the target
            i = 2;
        }

        // Handle case when target is a string or something (possible in deep copy)
        if (typeof target !== "object" && !isFunction(target)) {
            target = {};
        }

        for (; i < length; i++) {
            // Only deal with non-null/undefined values
            if ((options = arguments[i]) != null) {
                // Extend the base object
                for (name in options) {
                    src = target[name];
                    copy = options[name];

                    // Prevent never-ending loop
                    if (target === copy) {
                        continue;
                    }

                    // Recurse if we're merging plain objects or arrays
                    if (deep && copy && (isObject(copy) || (copyIsArray = isArray(copy)))) {
                        if (copyIsArray) {
                            copyIsArray = false;
                            clone = src && isArray(src) ? src : [];

                        } else {
                            clone = src && isObject(src) ? src : {};
                        }

                        // Never move original objects, clone them
                        target[name] = extend(deep, clone, copy);

                        // Don't bring in undefined values
                    } else if (copy !== undefined) {
                        target[name] = copy;
                    }
                }
            }
        }

        // Return the modified object
        return target;
    };

    isArray = Array.isArray || function (obj) {
        return Object.prototype.toString.call(obj) === "[object Array]";
    };

    isFunction = function (obj) {
        return Object.prototype.toString.call(obj) === "[object Function]";
    };

    isObject = function (obj) {
        return Object.prototype.toString.call(obj) === "[object Object]";
    };

    startsWith = function (value, pattern) {
        return value.indexOf(pattern) === 0;
    };

    trim = function (value) {
        return (value + "").replace(regexTrim, "");
    };

    truncate = function (value) {
        if (isNaN(value)) {
            return NaN;
        }
        return Math[value < 0 ? "ceil" : "floor"](value);
    };

    zeroPad = function (str, count, left) {
        var l;
        for (l = str.length; l < count; l += 1) {
            str = (left ? ("0" + str) : (str + "0"));
        }
        return str;
    };

    //
    // private Globalization utility functions
    //

    appendPreOrPostMatch = function (preMatch, strings) {
        // appends pre- and post- token match strings while removing escaped characters.
        // Returns a single quote count which is used to determine if the token occurs
        // in a string literal.
        var quoteCount = 0,
            escaped = false;
        for (var i = 0, il = preMatch.length; i < il; i++) {
            var c = preMatch.charAt(i);
            switch (c) {
                case "\'":
                    if (escaped) {
                        strings.push("\'");
                    }
                    else {
                        quoteCount++;
                    }
                    escaped = false;
                    break;
                case "\\":
                    if (escaped) {
                        strings.push("\\");
                    }
                    escaped = !escaped;
                    break;
                default:
                    strings.push(c);
                    escaped = false;
                    break;
            }
        }
        return quoteCount;
    };

    expandFormat = function (cal, format) {
        // expands unspecified or single character date formats into the full pattern.
        format = format || "F";
        var pattern,
            patterns = cal.patterns,
            len = format.length;
        if (len === 1) {
            pattern = patterns[format];
            if (!pattern) {
                throw "Invalid date format string \'" + format + "\'.";
            }
            format = pattern;
        }
        else if (len === 2 && format.charAt(0) === "%") {
            // %X escape format -- intended as a custom format string that is only one character, not a built-in format.
            format = format.charAt(1);
        }
        return format;
    };

    formatDate = function (value, format, culture) {
        var cal = culture.calendar,
            convert = cal.convert,
            ret;

        if (!format || !format.length || format === "i") {
            if (culture && culture.name.length) {
                if (convert) {
                    // non-gregorian calendar, so we cannot use built-in toLocaleString()
                    ret = formatDate(value, cal.patterns.F, culture);
                }
                else {
                    var eraDate = new Date(value.getTime()),
                        era = getEra(value, cal.eras);
                    eraDate.setFullYear(getEraYear(value, cal, era));
                    ret = eraDate.toLocaleString();
                }
            }
            else {
                ret = value.toString();
            }
            return ret;
        }

        var eras = cal.eras,
            sortable = format === "s";
        format = expandFormat(cal, format);

        // Start with an empty string
        ret = [];
        var hour,
            zeros = ["0", "00", "000"],
            foundDay,
            checkedDay,
            dayPartRegExp = /([^d]|^)(d|dd)([^d]|$)/g,
            quoteCount = 0,
            tokenRegExp = getTokenRegExp(),
            converted;

        function padZeros(num, c) {
            var r, s = num + "";
            if (c > 1 && s.length < c) {
                r = (zeros[c - 2] + s);
                return r.substr(r.length - c, c);
            }
            else {
                r = s;
            }
            return r;
        }

        function hasDay() {
            if (foundDay || checkedDay) {
                return foundDay;
            }
            foundDay = dayPartRegExp.test(format);
            checkedDay = true;
            return foundDay;
        }

        function getPart(date, part) {
            if (converted) {
                return converted[part];
            }
            switch (part) {
                case 0:
                    return date.getFullYear();
                case 1:
                    return date.getMonth();
                case 2:
                    return date.getDate();
                default:
                    throw "Invalid part value " + part;
            }
        }

        if (!sortable && convert) {
            converted = convert.fromGregorian(value);
        }

        for (; ;) {
            // Save the current index
            var index = tokenRegExp.lastIndex,
                // Look for the next pattern
                ar = tokenRegExp.exec(format);

            // Append the text before the pattern (or the end of the string if not found)
            var preMatch = format.slice(index, ar ? ar.index : format.length);
            quoteCount += appendPreOrPostMatch(preMatch, ret);

            if (!ar) {
                break;
            }

            // do not replace any matches that occur inside a string literal.
            if (quoteCount % 2) {
                ret.push(ar[0]);
                continue;
            }

            var current = ar[0],
                clength = current.length;

            switch (current) {
                case "ddd":
                //Day of the week, as a three-letter abbreviation
                case "dddd":
                    // Day of the week, using the full name
                    var names = (clength === 3) ? cal.days.namesAbbr : cal.days.names;
                    ret.push(names[value.getDay()]);
                    break;
                case "d":
                // Day of month, without leading zero for single-digit days
                case "dd":
                    // Day of month, with leading zero for single-digit days
                    foundDay = true;
                    ret.push(
                        padZeros(getPart(value, 2), clength)
                    );
                    break;
                case "MMM":
                // Month, as a three-letter abbreviation
                case "MMMM":
                    // Month, using the full name
                    var part = getPart(value, 1);
                    ret.push(
                        (cal.monthsGenitive && hasDay()) ?
                            (cal.monthsGenitive[clength === 3 ? "namesAbbr" : "names"][part]) :
                            (cal.months[clength === 3 ? "namesAbbr" : "names"][part])
                    );
                    break;
                case "M":
                // Month, as digits, with no leading zero for single-digit months
                case "MM":
                    // Month, as digits, with leading zero for single-digit months
                    ret.push(
                        padZeros(getPart(value, 1) + 1, clength)
                    );
                    break;
                case "y":
                // Year, as two digits, but with no leading zero for years less than 10
                case "yy":
                // Year, as two digits, with leading zero for years less than 10
                case "yyyy":
                    // Year represented by four full digits
                    part = converted ? converted[0] : getEraYear(value, cal, getEra(value, eras), sortable);
                    if (clength < 4) {
                        part = part % 100;
                    }
                    ret.push(
                        padZeros(part, clength)
                    );
                    break;
                case "h":
                // Hours with no leading zero for single-digit hours, using 12-hour clock
                case "hh":
                    // Hours with leading zero for single-digit hours, using 12-hour clock
                    hour = value.getHours() % 12;
                    if (hour === 0) hour = 12;
                    ret.push(
                        padZeros(hour, clength)
                    );
                    break;
                case "H":
                // Hours with no leading zero for single-digit hours, using 24-hour clock
                case "HH":
                    // Hours with leading zero for single-digit hours, using 24-hour clock
                    ret.push(
                        padZeros(value.getHours(), clength)
                    );
                    break;
                case "m":
                // Minutes with no leading zero for single-digit minutes
                case "mm":
                    // Minutes with leading zero for single-digit minutes
                    ret.push(
                        padZeros(value.getMinutes(), clength)
                    );
                    break;
                case "s":
                // Seconds with no leading zero for single-digit seconds
                case "ss":
                    // Seconds with leading zero for single-digit seconds
                    ret.push(
                        padZeros(value.getSeconds(), clength)
                    );
                    break;
                case "t":
                // One character am/pm indicator ("a" or "p")
                case "tt":
                    // Multicharacter am/pm indicator
                    part = value.getHours() < 12 ? (cal.AM ? cal.AM[0] : " ") : (cal.PM ? cal.PM[0] : " ");
                    ret.push(clength === 1 ? part.charAt(0) : part);
                    break;
                case "f":
                // Deciseconds
                case "ff":
                // Centiseconds
                case "fff":
                    // Milliseconds
                    ret.push(
                        padZeros(value.getMilliseconds(), 3).substr(0, clength)
                    );
                    break;
                case "z":
                // Time zone offset, no leading zero
                case "zz":
                    // Time zone offset with leading zero
                    hour = value.getTimezoneOffset() / 60;
                    ret.push(
                        (hour <= 0 ? "+" : "-") + padZeros(Math.floor(Math.abs(hour)), clength)
                    );
                    break;
                case "zzz":
                    // Time zone offset with leading zero
                    hour = value.getTimezoneOffset() / 60;
                    ret.push(
                        (hour <= 0 ? "+" : "-") + padZeros(Math.floor(Math.abs(hour)), 2) +
                        // Hard coded ":" separator, rather than using cal.TimeSeparator
                        // Repeated here for consistency, plus ":" was already assumed in date parsing.
                        ":" + padZeros(Math.abs(value.getTimezoneOffset() % 60), 2)
                    );
                    break;
                case "g":
                case "gg":
                    if (cal.eras) {
                        ret.push(
                            cal.eras[getEra(value, eras)].name
                        );
                    }
                    break;
                case "/":
                    ret.push(cal["/"]);
                    break;
                default:
                    throw "Invalid date format pattern \'" + current + "\'.";
            }
        }
        return ret.join("");
    };

    // formatNumber
    (function () {
        var expandNumber;

        expandNumber = function (number, precision, formatInfo) {
            var groupSizes = formatInfo.groupSizes,
                curSize = groupSizes[0],
                curGroupIndex = 1,
                factor = Math.pow(10, precision),
                rounded = Math.round(number * factor) / factor;

            if (!isFinite(rounded)) {
                rounded = number;
            }
            number = rounded;

            var numberString = number + "",
                right = "",
                split = numberString.split(/e/i),
                exponent = split.length > 1 ? parseInt(split[1], 10) : 0;
            numberString = split[0];
            split = numberString.split(".");
            numberString = split[0];
            right = split.length > 1 ? split[1] : "";

            if (exponent > 0) {
                right = zeroPad(right, exponent, false);
                numberString += right.slice(0, exponent);
                right = right.substr(exponent);
            }
            else if (exponent < 0) {
                exponent = -exponent;
                numberString = zeroPad(numberString, exponent + 1, true);
                right = numberString.slice(-exponent, numberString.length) + right;
                numberString = numberString.slice(0, -exponent);
            }

            if (precision > 0) {
                right = formatInfo["."] +
                    ((right.length > precision) ? right.slice(0, precision) : zeroPad(right, precision));
            }
            else {
                right = "";
            }

            var stringIndex = numberString.length - 1,
                sep = formatInfo[","],
                ret = "";

            while (stringIndex >= 0) {
                if (curSize === 0 || curSize > stringIndex) {
                    return numberString.slice(0, stringIndex + 1) + (ret.length ? (sep + ret + right) : right);
                }
                ret = numberString.slice(stringIndex - curSize + 1, stringIndex + 1) + (ret.length ? (sep + ret) : "");

                stringIndex -= curSize;

                if (curGroupIndex < groupSizes.length) {
                    curSize = groupSizes[curGroupIndex];
                    curGroupIndex++;
                }
            }

            return numberString.slice(0, stringIndex + 1) + sep + ret + right;
        };

        formatNumber = function (value, format, culture) {
            if (!isFinite(value)) {
                if (value === Infinity) {
                    return culture.numberFormat.positiveInfinity;
                }
                if (value === -Infinity) {
                    return culture.numberFormat.negativeInfinity;
                }
                return culture.numberFormat.NaN;
            }
            if (!format || format === "i") {
                return culture.name.length ? value.toLocaleString() : value.toString();
            }
            format = format || "D";

            var nf = culture.numberFormat,
                number = Math.abs(value),
                precision = -1,
                pattern;
            if (format.length > 1) precision = parseInt(format.slice(1), 10);

            var current = format.charAt(0).toUpperCase(),
                formatInfo;

            switch (current) {
                case "D":
                    pattern = "n";
                    number = truncate(number);
                    if (precision !== -1) {
                        number = zeroPad("" + number, precision, true);
                    }
                    if (value < 0) number = "-" + number;
                    break;
                case "N":
                    formatInfo = nf;
                /* falls through */
                case "C":
                    formatInfo = formatInfo || nf.currency;
                /* falls through */
                case "P":
                    formatInfo = formatInfo || nf.percent;
                    pattern = value < 0 ? formatInfo.pattern[0] : (formatInfo.pattern[1] || "n");
                    if (precision === -1) precision = formatInfo.decimals;
                    number = expandNumber(number * (current === "P" ? 100 : 1), precision, formatInfo);
                    break;
                default:
                    throw "Bad number format specifier: " + current;
            }

            var patternParts = /n|\$|-|%/g,
                ret = "";
            for (; ;) {
                var index = patternParts.lastIndex,
                    ar = patternParts.exec(pattern);

                ret += pattern.slice(index, ar ? ar.index : pattern.length);

                if (!ar) {
                    break;
                }

                switch (ar[0]) {
                    case "n":
                        ret += number;
                        break;
                    case "$":
                        ret += nf.currency.symbol;
                        break;
                    case "-":
                        // don't make 0 negative
                        if (/[1-9]/.test(number)) {
                            ret += nf["-"];
                        }
                        break;
                    case "%":
                        ret += nf.percent.symbol;
                        break;
                }
            }

            return ret;
        };

    }());

    getTokenRegExp = function () {
        // regular expression for matching date and time tokens in format strings.
        return (/\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g);
    };

    getEra = function (date, eras) {
        if (!eras) return 0;
        var start, ticks = date.getTime();
        for (var i = 0, l = eras.length; i < l; i++) {
            start = eras[i].start;
            if (start === null || ticks >= start) {
                return i;
            }
        }
        return 0;
    };

    getEraYear = function (date, cal, era, sortable) {
        var year = date.getFullYear();
        if (!sortable && cal.eras) {
            // convert normal gregorian year to era-shifted gregorian
            // year by subtracting the era offset
            year -= cal.eras[era].offset;
        }
        return year;
    };

    // parseExact
    (function () {
        var expandYear,
            getDayIndex,
            getMonthIndex,
            getParseRegExp,
            outOfRange,
            toUpper,
            toUpperArray;

        expandYear = function (cal, year) {
            // expands 2-digit year into 4 digits.
            if (year < 100) {
                var now = new Date(),
                    era = getEra(now),
                    curr = getEraYear(now, cal, era),
                    twoDigitYearMax = cal.twoDigitYearMax;
                twoDigitYearMax = typeof twoDigitYearMax === "string" ? new Date().getFullYear() % 100 + parseInt(twoDigitYearMax, 10) : twoDigitYearMax;
                year += curr - (curr % 100);
                if (year > twoDigitYearMax) {
                    year -= 100;
                }
            }
            return year;
        };

        getDayIndex = function (cal, value, abbr) {
            var ret,
                days = cal.days,
                upperDays = cal._upperDays;
            if (!upperDays) {
                cal._upperDays = upperDays = [
                    toUpperArray(days.names),
                    toUpperArray(days.namesAbbr),
                    toUpperArray(days.namesShort)
                ];
            }
            value = toUpper(value);
            if (abbr) {
                ret = arrayIndexOf(upperDays[1], value);
                if (ret === -1) {
                    ret = arrayIndexOf(upperDays[2], value);
                }
            }
            else {
                ret = arrayIndexOf(upperDays[0], value);
            }
            return ret;
        };

        getMonthIndex = function (cal, value, abbr) {
            var months = cal.months,
                monthsGen = cal.monthsGenitive || cal.months,
                upperMonths = cal._upperMonths,
                upperMonthsGen = cal._upperMonthsGen;
            if (!upperMonths) {
                cal._upperMonths = upperMonths = [
                    toUpperArray(months.names),
                    toUpperArray(months.namesAbbr)
                ];
                cal._upperMonthsGen = upperMonthsGen = [
                    toUpperArray(monthsGen.names),
                    toUpperArray(monthsGen.namesAbbr)
                ];
            }
            value = toUpper(value);
            var i = arrayIndexOf(abbr ? upperMonths[1] : upperMonths[0], value);
            if (i < 0) {
                i = arrayIndexOf(abbr ? upperMonthsGen[1] : upperMonthsGen[0], value);
            }
            return i;
        };

        getParseRegExp = function (cal, format) {
            // converts a format string into a regular expression with groups that
            // can be used to extract date fields from a date string.
            // check for a cached parse regex.
            var re = cal._parseRegExp;
            if (!re) {
                cal._parseRegExp = re = {};
            }
            else {
                var reFormat = re[format];
                if (reFormat) {
                    return reFormat;
                }
            }

            // expand single digit formats, then escape regular expression characters.
            var expFormat = expandFormat(cal, format).replace(/([\^\$\.\*\+\?\|\[\]\(\)\{\}])/g, "\\\\$1"),
                regexp = ["^"],
                groups = [],
                index = 0,
                quoteCount = 0,
                tokenRegExp = getTokenRegExp(),
                match;

            // iterate through each date token found.
            while ((match = tokenRegExp.exec(expFormat)) !== null) {
                var preMatch = expFormat.slice(index, match.index);
                index = tokenRegExp.lastIndex;

                // don't replace any matches that occur inside a string literal.
                quoteCount += appendPreOrPostMatch(preMatch, regexp);
                if (quoteCount % 2) {
                    regexp.push(match[0]);
                    continue;
                }

                // add a regex group for the token.
                var m = match[0],
                    len = m.length,
                    add;
                switch (m) {
                    case "dddd": case "ddd":
                    case "MMMM": case "MMM":
                    case "gg": case "g":
                        add = "(\\D+)";
                        break;
                    case "tt": case "t":
                        add = "(\\D*)";
                        break;
                    case "yyyy":
                    case "fff":
                    case "ff":
                    case "f":
                        add = "(\\d{" + len + "})";
                        break;
                    case "dd": case "d":
                    case "MM": case "M":
                    case "yy": case "y":
                    case "HH": case "H":
                    case "hh": case "h":
                    case "mm": case "m":
                    case "ss": case "s":
                        add = "(\\d\\d?)";
                        break;
                    case "zzz":
                        add = "([+-]?\\d\\d?:\\d{2})";
                        break;
                    case "zz": case "z":
                        add = "([+-]?\\d\\d?)";
                        break;
                    case "/":
                        add = "(\\/)";
                        break;
                    default:
                        throw "Invalid date format pattern \'" + m + "\'.";
                }
                if (add) {
                    regexp.push(add);
                }
                groups.push(match[0]);
            }
            appendPreOrPostMatch(expFormat.slice(index), regexp);
            regexp.push("$");

            // allow whitespace to differ when matching formats.
            var regexpStr = regexp.join("").replace(/\s+/g, "\\s+"),
                parseRegExp = { "regExp": regexpStr, "groups": groups };

            // cache the regex for this format.
            return re[format] = parseRegExp;
        };

        outOfRange = function (value, low, high) {
            return value < low || value > high;
        };

        toUpper = function (value) {
            // "he-IL" has non-breaking space in weekday names.
            return value.split("\u00A0").join(" ").toUpperCase();
        };

        toUpperArray = function (arr) {
            var results = [];
            for (var i = 0, l = arr.length; i < l; i++) {
                results[i] = toUpper(arr[i]);
            }
            return results;
        };

        parseExact = function (value, format, culture) {
            // try to parse the date string by matching against the format string
            // while using the specified culture for date field names.
            value = trim(value);
            var cal = culture.calendar,
                // convert date formats into regular expressions with groupings.
                // use the regexp to determine the input format and extract the date fields.
                parseInfo = getParseRegExp(cal, format),
                match = new RegExp(parseInfo.regExp).exec(value);
            if (match === null) {
                return null;
            }
            // found a date format that matches the input.
            var groups = parseInfo.groups,
                era = null, year = null, month = null, date = null, weekDay = null,
                hour = 0, hourOffset, min = 0, sec = 0, msec = 0, tzMinOffset = null,
                pmHour = false;
            // iterate the format groups to extract and set the date fields.
            for (var j = 0, jl = groups.length; j < jl; j++) {
                var matchGroup = match[j + 1];
                if (matchGroup) {
                    var current = groups[j],
                        clength = current.length,
                        matchInt = parseInt(matchGroup, 10);
                    switch (current) {
                        case "dd": case "d":
                            // Day of month.
                            date = matchInt;
                            // check that date is generally in valid range, also checking overflow below.
                            if (outOfRange(date, 1, 31)) return null;
                            break;
                        case "MMM": case "MMMM":
                            month = getMonthIndex(cal, matchGroup, clength === 3);
                            if (outOfRange(month, 0, 11)) return null;
                            break;
                        case "M": case "MM":
                            // Month.
                            month = matchInt - 1;
                            if (outOfRange(month, 0, 11)) return null;
                            break;
                        case "y": case "yy":
                        case "yyyy":
                            year = clength < 4 ? expandYear(cal, matchInt) : matchInt;
                            if (outOfRange(year, 0, 9999)) return null;
                            break;
                        case "h": case "hh":
                            // Hours (12-hour clock).
                            hour = matchInt;
                            if (hour === 12) hour = 0;
                            if (outOfRange(hour, 0, 11)) return null;
                            break;
                        case "H": case "HH":
                            // Hours (24-hour clock).
                            hour = matchInt;
                            if (outOfRange(hour, 0, 23)) return null;
                            break;
                        case "m": case "mm":
                            // Minutes.
                            min = matchInt;
                            if (outOfRange(min, 0, 59)) return null;
                            break;
                        case "s": case "ss":
                            // Seconds.
                            sec = matchInt;
                            if (outOfRange(sec, 0, 59)) return null;
                            break;
                        case "tt": case "t":
                            // AM/PM designator.
                            // see if it is standard, upper, or lower case PM. If not, ensure it is at least one of
                            // the AM tokens. If not, fail the parse for this format.
                            pmHour = cal.PM && (matchGroup === cal.PM[0] || matchGroup === cal.PM[1] || matchGroup === cal.PM[2]);
                            if (
                                !pmHour && (
                                    !cal.AM || (matchGroup !== cal.AM[0] && matchGroup !== cal.AM[1] && matchGroup !== cal.AM[2])
                                )
                            ) return null;
                            break;
                        case "f":
                        // Deciseconds.
                        case "ff":
                        // Centiseconds.
                        case "fff":
                            // Milliseconds.
                            msec = matchInt * Math.pow(10, 3 - clength);
                            if (outOfRange(msec, 0, 999)) return null;
                            break;
                        case "ddd":
                        // Day of week.
                        case "dddd":
                            // Day of week.
                            weekDay = getDayIndex(cal, matchGroup, clength === 3);
                            if (outOfRange(weekDay, 0, 6)) return null;
                            break;
                        case "zzz":
                            // Time zone offset in +/- hours:min.
                            var offsets = matchGroup.split(/:/);
                            if (offsets.length !== 2) return null;
                            hourOffset = parseInt(offsets[0], 10);
                            if (outOfRange(hourOffset, -12, 13)) return null;
                            var minOffset = parseInt(offsets[1], 10);
                            if (outOfRange(minOffset, 0, 59)) return null;
                            tzMinOffset = (hourOffset * 60) + (startsWith(matchGroup, "-") ? -minOffset : minOffset);
                            break;
                        case "z": case "zz":
                            // Time zone offset in +/- hours.
                            hourOffset = matchInt;
                            if (outOfRange(hourOffset, -12, 13)) return null;
                            tzMinOffset = hourOffset * 60;
                            break;
                        case "g": case "gg":
                            var eraName = matchGroup;
                            if (!eraName || !cal.eras) return null;
                            eraName = trim(eraName.toLowerCase());
                            for (var i = 0, l = cal.eras.length; i < l; i++) {
                                if (eraName === cal.eras[i].name.toLowerCase()) {
                                    era = i;
                                    break;
                                }
                            }
                            // could not find an era with that name
                            if (era === null) return null;
                            break;
                    }
                }
            }
            var result = new Date(), defaultYear, convert = cal.convert;
            defaultYear = convert ? convert.fromGregorian(result)[0] : result.getFullYear();
            if (year === null) {
                year = defaultYear;
            }
            else if (cal.eras) {
                // year must be shifted to normal gregorian year
                // but not if year was not specified, its already normal gregorian
                // per the main if clause above.
                year += cal.eras[(era || 0)].offset;
            }
            // set default day and month to 1 and January, so if unspecified, these are the defaults
            // instead of the current day/month.
            if (month === null) {
                month = 0;
            }
            if (date === null) {
                date = 1;
            }
            // now have year, month, and date, but in the culture's calendar.
            // convert to gregorian if necessary
            if (convert) {
                result = convert.toGregorian(year, month, date);
                // conversion failed, must be an invalid match
                if (result === null) return null;
            }
            else {
                // have to set year, month and date together to avoid overflow based on current date.
                result.setFullYear(year, month, date);
                // check to see if date overflowed for specified month (only checked 1-31 above).
                if (result.getDate() !== date) return null;
                // invalid day of week.
                if (weekDay !== null && result.getDay() !== weekDay) {
                    return null;
                }
            }
            // if pm designator token was found make sure the hours fit the 24-hour clock.
            if (pmHour && hour < 12) {
                hour += 12;
            }
            result.setHours(hour, min, sec, msec);
            if (tzMinOffset !== null) {
                // adjust timezone to utc before applying local offset.
                var adjustedMin = result.getMinutes() - (tzMinOffset + result.getTimezoneOffset());
                // Safari limits hours and minutes to the range of -127 to 127.  We need to use setHours
                // to ensure both these fields will not exceed this range.	adjustedMin will range
                // somewhere between -1440 and 1500, so we only need to split this into hours.
                result.setHours(result.getHours() + parseInt(adjustedMin / 60, 10), adjustedMin % 60);
            }
            return result;
        };
    }());

    parseNegativePattern = function (value, nf, negativePattern) {
        var neg = nf["-"],
            pos = nf["+"],
            ret;
        switch (negativePattern) {
            case "n -":
                neg = " " + neg;
                pos = " " + pos;
            /* falls through */
            case "n-":
                if (endsWith(value, neg)) {
                    ret = ["-", value.substr(0, value.length - neg.length)];
                }
                else if (endsWith(value, pos)) {
                    ret = ["+", value.substr(0, value.length - pos.length)];
                }
                break;
            case "- n":
                neg += " ";
                pos += " ";
            /* falls through */
            case "-n":
                if (startsWith(value, neg)) {
                    ret = ["-", value.substr(neg.length)];
                }
                else if (startsWith(value, pos)) {
                    ret = ["+", value.substr(pos.length)];
                }
                break;
            case "(n)":
                if (startsWith(value, "(") && endsWith(value, ")")) {
                    ret = ["-", value.substr(1, value.length - 2)];
                }
                break;
        }
        return ret || ["", value];
    };

    //
    // public instance functions
    //

    Globalize.prototype.findClosestCulture = function (cultureSelector) {
        return Globalize.findClosestCulture.call(this, cultureSelector);
    };

    Globalize.prototype.format = function (value, format, cultureSelector) {
        return Globalize.format.call(this, value, format, cultureSelector);
    };

    Globalize.prototype.localize = function (key, cultureSelector) {
        return Globalize.localize.call(this, key, cultureSelector);
    };

    Globalize.prototype.parseInt = function (value, radix, cultureSelector) {
        return Globalize.parseInt.call(this, value, radix, cultureSelector);
    };

    Globalize.prototype.parseFloat = function (value, radix, cultureSelector) {
        return Globalize.parseFloat.call(this, value, radix, cultureSelector);
    };

    Globalize.prototype.culture = function (cultureSelector) {
        return Globalize.culture.call(this, cultureSelector);
    };

    //
    // public singleton functions
    //

    Globalize.addCultureInfo = function (cultureName, baseCultureName, info) {

        var base = {},
            isNew = false;

        if (typeof cultureName !== "string") {
            // cultureName argument is optional string. If not specified, assume info is first
            // and only argument. Specified info deep-extends current culture.
            info = cultureName;
            cultureName = this.culture().name;
            base = this.cultures[cultureName];
        } else if (typeof baseCultureName !== "string") {
            // baseCultureName argument is optional string. If not specified, assume info is second
            // argument. Specified info deep-extends specified culture.
            // If specified culture does not exist, create by deep-extending default
            info = baseCultureName;
            isNew = (this.cultures[cultureName] == null);
            base = this.cultures[cultureName] || this.cultures["default"];
        } else {
            // cultureName and baseCultureName specified. Assume a new culture is being created
            // by deep-extending an specified base culture
            isNew = true;
            base = this.cultures[baseCultureName];
        }

        this.cultures[cultureName] = extend(true, {},
            base,
            info
        );
        // Make the standard calendar the current culture if it's a new culture
        if (isNew) {
            this.cultures[cultureName].calendar = this.cultures[cultureName].calendars.standard;
        }
    };

    Globalize.findClosestCulture = function (name) {
        var match;
        if (!name) {
            return this.findClosestCulture(this.cultureSelector) || this.cultures["default"];
        }
        if (typeof name === "string") {
            name = name.split(",");
        }
        if (isArray(name)) {
            var lang,
                cultures = this.cultures,
                list = name,
                i, l = list.length,
                prioritized = [];
            for (i = 0; i < l; i++) {
                name = trim(list[i]);
                var pri, parts = name.split(";");
                lang = trim(parts[0]);
                if (parts.length === 1) {
                    pri = 1;
                }
                else {
                    name = trim(parts[1]);
                    if (name.indexOf("q=") === 0) {
                        name = name.substr(2);
                        pri = parseFloat(name);
                        pri = isNaN(pri) ? 0 : pri;
                    }
                    else {
                        pri = 1;
                    }
                }
                prioritized.push({ lang: lang, pri: pri });
            }
            prioritized.sort(function (a, b) {
                if (a.pri < b.pri) {
                    return 1;
                } else if (a.pri > b.pri) {
                    return -1;
                }
                return 0;
            });
            // exact match
            for (i = 0; i < l; i++) {
                lang = prioritized[i].lang;
                match = cultures[lang];
                if (match) {
                    return match;
                }
            }

            // neutral language match
            for (i = 0; i < l; i++) {
                lang = prioritized[i].lang;
                do {
                    var index = lang.lastIndexOf("-");
                    if (index === -1) {
                        break;
                    }
                    // strip off the last part. e.g. en-US => en
                    lang = lang.substr(0, index);
                    match = cultures[lang];
                    if (match) {
                        return match;
                    }
                }
                while (1);
            }

            // last resort: match first culture using that language
            for (i = 0; i < l; i++) {
                lang = prioritized[i].lang;
                for (var cultureKey in cultures) {
                    var culture = cultures[cultureKey];
                    if (culture.language === lang) {
                        return culture;
                    }
                }
            }
        }
        else if (typeof name === "object") {
            return name;
        }
        return match || null;
    };

    Globalize.format = function (value, format, cultureSelector) {
        var culture = this.findClosestCulture(cultureSelector);
        if (value instanceof Date) {
            value = formatDate(value, format, culture);
        }
        else if (typeof value === "number") {
            value = formatNumber(value, format, culture);
        }
        return value;
    };

    Globalize.localize = function (key, cultureSelector) {
        return this.findClosestCulture(cultureSelector).messages[key] ||
            this.cultures["default"].messages[key];
    };

    Globalize.parseDate = function (value, formats, culture) {
        culture = this.findClosestCulture(culture);

        var date, prop, patterns;
        if (formats) {
            if (typeof formats === "string") {
                formats = [formats];
            }
            if (formats.length) {
                for (var i = 0, l = formats.length; i < l; i++) {
                    var format = formats[i];
                    if (format) {
                        date = parseExact(value, format, culture);
                        if (date) {
                            break;
                        }
                    }
                }
            }
        } else {
            patterns = culture.calendar.patterns;
            for (prop in patterns) {
                date = parseExact(value, patterns[prop], culture);
                if (date) {
                    break;
                }
            }
        }

        return date || null;
    };

    Globalize.parseInt = function (value, radix, cultureSelector) {
        return truncate(Globalize.parseFloat(value, radix, cultureSelector));
    };

    Globalize.parseFloat = function (value, radix, cultureSelector) {
        // radix argument is optional
        if (typeof radix !== "number") {
            cultureSelector = radix;
            radix = 10;
        }

        var culture = this.findClosestCulture(cultureSelector);
        var ret = NaN,
            nf = culture.numberFormat;

        if (value.indexOf(culture.numberFormat.currency.symbol) > -1) {
            // remove currency symbol
            value = value.replace(culture.numberFormat.currency.symbol, "");
            // replace decimal seperator
            value = value.replace(culture.numberFormat.currency["."], culture.numberFormat["."]);
        }

        //Remove percentage character from number string before parsing
        if (value.indexOf(culture.numberFormat.percent.symbol) > -1) {
            value = value.replace(culture.numberFormat.percent.symbol, "");
        }

        // remove spaces: leading, trailing and between - and number. Used for negative currency pt-BR
        value = value.replace(/ /g, "");

        // allow infinity or hexidecimal
        if (regexInfinity.test(value)) {
            ret = parseFloat(value);
        }
        else if (!radix && regexHex.test(value)) {
            ret = parseInt(value, 16);
        }
        else {

            // determine sign and number
            var signInfo = parseNegativePattern(value, nf, nf.pattern[0]),
                sign = signInfo[0],
                num = signInfo[1];

            // #44 - try parsing as "(n)"
            if (sign === "" && nf.pattern[0] !== "(n)") {
                signInfo = parseNegativePattern(value, nf, "(n)");
                sign = signInfo[0];
                num = signInfo[1];
            }

            // try parsing as "-n"
            if (sign === "" && nf.pattern[0] !== "-n") {
                signInfo = parseNegativePattern(value, nf, "-n");
                sign = signInfo[0];
                num = signInfo[1];
            }

            sign = sign || "+";

            // determine exponent and number
            var exponent,
                intAndFraction,
                exponentPos = num.indexOf("e");
            if (exponentPos < 0) exponentPos = num.indexOf("E");
            if (exponentPos < 0) {
                intAndFraction = num;
                exponent = null;
            }
            else {
                intAndFraction = num.substr(0, exponentPos);
                exponent = num.substr(exponentPos + 1);
            }
            // determine decimal position
            var integer,
                fraction,
                decSep = nf["."],
                decimalPos = intAndFraction.indexOf(decSep);
            if (decimalPos < 0) {
                integer = intAndFraction;
                fraction = null;
            }
            else {
                integer = intAndFraction.substr(0, decimalPos);
                fraction = intAndFraction.substr(decimalPos + decSep.length);
            }
            // handle groups (e.g. 1,000,000)
            var groupSep = nf[","];
            integer = integer.split(groupSep).join("");
            var altGroupSep = groupSep.replace(/\u00A0/g, " ");
            if (groupSep !== altGroupSep) {
                integer = integer.split(altGroupSep).join("");
            }
            // build a natively parsable number string
            var p = sign + integer;
            if (fraction !== null) {
                p += "." + fraction;
            }
            if (exponent !== null) {
                // exponent itself may have a number patternd
                var expSignInfo = parseNegativePattern(exponent, nf, "-n");
                p += "e" + (expSignInfo[0] || "+") + expSignInfo[1];
            }
            if (regexParseFloat.test(p)) {
                ret = parseFloat(p);
            }
        }
        return ret;
    };

    Globalize.culture = function (cultureSelector) {
        // setter
        if (typeof cultureSelector !== "undefined") {
            this.cultureSelector = cultureSelector;
        }
        // getter
        return this.findClosestCulture(cultureSelector) || this.cultures["default"];
    };

}(this));

/*
 * Globalize Culture es-ES
 *
 * http://github.com/jquery/globalize
 *
 * Copyright Software Freedom Conservancy, Inc.
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * This file was generated by the Globalize Culture Generator
 * Translation: bugs found in this file need to be fixed in the generator
 */

(function (window, undefined) {

    var Globalize;

    if (typeof require !== "undefined" &&
        typeof exports !== "undefined" &&
        typeof module !== "undefined") {
        // Assume CommonJS
        Globalize = require("globalize");
    } else {
        // Global variable
        Globalize = window.Globalize;
    }

    Globalize.addCultureInfo("es-ES", "default", {
        name: "es-ES",
        englishName: "Spanish (Spain, International Sort)",
        nativeName: "Español (España, alfabetización internacional)",
        language: "es",
        numberFormat: {
            ",": ".",
            ".": ",",
            "NaN": "NeuN",
            negativeInfinity: "-Infinito",
            positiveInfinity: "Infinito",
            percent: {
                ",": ".",
                ".": ","
            },
            currency: {
                pattern: ["-n $", "n $"],
                ",": ".",
                ".": ",",
                symbol: "€"
            }
        },
        calendars: {
            standard: {
                firstDay: 1,
                days: {
                    names: ["domingo", "lunes", "martes", "miércoles", "jueves", "viernes", "sábado"],
                    namesAbbr: ["dom", "lun", "mar", "mié", "jue", "vie", "sáb"],
                    namesShort: ["do", "lu", "ma", "mi", "ju", "vi", "sá"]
                },
                months: {
                    names: ["enero", "febrero", "marzo", "abril", "mayo", "junio", "julio", "agosto", "septiembre", "octubre", "noviembre", "diciembre", ""],
                    namesAbbr: ["ene", "feb", "mar", "abr", "may", "jun", "jul", "ago", "sep", "oct", "nov", "dic", ""]
                },
                AM: null,
                PM: null,
                eras: [{ "name": "d.C.", "start": null, "offset": 0 }],
                patterns: {
                    d: "dd/MM/yyyy",
                    D: "dddd, dd' de 'MMMM' de 'yyyy",
                    t: "H:mm",
                    T: "H:mm:ss",
                    f: "dddd, dd' de 'MMMM' de 'yyyy H:mm",
                    F: "dddd, dd' de 'MMMM' de 'yyyy H:mm:ss",
                    M: "dd MMMM",
                    Y: "MMMM' de 'yyyy"
                }
            }
        }
    });

}(this));