/*!
 * Signature Pad v2.3.2
 * https://github.com/szimek/signature_pad
 *
 * Copyright 2017 Szymon Nowak
 * Released under the MIT license
 *
 * The main idea and some parts of the code (e.g. drawing variable width Bézier curve) are taken from:
 * http://corner.squareup.com/2012/07/smoother-signatures.html
 *
 * Implementation of interpolation using cubic Bézier curves is taken from:
 * http://benknowscode.wordpress.com/2012/09/14/path-interpolation-using-cubic-bezier-and-control-point-estimation-in-javascript
 *
 * Algorithm for approximated length of a Bézier curve is taken from:
 * http://www.lemoda.net/maths/bezier-length/index.html
 *
 */
function resizeCanvas(){var n=Math.max(window.devicePixelRatio||1,1);canvas.width=canvas.offsetWidth*n;canvas.height=canvas.offsetHeight*n;canvas.getContext("2d").scale(n,n);signaturePad.clear()}function getBase64(){if(signaturePad.isEmpty())lanzarMensaje(!1,"Por favor, firme antes de aceptar");else{var n=signaturePad.toDataURL();return n.split(";base64,")[1]}}function dataURLToBlob(n){for(var i=n.split(";base64,"),e=i[0].split(":")[1],r=window.atob(i[1]),u=r.length,f=new Uint8Array(u),t=0;t<u;++t)f[t]=r.charCodeAt(t);return new Blob([f],{type:e})}function clearCanvas(){signaturePad.clear()}(function(n,t){typeof exports=="object"&&typeof module!="undefined"?module.exports=t():typeof define=="function"&&define.amd?define(t):n.SignaturePad=t()})(this,function(){"use strict";function t(n,t,i){this.x=n;this.y=t;this.time=i||(new Date).getTime()}function i(n,t,i,r){this.startPoint=n;this.control1=t;this.control2=i;this.endPoint=r}function r(n,t,i){var u,f,o,r=null,e=0,s;return i||(i={}),s=function(){e=i.leading===!1?0:Date.now();r=null;o=n.apply(u,f);r||(u=f=null)},function(){var c=Date.now(),h;return e||i.leading!==!1||(e=c),h=t-(c-e),u=this,f=arguments,h<=0||h>t?(r&&(clearTimeout(r),r=null),e=c,o=n.apply(u,f),r||(u=f=null)):r||i.trailing===!1||(r=setTimeout(s,h)),o}}function n(t,i){var f=this,u=i||{};this.velocityFilterWeight=u.velocityFilterWeight||.7;this.minWidth=u.minWidth||.5;this.maxWidth=u.maxWidth||2.5;this.throttle="throttle"in u?u.throttle:16;this.minDistance="minDistance"in u?u.minDistance:5;this._strokeMoveUpdate=this.throttle?r(n.prototype._strokeUpdate,this.throttle):n.prototype._strokeUpdate;this.dotSize=u.dotSize||function(){return(this.minWidth+this.maxWidth)/2};this.penColor=u.penColor||"black";this.backgroundColor=u.backgroundColor||"rgba(0,0,0,0)";this.onBegin=u.onBegin;this.onEnd=u.onEnd;this._canvas=t;this._ctx=t.getContext("2d");this.clear();this._handleMouseDown=function(n){n.which===1&&(f._mouseButtonDown=!0,f._strokeBegin(n))};this._handleMouseMove=function(n){f._mouseButtonDown&&f._strokeMoveUpdate(n)};this._handleMouseUp=function(n){n.which===1&&f._mouseButtonDown&&(f._mouseButtonDown=!1,f._strokeEnd(n))};this._handleTouchStart=function(n){if(n.targetTouches.length===1){var t=n.changedTouches[0];f._strokeBegin(t)}};this._handleTouchMove=function(n){n.preventDefault();var t=n.targetTouches[0];f._strokeMoveUpdate(t)};this._handleTouchEnd=function(n){var t=n.target===f._canvas;t&&(n.preventDefault(),f._strokeEnd(n))};this.on()}return t.prototype.velocityFrom=function(n){return this.time!==n.time?this.distanceTo(n)/(this.time-n.time):1},t.prototype.distanceTo=function(n){return Math.sqrt(Math.pow(this.x-n.x,2)+Math.pow(this.y-n.y,2))},t.prototype.equals=function(n){return this.x===n.x&&this.y===n.y&&this.time===n.time},i.prototype.length=function(){for(var t,i,r=10,u=0,f=void 0,e=void 0,n=0;n<=r;n+=1){var o=n/r,s=this._point(o,this.startPoint.x,this.control1.x,this.control2.x,this.endPoint.x),h=this._point(o,this.startPoint.y,this.control1.y,this.control2.y,this.endPoint.y);n>0&&(t=s-f,i=h-e,u+=Math.sqrt(t*t+i*i));f=s;e=h}return u},i.prototype._point=function(n,t,i,r,u){return t*(1-n)*(1-n)*(1-n)+3*i*(1-n)*(1-n)*n+3*r*(1-n)*n*n+u*n*n*n},n.prototype.clear=function(){var t=this._ctx,n=this._canvas;t.fillStyle=this.backgroundColor;t.clearRect(0,0,n.width,n.height);t.fillRect(0,0,n.width,n.height);this._data=[];this._reset();this._isEmpty=!0},n.prototype.fromDataURL=function(n){var u=this,t=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{},i=new Image,r=t.ratio||window.devicePixelRatio||1,f=t.width||this._canvas.width/r,e=t.height||this._canvas.height/r;this._reset();i.src=n;i.onload=function(){u._ctx.drawImage(i,0,0,f,e)};this._isEmpty=!1},n.prototype.toDataURL=function(n){var r;switch(n){case"image/svg+xml":return this._toSVG();default:for(var i=arguments.length,u=Array(i>1?i-1:0),t=1;t<i;t++)u[t-1]=arguments[t];return(r=this._canvas).toDataURL.apply(r,[n].concat(u))}},n.prototype.on=function(){this._handleMouseEvents();this._handleTouchEvents()},n.prototype.off=function(){this._canvas.removeEventListener("mousedown",this._handleMouseDown);this._canvas.removeEventListener("mousemove",this._handleMouseMove);document.removeEventListener("mouseup",this._handleMouseUp);this._canvas.removeEventListener("touchstart",this._handleTouchStart);this._canvas.removeEventListener("touchmove",this._handleTouchMove);this._canvas.removeEventListener("touchend",this._handleTouchEnd)},n.prototype.isEmpty=function(){return this._isEmpty},n.prototype._strokeBegin=function(n){if(this._data.push([]),this._reset(),this._strokeUpdate(n),typeof this.onBegin=="function")this.onBegin(n)},n.prototype._strokeUpdate=function(n){var o=n.clientX,s=n.clientY,t=this._createPoint(o,s),i=this._data[this._data.length-1],r=i&&i[i.length-1],h=r&&t.distanceTo(r)<this.minDistance;if(!(r&&h)){var f=this._addPoint(t),e=f.curve,u=f.widths;e&&u&&this._drawCurve(e,u.start,u.end);this._data[this._data.length-1].push({x:t.x,y:t.y,time:t.time,color:this.penColor})}},n.prototype._strokeEnd=function(n){var u=this.points.length>2,t=this.points[0],i,r;if(!u&&t&&this._drawDot(t),t&&(i=this._data[this._data.length-1],r=i[i.length-1],t.equals(r)||i.push({x:t.x,y:t.y,time:t.time,color:this.penColor})),typeof this.onEnd=="function")this.onEnd(n)},n.prototype._handleMouseEvents=function(){this._mouseButtonDown=!1;this._canvas.addEventListener("mousedown",this._handleMouseDown);this._canvas.addEventListener("mousemove",this._handleMouseMove);document.addEventListener("mouseup",this._handleMouseUp)},n.prototype._handleTouchEvents=function(){this._canvas.style.msTouchAction="none";this._canvas.style.touchAction="none";this._canvas.addEventListener("touchstart",this._handleTouchStart);this._canvas.addEventListener("touchmove",this._handleTouchMove);this._canvas.addEventListener("touchend",this._handleTouchEnd)},n.prototype._reset=function(){this.points=[];this._lastVelocity=0;this._lastWidth=(this.minWidth+this.maxWidth)/2;this._ctx.fillStyle=this.penColor},n.prototype._createPoint=function(n,i,r){var u=this._canvas.getBoundingClientRect();return new t(n-u.left,i-u.top,r||(new Date).getTime())},n.prototype._addPoint=function(n){var t=this.points,r=void 0,u;if(t.push(n),t.length>2){t.length===3&&t.unshift(t[0]);r=this._calculateCurveControlPoints(t[0],t[1],t[2]);u=r.c2;r=this._calculateCurveControlPoints(t[1],t[2],t[3]);var e=r.c1,f=new i(t[1],u,e,t[2]),o=this._calculateCurveWidths(f);return t.shift(),{curve:f,widths:o}}return{}},n.prototype._calculateCurveControlPoints=function(n,i,r){var e=n.x-i.x,o=n.y-i.y,s=i.x-r.x,h=i.y-r.y,f={x:(n.x+i.x)/2,y:(n.y+i.y)/2},u={x:(i.x+r.x)/2,y:(i.y+r.y)/2},p=Math.sqrt(e*e+o*o),c=Math.sqrt(s*s+h*h),w=f.x-u.x,b=f.y-u.y,l=c/(p+c),a={x:u.x+w*l,y:u.y+b*l},v=i.x-a.x,y=i.y-a.y;return{c1:new t(f.x+v,f.y+y),c2:new t(u.x+v,u.y+y)}},n.prototype._calculateCurveWidths=function(n){var u=n.startPoint,f=n.endPoint,t={start:null,end:null},i=this.velocityFilterWeight*f.velocityFrom(u)+(1-this.velocityFilterWeight)*this._lastVelocity,r=this._strokeWidth(i);return t.start=this._lastWidth,t.end=r,this._lastVelocity=i,this._lastWidth=r,t},n.prototype._strokeWidth=function(n){return Math.max(this.maxWidth/(n+1),this.minWidth)},n.prototype._drawPoint=function(n,t,i){var r=this._ctx;r.moveTo(n,t);r.arc(n,t,i,0,2*Math.PI,!1);this._isEmpty=!1},n.prototype._drawCurve=function(n,t,i){var s=this._ctx,p=i-t,a=Math.floor(n.length()),e,f,y;for(s.beginPath(),e=0;e<a;e+=1){var r=e/a,h=r*r,c=h*r,u=1-r,l=u*u,v=l*u,o=v*n.startPoint.x;o+=3*l*r*n.control1.x;o+=3*u*h*n.control2.x;o+=c*n.endPoint.x;f=v*n.startPoint.y;f+=3*l*r*n.control1.y;f+=3*u*h*n.control2.y;f+=c*n.endPoint.y;y=t+c*p;this._drawPoint(o,f,y)}s.closePath();s.fill()},n.prototype._drawDot=function(n){var t=this._ctx,i=typeof this.dotSize=="function"?this.dotSize():this.dotSize;t.beginPath();this._drawPoint(n.x,n.y,i);t.closePath();t.fill()},n.prototype._fromData=function(n,i,r){for(var u,f,v,e=0;e<n.length;e+=1)if(u=n[e],u.length>1)for(f=0;f<u.length;f+=1){var o=u[f],s=new t(o.x,o.y,o.time),h=o.color;if(f===0)this.penColor=h,this._reset(),this._addPoint(s);else if(f!==u.length-1){var c=this._addPoint(s),l=c.curve,a=c.widths;l&&a&&i(l,a,h)}}else this._reset(),v=u[0],r(v)},n.prototype._toSVG=function(){var u=this,a=this._data,t=this._canvas,o=Math.max(window.devicePixelRatio||1,1),s=t.width/o,h=t.height/o,n=document.createElementNS("http://www.w3.org/2000/svg","svg"),i,e,r,c,l;n.setAttributeNS(null,"width",t.width);n.setAttributeNS(null,"height",t.height);this._fromData(a,function(t,i,r){var u=document.createElement("path"),f;isNaN(t.control1.x)||isNaN(t.control1.y)||isNaN(t.control2.x)||isNaN(t.control2.y)||(f="M "+t.startPoint.x.toFixed(3)+","+t.startPoint.y.toFixed(3)+" "+("C "+t.control1.x.toFixed(3)+","+t.control1.y.toFixed(3)+" ")+(t.control2.x.toFixed(3)+","+t.control2.y.toFixed(3)+" ")+(t.endPoint.x.toFixed(3)+","+t.endPoint.y.toFixed(3)),u.setAttribute("d",f),u.setAttribute("stroke-width",(i.end*2.25).toFixed(3)),u.setAttribute("stroke",r),u.setAttribute("fill","none"),u.setAttribute("stroke-linecap","round"),n.appendChild(u))},function(t){var i=document.createElement("circle"),r=typeof u.dotSize=="function"?u.dotSize():u.dotSize;i.setAttribute("r",r);i.setAttribute("cx",t.x);i.setAttribute("cy",t.y);i.setAttribute("fill",t.color);n.appendChild(i)});var v='<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"'+(' viewBox="0 0 '+s+" "+h+'"')+(' width="'+s+'"')+(' height="'+h+'"')+">",f=n.innerHTML;if(f===undefined){for(i=document.createElement("dummy"),e=n.childNodes,i.innerHTML="",r=0;r<e.length;r+=1)i.appendChild(e[r].cloneNode(!0));f=i.innerHTML}return c="<\/svg>",l=v+f+c,"data:image/svg+xml;base64,"+btoa(l)},n.prototype.fromData=function(n){var t=this;this.clear();this._fromData(n,function(n,i){return t._drawCurve(n,i.start,i.end)},function(n){return t._drawDot(n)});this._data=n},n.prototype.toData=function(){return this._data},n});var wrapper=document.getElementById("signature-pad"),clearButton=wrapper.querySelector("[data-action=clear]"),canvas=wrapper.querySelector("canvas"),signaturePad=new SignaturePad(canvas,{backgroundColor:"rgb(255, 255, 255)"});setTimeout(function(){resizeCanvas()},300);window.onresize=resizeCanvas;resizeCanvas();